// FILENAME:	DM_Faceball_Arena.cs
//
// AUTHORS:  	Gen. Powio [MIB]
//------------------------------------------------------------------------------

$missionName = "DM_Dookie_Land";
$sinkSpeed = 0.2;

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	temperateSounds();
}

function onMissionLoad()
{
   $healRate = 200;   
   $ammoRate = 1;
   $padWaitTime = 40;
   $zenWaitTime = 60;	
   cdAudioCycle("Mechsoul", "Watching", "NewTech", "SS3");
   setHUDMapViewOffSet(-8500,0);
}

function player::onAdd(%p)
{
   if(strAlign(1, left, getname(%p))=="/")
   {
      say(0,0,"<f4>"@getname(%p)@" joined the game with a slash","sfx_spot_locking.wav");
   }
   say(%p,0,"Welcome to DM_Dookie_Land! You can download this & other missions made by Gen. Powio [MIB] from the MIB Website at http://Starsiegemeninblack.cjb.net");
}

function player::onLeave(%p)
{
   if(strAlign(1, left, getname(%p))=="/")
   {
      say(0,0,"<f4>"@getname(%p)@" left the game with a slash","sfx_spot_locking.wav");
   }
}

function vehicle::onDestroyed(%d,%r)
{
   %p = playerManager::vehicleIdToPlayerNum(%d);
   vehicle::onDestroyedLog(%d,%r);
   %m=getFancyDeathMessage(getHUDName(%d),getHUDName(%r));
   if(%d.Bloop == True)
   {
      %r = randomInt(0,2);
      if(%r == 0)
      {
         say(0,%p,getHUDName(%d)@"<F2> thought a little sewage wouldn't hurt untill it ate them up.","sfx_lava.wav");
      }
      else if(%r == 1)
      {
         say(0,%p,getHUDName(%d)@"<F2> never thought that moldy stuff could be so deadly.","sfx_lava.wav");
      }
      else
      {
         say(0,%p,getHUDName(%d)@"<F2> slipped up and became another victim of that nasty looking stuff below.","sfx_lava.wav");
      }
   }
   else if(%m != "")
   {
      say( 0, 0, %m);
   }
   %Door = %p.Locking;
   %Door.Locked = "";
   %p.Locking = "";
}

function vehicle::onAdd(%v)
{
   %v.Bloop = "";
}

function Dookie::Trigger::onEnter(%t,%v)
{
   %p = playerManager::vehicleIdToPlayerNum(%v);
   playSound(%p,"sfx_swamp.wav",IDPRF_2D);
}

function Dookie::Trigger::onContact(%t,%v)
{
   %x = getPosition(%v,x) - $currentSpeed;
   %y = getPosition(%v,y);
   %z = getPosition(%v,z) - $sinkSpeed;
   setPosition(%v,%x,%y,%z);
}

function Dookie::Trigger::onLeave(%t,%v)
{
   %v.Bloop = True;
   playSound(%p,"sfx_lava.wav",IDPRF_2D);
   healObject(%v,-999999);
   echo(getHUDname(%v)@" has sunk.");
}

//------

function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $zenWaitTime, true); 
}

function Redropper::trigger::onEnter(%t,%v)
{
   reDrop(%v);
}