// FILENAME:    DM_Elements.cs
//
// AUTHOR:      Gen. Stormtrooper MIB
//--------------------------------------------------------------------------------

$missionName = "DM_ELEMENTS";

exec("multiplayerStdLib.cs");
exec("dmStdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = False;
	$server::AllowDeathmatch = True;
	$server::AllowTeamPlay = True;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionLoad()
{
   cdAudioCycle("Newtech", "Mechsoul", "Terror"); 
}

   setGameInfo("<F2><F5><<>GAME TYPE:<F0>  Starsiege: Elements\n\n<F2><F5><<>MISSION:<F0>  DM_Elements\n\n<F2><n><F5><<><F2>RULES:<F0><n><n><F0>There are 5 element powers: wind, fire, stone, water, and ice. To aquire an elements' power, you must search the land for the elements. There are two drone balls near each element, one is for the first element power, the other is for the second. By scanning these drone balls, yuo will aquire ceartain powers, for example: you could cmbine two elements, fire and rock, this would be the meteor power. Most powers can be used by scanning your target, others are automatic."); 

//-------------------------------------------------------------
function player::onAdd(%this)
{
   say(%this, 0, "Welcome to DM_Elements! You can download this & other missions made by <F1>Gen. Stormtrooper MIB <F0>in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.<n><F5><<> <F1>Be Sure To READ THE RULES! <F5><<>");
}

function onMissionStart()
{
	desertSounds();
}

function vehicle::onAdd(%this)
{
   %this.second = "none";
   %this.first = "none";
}

////////////=====================now, the powers's functions
function meteor(%r, %d)
{
	if((%d.first != "ice") && (%d.second != "ice") && (%d.first != "water") && (%d.second != "water"))
	{
	   %x1 = getPosition(%r, x);
	   %y1 = getPosition(%r, y);
	   %z1 = getPosition(%r, z) + 5;
	   %x2 = getPosition(%d, x);
	   %y2 = getPosition(%d, y);
	   %z2 = getPosition(%d, z) + 5;
	   %time = (getDistance(%d, %r) / 400);
	   dropPod(%x1, %y1, %z1, %x2, %y2, %z2);
	   schedule("damageArea(%d, 0, 0, 0, 25, 2000);", %time );
	}
}

function fire(%r, %d)
{

	if((%d.first != "ice") && (%d.second != "ice") && (%d.first != "water") && (%d.second != "water"))
	{
	   %m = playerManager::vehicleIdToPlayerNum(%d);
	   fadeevent(%m, in, 5, 1.0, 0.8, 0);
	   heaObject(%d, -2000);
	}
}

function blizzard(%r, %d)
{
   snow(5, 5, 0);
   snow(5, 0, 5);
   snow(5, 5, 0);
   snow(5, 0, 5);
   schedule("healobject(%d, -2000);", 1 );
   schedule("snow(0, 0, 0);", 1.5 );
}

function firestorm(%r, %d)
{
	if((%d.first != "ice") && (%d.second != "ice") && (%d.first != "water") && (%d.second != "water"))
	{
	   %x = getposition(%r, x);
	   %y = getposition(%r ,y);
	   %z = getposition(%r, z);
	   dropboom(%x ,%y ,%z + 10, %x ,%y + 200, %z, %r, %d);
	   dropboom(%x, %y, %z + 10, %x, %y - 200, %z, %r, %d);
	   dropboom(%x, %y, %z + 10, %x + 200, %y, %z, %r, %d);
	   dropboom(%x, %y, %z + 10, %x - 200, %y, %z, %r, %d);
	   dropboom(%x, %y, %z + 10, %x + 200, %y + 200, %z, %r, %d);
	   dropboom(%x, %y, %z + 10, %x - 200, %y + 200, %z, %r, %d);
	   dropboom(%x, %y, %z + 10, %x + 200, %y - 200, %z, %r, %d);
	   dropboom(%x, %y, %z + 10, %x - 200, %y - 200, %z, %r, %d);
	}
}

function dropboom(%x, %y, %z, %x2, %y2, %z2, %r)
{
   dropPod(%x, %y, %z, %x2, %y2, %z2);
//   %xOffset = %x - %x2;
//   %yOffset = %y - %y2;
//   damageArea(%r, %xOffset, %yOffset, %z, 50, 1000); // If the firer was at point -50(x) and the target was at point 50, 50 - (-50) = 0... uhm, that doesn't make any sense for blastArea(); =)
     %t = getDistance(%r,%d) / 400;
     schedule("damageArea(%r,0,0,0,50,1000);",%t); //Fixed that up, you were doing fine before with this, take a rest while yer making big scripts.
}


function gust(%r, %d)
{
   %x1 = getPosition(%r, x);
   %y1 = getPosition(%r, y);
   %x2 = getPosition(%d, x);
   %y2 = getPosition(%d, y);
   %x3 = (%x1 - (%x1 - %x2) + 50);
   %y3 = (%y1 - (%y1 - %y2) + 50);
   %z = getTerrainHeight(%x3, %y3);
   setPosition(%d, %x3, %y3, %z + 2);
}

function freeze(%r, %d)
{
   violate(%d);
   schedule("violate(%d);", 0.1 );
   schedule("violate(%d);", 0.3 );
   schedule("violate(%d);", 0.5 );
   schedule("violate(%d);", 0.7 );
   schedule("violate(%d);", 0.9 );
   schedule("violate(%d);", 1.1 );
   schedule("violate(%d);", 1.5 );
   schedule("violate(%d);", 2.0 );
   schedule("reloadObject(%d, 500000);", 2.1 );
}

function earthquake(%r, %d)
{
   %num = randomInt(1, 100);
   %num2 = randomInt(1, 99);
   say(0, %num, "sfx_quake.WAV");
   say(0, %num2, "explosionlarge.WAV");
   healObject(%d, -3000);
}

function wave(%r, %d)
{
   %m = playerManager::vehicleIdToPlayerNum(%d);
   fadeevent(%m, in, 5, 0, 0, 1.0);
   healObject(%d, -1000);
}

function gusthurt(%r, %d)
{
   %x1 = getPosition(%r, x);
   %y1 = getPosition(%r, y);
   %x2 = getPosition(%d, x);
   %y2 = getPosition(%d, y);
   %x3 = (%x1 - (%x1 - %x2) + 50);
   %y3 = (%y1 - (%y1 - %y2) + 50);
   %z = getTerrainHeight(%x3, %y3);
   setPosition(%d, %x3, %y3, %z + 2);
   healObject(%d, -500);
}

function storm(%r, %d) // This was messed up. Check what variables are going to your functions.
{
  %p = playerManager::vehicleIdToPlayerNum(%d);
  %bolt = newobject("Object", staticshape, "hTitanBEAM.DTS"); // Shouldn't use global variables for "suddenly appearing objects"... otherwise if someone uses it again, you can't get rid of the old one.
  %x = getposition(%d, x);
  %y = getposition(%d, y);
  %z = getposition(%d, z);
  setposition($bolt, %x, %y, %z - 50);
  say(0, 2, "<f1>"@getname(%p)@" was hit by Lightning!", "sfx_orbital_gun.WAV");
  playSound(0, "sfx_thunder2.WAV", IDPRF_2D);
  damagearea(%d, 0, 0, 0 , 5000, 150);
  schedule("deleteobject(%bolt);",1.3 );
}

function wave(%r, %d)
{
   %m = playerManager::vehicleIdToPlayerNum(%d);
   fadeevent(%m, in, 5, 0, 0, 1.0);
   heaObject(%d, -2000);
}

function wetrock(%r, %d)
{
   %m = playerManager::vehicleIdToPlayerNum(%d);
   fadeevent(%m, in, 3, 0, 0, 1.0);
   damageArea(%d, 0, 10, -5, 100, 50);
   damageArea(%d, 0, 10, -5, 100, 50);
   damageArea(%d, 0, 10, -5, 100, 50);
   damageArea(%d, 0, 10, -5, 1000, 50);
   damageArea(%d, 0, 10, -5, 1000, 50);
}

function steam(%r, %d)
{
   %m = playerManager::vehicleIdToPlayerNum(%d);
   fadeevent(%m, in, 10, 0.7, 0.7, 0.7);
}

function icerock(%r, %d)
{
   snow(7, 0, 0);
   healObject(%d, -3000);
   schedule("snow(0, 0, 0);", 1.5 );
}

function frostbite(%r, %d)
{
   %m = playerManager::vehicleIdToPlayerNum(%d);
   fadeevent(%m, out, 2, 0.75, 0.75, 0.75);
   healObject(%d, -2000);
   fadeevent(%m, in, 2, 1.75, 0, 0);
}

////////////-=-=-=-=-=-=-=-=-=-=-ok, now the structure thingy...
// Suggestion from moi! Maybe you should add a message that says the player has gotten that element

function stonefirst::structure::onScan(%d, %r) // Just grammar mistakes, but it gets annoying to remember "ed" or no "ed" for these kind of functions.
{
   %r.first = "stone";
}

function stonesecond::structure::onScan(%d, %r)
{
   %r.second = "stone";
}

function firefirst::structure::onScan(%d, %r)
{
   %r.first = "fire";
}

function firesecond::structure::onScan(%d, %r)
{
   %r.second = "fire";
}

function icefirst::structure::onScan(%d, %r)
{
   %r.first = "ice";
}

function icesecond::structure::onScan(%d, %r)
{
   %r.second = "ice";
}

function windfirst::structure::onScan(%d, %r)
{
   %r.first = "wind";
   echo("Successful");
}

function windsecond::structure::onScan(%d, %r)
{
   %r.second = "wind";
}

function waterfirst::structure::onScan(%d, %r)
{
   %r.first = "water";
}

function watersecond::structure::onScan(%d, %r)
{
   %r.second = "water";
}

//////////////---------------now for the long part :]

function vehicle::onScan(%d, %r)
{

	if((%r.first == "fire") && (%r.second == "fire"))
	{
		fire(%r, %d);
	}

	else if((%r.first == "fire") && (%r.second == "stone"))
	{
		meteor(%r, %d);
	}

	else if((%r.first == "stone") && (%r.second == "fire"))
	{
		meteor(%r, %d);
	}

	else if((%r.first == "fire") && (%r.second == "wind"))
	{
		firestorm(%r, %d);
	}

	else if((%r.first == "wind") && (%r.second == "fire"))
	{
		firestorm(%r, %d);
	}

	else if((%r.first == "ice") && (%r.second == "wind"))
	{
		blizzard(%r, %d);
	}

	else if((%r.first == "wind") && (%r.second == "ice"))
	{
		blizzard(%r, %d);
	}

	else if((%r.first == "wind") && (%r.second == "wind"))
	{
		gust(%r, %d);
	}

	else if((%r.first == "ice") && (%r.second == "ice"))
	{
		freeze(%r, %d);
	}

	else if((%r.first == "stone") && (%r.second == "stone"))
	{
		earthquake(%r, %d);
	}

	else if((%r.first == "water") && (%r.second == "wind"))
	{
		storm(%r, %d);
	}

	else if((%r.first == "wind") && (%r.second == "water"))
	{
		storm(%r, %d);
	}
      else
      {
            pickSpell(%d,%r);
      }
}

function pickSpell(%d,%r) //Split the function here, too many "if" checks triggers a scripting bug, and confuses SS (Syntax error)
{
	if((%r.first == "water") && (%r.second == "water"))
	{
		wave(%r, %d);
	}

	else if((%r.first == "water") && (%r.second == "stone"))
	{
		wetrock(%r, %d);
	}

	else if((%r.first == "stone") && (%r.second == "water"))
	{
		wetrock(%r, %d);
	}

	else if((%r.first == "wind") && (%r.second == "stone"))
	{
		gusthurt(%r, %d);
	}

	else if((%r.first == "stone") && (%r.second == "wind"))
	{
		gusthurt(%r, %d);
	}

	else if((%r.first == "fire") && (%r.second == "water"))
	{
		steam(%r, %d);//causes temporary blindness, nuthing else...
	}

	else if((%r.first == "water") && (%r.second == "fire"))
	{
		steam(%r, %d);//causes temporary blindness, nuthing else...
	}

	else if((%r.first == "stone") && (%r.second == "ice"))
	{
		icerock(%r, %d);//note: needs snow.
	}

	else if((%r.first == "ice") && (%r.second == "stone"))
	{
		icerock(%r, %d);//note: needs snow.
	}

	else if((%r.first == "fire") && (%r.second == "ice"))
	{
		frostbite(%r, %d);
	}
	else
	{
		frostbite(%r, %d);
	}
}
