// FILENAME:	DM_Faceball_Arena.cs
//
// AUTHORS:  	Gen. Powio [MIB]
//------------------------------------------------------------------------------

$missionName = "DM_Faceball_Arena";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	temperateSounds();
}

function onMissionLoad()
{
   $healRate = 350;   
   $ammoRate = 5;
   $padWaitTime = 30;
   $zenWaitTime = 60;	
   cdAudioCycle("Mechsoul", "Cyberntx", "Yougot"); 
}

function player::onAdd(%p)
{
   if(strAlign(1, left, getname(%p))=="/")
   {
      say(0,0,"<f4>"@getname(%p)@" joined the game with a slash","sfx_spot_locking.wav");
   }
   say(%p,0,"Welcome to DM_Faceball_Arena! You can download this & other missions made by Gen. Powio [MIB] from the MIB Website at http://Starsiegemeninblack.cjb.net");
}

function player::onLeave(%p)
{
   if(strAlign(1, left, getname(%p))=="/")
   {
      say(0,0,"<f4>"@getname(%p)@" left the game with a slash","sfx_spot_locking.wav");
   }
}

//------

function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $zenWaitTime, true); 
}

function Redropper::trigger::onEnter(%t,%v)
{
   reDrop(%v);
}