// FILENAME:	DM_Frostbite.cs
//
// AUTHOR:  	Gen. Stormtrooper [M.I.B.]
//------------------------------------------------------------------------------

$missionName = "DM_Frostbite";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
   marsSounds();
   snow(5, 0, 0);
}

function player::onAdd(%player)
{
   say(%player, 0, "Welcome to DeathMatch Frostbite! You can download this & other missions made by Gen. Stormtrooper [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function onMissionLoad()
{
   cdAudioCycle("Yougot", "Newtech", "Mechsoul"); 
}

function up::Structure::onScan(%d, %r)
{
   %ronald = getposition(%r, x);
   %burger = getposition(%r, y);
   %pooz = getposition(%r, z) + 51;
   setposition(%r, %ronald, %burger, %pooz);
}

function down::Structure::onScan(%d, %r)
{
   %ronald = getposition(%r, x);
   %burger = getposition(%r, y);
   %pooz = getposition(%r, z) - 49;
   %tap = getTerrainHeight(%ronald, %burger);
	if(%tap < %pooz)
	{
	   setposition(%r, %ronald, %burger, %pooz);
	}

	else if(%tap > %pooz)
	{
	   setposition(%r, %ronald, %burger, %tap + 1);
	}
}