// FILENAME:	DM_Outpost_Terra.cs
//
// AUTHORS:  	Gen. Stormtrooper [M.I.B.]
//------------------------------------------------------------------------------

$missionName = "DM_Outpost_Terra";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
	setHostile(*IDSTR_TEAM_BLUE, *IDSTR_TEAM_BLUE);
	setHostile(*IDSTR_TEAM_RED, *IDSTR_TEAM_BLUE, *IDSTR_TEAM_RED);
	marsSounds();
	$HercsAtDoor1 = 0;
	order(getObjectId("MissionGroup\\minos\\lead"), guard, getObjectId("MissionGroup\\minos"));
	order(getObjectId("MissionGroup\\minos"), guard, getObjectId("MissionGroup\\minos\\lead"));
	order(getObjectId("MissionGroup\\minos\\lead"), guard, getObjectId("MissionGroup\\Path"));
}

function onMissionLoad()
{
   cdAudioCycle("Purge", "Terror", "Watching"); 
}

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to Outpost Terra! You can download this & other missions made by Maj. Stormtrooper [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function door::trigger::onEnter(%this, %vehicleId)
{
	if($hercsAtDoor1 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\door1"), 0, true);
		playAnimSequence(getObjectId("MissionGroup\\door2"), 0, true);
		playAnimSequence(getObjectId("MissionGroup\\door3"), 0, true);
	}
	$hercsAtDoor1 = $hercsAtDoor1 + 1;
}

function door::trigger::onLeave(%this, %vehicleId)
{
	$hercsAtDoor1 = $hercsAtDoor1 - 1;
	if($hercsAtDoor1 == 0)
      {
		playAnimSequence(getObjectId("MissionGroup\\door1"), 0, false);
		playAnimSequence(getObjectId("MissionGroup\\door2"), 0, false);
		playAnimSequence(getObjectId("MissionGroup\\door3"), 0, false);
		%person = playerManager::vehicleIdToPlayerNum(%vehicleId);
		schedule("say(%person, 59, \"SFX_RAIL.WAV\");", 0.456658 );
	}
}

function up::trigger::onEnter(%this, %vehicleId)
{
   setPosition(%vehicleId, -4491.53, 534.153, 271);
}

function down::trigger::onEnter(%this, %vehicleId)
{
   reDrop(%vehicleId);
}

function boom::trigger::onContact(%this, %vehicleId)
{
   healObject(%vehicleId, -150);
}