// FILENAME:	DM_Unholy_Sanctuary.cs
//
// AUTHORS:  	Gen. Powio [MIB]
//------------------------------------------------------------------------------

$missionName = "DM_Unholy_Sanctuary";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
$healRate = 350;   
$ammoRate = 5;
$padWaitTime = 30;
$zenWaitTime = 60;

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	marsSounds();
}

function onMissionLoad()
{
   cdAudioCycle("Mechsoul","Terror","Watching","Yougot"); 
}

function Gate::Trigger::onEnter(%t,%v)
{
   %p = playerManager::vehicleIdToPlayerNum(%v);
   fadeEvent(%p,in,0.5,1,1,3);
   reDrop(%v);
   say(%p,0,"<F1>A mysterious force draws you back into the graveyard...","Teleporter.wav");
}

function player::onAdd(%player)
{
   if(strAlign(1, left, getname(%p))=="/")
   {
      say(0,0,"<f4>"@getname(%p)@" joined the game with a slash","sfx_spot_locking.wav");
   }
   say(%player, 0, "Welcome to DeathMatch Unholy Sanctuary! You can download this & other missions made by Gen. Powio [MIB] on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $zenWaitTime, true); 
}