// FILENAME:	EMP_Cold_Titan_Night.cs
//
// AUTHOR:  	Gen. Raven [M.I.B.]
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetect = true;    //Set to false to turn off stealth detection

//------------------------------------------------------------------------------
$missionName = "EMP_Cold_Titan_Night";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
      // DM_Cold_Titan_Night stuff
      $healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;

      titanSounds();
}

function onMissionLoad()
{
   cdAudioCycle("Mechsoul", "Terror", "NewTech"); 
   setGameInfo("<F2>GAME TYPE:<F0>  EMP Shockwave DeathMatch\n\n<F2>MISSION:<F0>  EMP_Cold_Titan_Night\n\nWelcome to EMP Shockwave Deathmatch! Your vehicle is equipped with an EMP Shockwave generator. Scan another vehicle or structure to emit an EMP shockwave. Any vehicles caught within 250 meters will have all of their operating systems temporarily offlined. Your EMP generator must recharge for 90 seconds after each use.\n\n<F2>DOWNLOAD INFO:<F0>\n\nYou can download EMP_Cold_Titan_Night & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function player::onadd(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }     
   say(%player,0,"Welcome to EMP Shockwave Deathmatch! Your vehicle is equipped with an EMP Shockwave generator. Scan another vehicle or structure to emit an EMP shockwave. Any vehicles caught within 250 meters will have all of their operating systems temporarily offlined. Your EMP generator must recharge for 90 seconds after each use.");
}

function player::onremove(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
}

function vehicle::onadd(%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %vehicleId.ready = false;
   %vehicleId.firetime = getcurrenttime()-60;   
   schedule("ready("@%vehicleId@");",30);
   sethudtimer(0,0,"EMP Online",2,%player);
   sethudtimer(30,-1,"EMP Charging",2,%player);
}

function vehicle::onscan(%scanned,%scanner)
{
    %player = playermanager::vehicleIdtoPlayerNum(%scanner);
    %player2 = playermanager::vehicleIdtoPlayerNum(%scanned);
    if(%scanner.ready==true)
    {
       %scanner.ready = false;
       %random = randomInt(1,7);
       if(%random == 7)
       {
          %player.backfire = true;
          damageArea(%scanner,0,0,5,20,1000);
          say(%player,%player,"<f5>EMP Shockwave malfunction!","sfx_shieldcap_backfire.wav");
          schedule("resetIt("@%player@");",2);
          %scanner.firetime = getcurrenttime();   
          schedule("ready("@%scanner@");",90);
          sethudtimer(90,-1,"EMP Recharging",2,%player);
       }
       else
       {
          fireEmp(%scanner);
          if(%player2==0)
          {
             schedule("violate("@%scanned@");",1);
             schedule("order("@%scanned@",shutdown,true);",1);
             schedule("order("@%scanned@",shutdown,false);",5);
          }
       }
    }
    else if(%scanner.ready==false)
    {
        %scanner.nowtime  = getcurrenttime();
        %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
        %scanner.timeleft = 90 - %scanner.timecharged;
        say(%player,%player,"<f1>EMP charging - " @ %scanner.timeleft @ " seconds remaining.");
    }
}

function structure::onscan(%scanned,%scanner)
{
    %player = playermanager::vehicleIdtoPlayerNum(%scanner);
    if(%scanner.ready==true)
    {
       %scanner.ready = false;
       %random = randomInt(1,7);
       if(%random == 7)
       {
          %player.backfire = true;
          damageArea(%scanner,0,0,5,20,1000);
          say(%player,%player,"<f5>EMP Shockwave malfunction!","sfx_shieldcap_backfire.wav");
          schedule("resetIt("@%player@");",2);
          %scanner.firetime = getcurrenttime();   
          schedule("ready("@%scanner@");",90);
          sethudtimer(90,-1,"EMP Recharging",2,%player);
       }
       else
       {
          fireEmp(%scanner);
       }
    }
    else if(%scanner.ready==false)
    {
        %scanner.nowtime  = getcurrenttime();
        %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
        %scanner.timeleft = 90 - %scanner.timecharged;
        say(%player,%player,"<f1>EMP charging - " @ %scanner.timeleft @ " seconds remaining.");
    }
}

function fireEmp(%scanner)
{
   %player = playermanager::vehicleIdToPlayerNum(%scanner);
   %x = getposition(%scanner,x);
   %y = getposition(%scanner,y);
   %z = getposition(%scanner,z)+3;
   %wave = newObject("ShockWave",StaticShape,"fx_thump_T.DTS");
   addtoset("MissionGroup/Waves",%wave);
   schedule("setPosition("@%wave@","@%x@","@%y@","@%z@");",0.5);
   schedule("playAnimSequence("@%wave@",0,true);",0.5);
   schedule("deleteObject("@%wave@");",2.167);
   %count = playermanager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player2 = playermanager::getplayernum(%i);
      %vehicleId = playermanager::playernumtovehicleId(%player2);
      %distance = getdistance(%scanner,%vehicleId);
      if((%distance<=250) && (%vehicleId!=%scanner)&&(%vehicleId!=0))
      {
         schedule("say("@%player2@","@%player2@",\"<f5>You were hit by an EMP shockwave! All vehicle operating systems have been temporarily offlined.\");",0.75);
         schedule("violate("@%vehicleId@");",1);
         schedule("reloadObject("@%vehicleId@",5000);",1.25);
         schedule("playSound("@%player2@", \"plasma3.wav\", IDPRF_2D);",1);
         schedule("playSound("@%player2@", \"sfx_prob.wav\", IDPRF_2D);",1);
         schedule("playSound("@%player2@", \"sfx_orbital_gun.wav\", IDPRF_2D);",1);
      }
   }
   say(%player,%player,"<f1>Emitting EMP Shockwave...");
   %scanner.firetime = getcurrenttime();   
   schedule("ready("@%scanner@");",90);
   sethudtimer(90,-1,"EMP Recharging",2,%player);
   schedule("playSound("@%player@", \"plasma3.wav\", IDPRF_2D);",1);
   schedule("playSound("@%player@", \"sfx_prob.wav\", IDPRF_2D);",1);
   schedule("playSound("@%player@", \"sfx_orbital_gun.wav\", IDPRF_2D);",1);
}

function ready(%scanner)
{  
   %scanner.ready = true;      
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   %player2 = playermanager::vehicleIdtoPlayerNum(%destroyed);
   if((%player == 0) && (%player2.backfire==true))
   {
      say(0,0,"<f0>" @ getName(%destroyed) @ " self-destructed!");
   }
   else
   {   
      // this is weird but %destroyer isn't necessarily a vehicle
      %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
      if(%message != "")
      {
         say( 0, 0, %message);
      }
      // enforce the rules
      if($server::TeamPlay == true)
      {
         if((getTeam(%destroyed) == getTeam(%destroyer))&&(%destroyed != %destroyer))
         {
            antiTeamKill(%destroyer);
         }
      }   
   }
}

function resetIt(%player)
{
   %player.backfire = false;
}

function onMissionEnd()
{
   flushConsoleScheduler();
   deleteObject("MissionGroup/Waves");
}

// DM_Cold_Titan_Night stuff
// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

//If someone shoots frosty, his houses blow up revealing a nasty surprise
//------------------------------------------------
function tur1::turret::onAdd(%this)
{
	$turret1=%this;
	order($turret1,ShutDown,true);
}
function tur2::turret::onAdd(%this)
{
	$turret2=%this;
	order($turret2,ShutDown,true);
}
function Frosty::structure::onAttacked(%attacked,%attacker)
{
	%bang1=getObjectId("MissionGroup\\extra\\frosty's house\\house1");
	healObject(%bang1,-30000);
	order($turret1,ShutDown,false);
	order($turret1, Attack, %attacker);
	%bang2=getObjectId("MissionGroup\\extra\\frosty's house\\house2");
	healObject(%bang2,-30000);
	order($turret2,ShutDown,false);
	order($turret2, Attack, %attacker);
}