// FILENAME:	EXP_Sand_Dunes.cs
//
// AUTHORS:  	Gen. Raven [M.I.B.]
//
// TRANSLATION:   What do you like to do?
//                I like to play Starsiege.
//
// Check out EXP_City_on_the_Edge.cs to find out how to say that in french.
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetect = true;    //Set to false to turn off stealth detection

//------------------------------------------------------------------------------
$missionName = "EXP_Sand_Dunes";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	desertSounds();
      $explosivesSupply1 = "ready";
      $explosivesSupply2 = "ready";
      $explosivesSupply3 = "ready";
      $explosivesSupply4 = "ready";
      $boom1 = "MissionGroup/Anims/boom1";
      $boom2 = "MissionGroup/Anims/boom2";
      $boom3 = "MissionGroup/Anims/boom3";
      $boom4 = "MissionGroup/Anims/boom4";
      $boom5 = "MissionGroup/Anims/boom5";
      $boom6 = "MissionGroup/Anims/boom6";
      $boom7 = "MissionGroup/Anims/boom7";
      $boom8 = "MissionGroup/Anims/boom8";
      $boom9 = "MissionGroup/Anims/boom9";
      $boom10 = "MissionGroup/Anims/boom10";
      $boom11 = "MissionGroup/Anims/boom11";
      $boom12 = "MissionGroup/Anims/boom12";
      $boom13 = "MissionGroup/Anims/boom13";
      $boom14 = "MissionGroup/Anims/boom14";
      $boom15 = "MissionGroup/Anims/boom15";      
}

function onMissionLoad()
{
   cdAudioCycle("MechSoul", "NewTech", "Terror"); 
   setGameInfo("<F2>GAME TYPE:<F0>  DeathMatch\n\n<F2>MISSION:<F0>  EXP_Sand_Dunes\n\nWelcome to Explosive Deathmatch! Your vehicle is equipped with explosives when you spawn. Shut down to set the explosives. You can toggle the amount of time until detonation by scanning a structure or another vehicle. Re-Supply your vehicle with explosives by walking into an Explosives Supply Depot. You cannot set explosives while in a pad. You can download EXP_Sand_Dunes & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function player::onAdd(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
        say(%player, 0, "Welcome to Explosive DeathMatch! Check the game info tab for the rules. You can download EXP_Sand_Dunes & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   }
   else
   {
      say(%player, 0, "Welcome to Explosive DeathMatch! Check the game info tab for the rules. You can download EXP_Sand_Dunes & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   }
   %player.bombtime = 15;
   %player.laidBomb = false;
}

function player::onremove(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
   deleteobject(%player.bomb);
   deleteobject(%player.explosion);
}


function vehicle::onadd(%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %vehicleId.name=gethudname(%vehicleId);
   %player.hasBomb = true;
   %player.InPad = false;
   %player.spawndelay = true;
   schedule("spawndelay("@%player@");",5);
   if(%player.laidbomb==true)
   {
      %player.timeElapsed = getcurrenttime() - %player.setTime;
      %player.timeleft = %player.TempTime - %player.timeElapsed;
      setHudTimer(%player.timeleft, -1, "Explosives Timer", 1, %player); 
   }
}   

function spawndelay(%player)
{
   %player.spawndelay = false;
}

function vehicle::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);
   if(%player.bombtime==10)
   {
      %player.bombtime = 15;
      say(%player,%player,"<f1>Explosives timer set to 15 seconds.");
   }
   else if(%player.bombtime==15)
   {
      %player.bombtime = 20;
      say(%player,%player,"<f1>Explosives timer set to 20 seconds.");
   }
   else if(%player.bombtime==20)
   {
      %player.bombtime = 30;
      say(%player,%player,"<f1>Explosives timer set to 30 seconds.");
   }
   else if(%player.bombtime==30)
   {
      %player.bombtime = 60;
      say(%player,%player,"<f1>Explosives timer set to 60 seconds.");
   }
   else if(%player.bombtime==60)
   {
      %player.bombtime = 10;
      say(%player,%player,"<f1>Explosives timer set to 10 seconds.");
   }
}

function vehicle::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   %player2 = playermanager::vehicleIdtoPlayerNum(%destroyed);
   
   %player2.deathdelay=true;
   schedule("deathdelay("@%player2@");",5);
   if(%player == 0)
   {
      say(0,0,gethudname(%destroyed) @ " got blown up!");
   }
   else
   {
      vehicle::onDestroyedLog(%destroyed, %destroyer);
   
      // this is weird but %destroyer isn't necessarily a vehicle
      %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
      if(%message != "")
      {
         say( 0, 0, %message);
      }
      
      // enforce the rules
      if($server::TeamPlay == true)
      {
         if((getTeam(%destroyed) == getTeam(%destroyer)) && (%destroyed != %destroyer))
         {
            antiTeamKill(%destroyer);
         }
      }   
   }
}

function deathdelay(%player2)
{
   %player2.deathdelay = false;
}

function structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);
   if(%player.bombtime==10)
   {
      %player.bombtime = 15;
      say(%player,%player,"<f1>Explosives timer set to 15 seconds.");
   }
   else if(%player.bombtime==15)
   {
      %player.bombtime = 20;
      say(%player,%player,"<f1>Explosives timer set to 20 seconds.");
   }
   else if(%player.bombtime==20)
   {
      %player.bombtime = 30;
      say(%player,%player,"<f1>Explosives timer set to 30 seconds.");
   }
   else if(%player.bombtime==30)
   {
      %player.bombtime = 60;
      say(%player,%player,"<f1>Explosives timer set to 60 seconds.");
   }
   else if(%player.bombtime==60)
   {
      %player.bombtime = 10;
      say(%player,%player,"<f1>Explosives timer set to 10 seconds.");
   }
}

function explosives::trigger::oncontact(%this,%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   if(isshutdown(%object)==false)
   {
      %player.justlaid = false;
   }
   if((%player.InPad==false)&&(isshutdown(%object)==true)&&(%player.hasbomb==true)&&(%player.laidbomb==false))
   {  
      %player.justlaid = true;
      say(%player,%player,"<f5>Explosives Armed.");
      setexplosives(%object);
   }  
   else if((%player.InPad==false)&&(isshutdown(%object)==true)&&(%player.hasbomb==false)&&(%player.justlaid==false))
   {  
      %player.justlaid = true;
      say(%player,%player,"<f1>You do not have explosives.");
   }
   else if((%player.InPad==false)&&(isshutdown(%object)==true)&&(%player.hasbomb==true)&&(%player.laidbomb==true)&&(%player.justlaid==false))
   {
      %player.justlaid = true;   
      say(%player,%player,"<f1>You cannot lay more explosives until your current explosives have detonated.");
   }
}

function setexplosives(%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   %player.hasbomb = false;
   %player.laidbomb = true;
   %player.bomb = newobject("Explosives", StaticShape, "pr_prx.DTS");
   %player.x = getposition(%object,x);
   %player.y = getposition(%object,y);
   %player.z = getTerrainHeight(%player.x,%player.y)+0.2;
   setposition(%player.bomb,%player.x,%player.y,%player.z);
   %player.setTime = getcurrenttime();
   %player.TempTime = %player.bombtime;
   setHudTimer(%player.bombtime, -1, "Explosives Timer", 1, %player); 
   schedule("explode("@%player@");",%player.bombtime);
   %player.explosion = newobject("Explosion", StaticShape, "fx_exp_podT.DTS");
   setShapeVisibility(%player.explosion,false);
   playAnimSequence(%player.explosion,0,false);
   setposition(%player.explosion,%player.x,%player.y,(%player.z-0.2));
}

function explode(%player)
{
   if(%player!=0)
   {
      %object = playermanager::PlayerNumtoVehicleId(%player);
      setShapeVisibility(%player.explosion,true);
      playAnimSequence(%player.explosion,0,true);
      say(0,1,"<f5>" @ gethudname(%object) @ "'s explosives have detonated!","sfx_fog.wav"); 
      damageArea(%player.bomb,0,0,0,250,5000);
      schedule("DeleteItAll(" @ %player @ ");",1.067);
   }
}

function DeleteItAll(%player)
{
   deleteobject(%player.bomb);
   deleteobject(%player.explosion);
   %player.laidbomb = false;
}

function onMissionEnd()
{
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      deleteobject(%player.bomb);
      deleteobject(%player.explosion);
      %player.laidbomb = false;
   }
}

function explosivesSupply1::trigger::onenter(%this,%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   if(($explosivesSupply1=="ready")&&(%player.hasbomb==false))
   {
      %player.hasbomb = true;
      say(%player,%player,"<f1>Your vehicle has been supplied with explosives.");
      $explosivesSupply1 = "not ready";
      schedule("$explosivesSupply1 = \"ready\";",30);
      schedule("say(0,0,\"<f1>Explosives Supply Depot 001 is ready.\");",30);
   }
   else if(($explosivesSupply1=="ready")&&(%player.hasbomb==true))
   {
      say(%player,%player,"<f1>You already have explosives!");
   }
   else if($explosivesSupply1!="ready")
   {
      say(%player,%player,"<f1>Explosives Supply Depot 001 is not ready.");
   }
}

function explosivesSupply2::trigger::onenter(%this,%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   if(($explosivesSupply2=="ready")&&(%player.hasbomb==false))
   {
      %player.hasbomb = true;
      say(%player,%player,"<f1>Your vehicle has been supplied with explosives.");
      $explosivesSupply2 = "not ready";
      schedule("$explosivesSupply2 = \"ready\";",30);
      schedule("say(0,0,\"<f1>Explosives Supply Depot 002 is ready.\");",30);
   }
   else if(($explosivesSupply2=="ready")&&(%player.hasbomb==true))
   {
      say(%player,%player,"<f1>You already have explosives!");
   }
   else if($explosivesSupply2!="ready")
   {
      say(%player,%player,"<f1>Explosives Supply Depot 002 is not ready.");
   }
}

function explosivesSupply3::trigger::onenter(%this,%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   if(($explosivesSupply3=="ready")&&(%player.hasbomb==false))
   {
      %player.hasbomb = true;
      say(%player,%player,"<f1>Your vehicle has been supplied with explosives.");
      $explosivesSupply3 = "not ready";
      schedule("$explosivesSupply3 = \"ready\";",30);
      schedule("say(0,0,\"<f1>Explosives Supply Depot 003 is ready.\");",30);
   }
   else if(($explosivesSupply3=="ready")&&(%player.hasbomb==true))
   {
      say(%player,%player,"<f1>You already have explosives!");
   }
   else if($explosivesSupply3!="ready")
   {
      say(%player,%player,"<f1>Explosives Supply Depot 003 is not ready.");
   }
}

function explosivesSupply4::trigger::onenter(%this,%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   if(($explosivesSupply4=="ready")&&(%player.hasbomb==false))
   {
      %player.hasbomb = true;
      say(%player,%player,"<f1>Your vehicle has been supplied with explosives.");
      $explosivesSupply4 = "not ready";
      schedule("$explosivesSupply4 = \"ready\";",30);
      schedule("say(0,0,\"<f1>Explosives Supply Depot 004 is ready.\");",30);
   }
   else if(($explosivesSupply4=="ready")&&(%player.hasbomb==true))
   {
      say(%player,%player,"<f1>You already have explosives!");
   }
   else if($explosivesSupply4!="ready")
   {
      say(%player,%player,"<f1>Explosives Supply Depot 004 is not ready.");
   }
}

//  BombZen Pad Functionality
function BombZen::trigger::onEnter(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);
      %player.InPad = true; 
}

function BombZen::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 1000, 40, 0, true); 
}

function BombZen::trigger::onLeave(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
      %player.InPad = false; 
}

function explosives::trigger::onEnter(%this,%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   if(%player.spawndelay==false)
   {
      say(%player,%player,"<f1>Re-entering mission area. Explosives back online.");
   }
}

function explosives::trigger::onLeave(%this,%object)
{
   %player = playermanager::vehicleIdtoPlayerNum(%object);
   if(%player.deathdelay==false)
   {
      say(%player,%player,"<f1>Leaving mission area. Explosives disabled.");
   }
}


function boom1::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom1,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom1,0,true);
      damageArea($boom1,0,0,0,150,2000);
      schedule("deleteobject($boom1);",1.067);
   }
   else
   {
      schedule("deleteobject($boom1);",1.067);
   }
}

function boom2::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom2,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom2,0,true);
      damageArea($boom2,0,0,0,150,2000);
      schedule("deleteobject($boom2);",1.067);
   }
   else
   {
      schedule("deleteobject($boom2);",1.067);
   }
}

function boom3::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom3,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom3,0,true);
      damageArea($boom3,0,0,0,150,2000);
      schedule("deleteobject($boom3);",1.067);
   }
   else
   {
      schedule("deleteobject($boom3);",1.067);
   }
}

function boom4::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom4,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom4,0,true);
      damageArea($boom4,0,0,0,150,2000);
      schedule("deleteobject($boom4);",1.067);
   }
   else
   {
      schedule("deleteobject($boom4);",1.067);
   }
}

function boom5::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom5,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom5,0,true);
      damageArea($boom5,0,0,0,150,2000);
      schedule("deleteobject($boom5);",1.067);
   }
   else
   {
      schedule("deleteobject($boom5);",1.067);
   }
}

function boom6::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom6,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom6,0,true);
      damageArea($boom6,0,0,0,150,2000);
      schedule("deleteobject($boom6);",1.067);
   }
   else
   {
      schedule("deleteobject($boom6);",1.067);
   }
}

function boom7::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom7,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom7,0,true);
      damageArea($boom7,0,0,0,150,2000);
      schedule("deleteobject($boom7);",1.067);
   }
   else
   {
      schedule("deleteobject($boom7);",1.067);
   }
}

function boom8::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom8,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom8,0,true);
      damageArea($boom8,0,0,0,150,2000);
      schedule("deleteobject($boom8);",1.067);
   }
   else
   {
      schedule("deleteobject($boom8);",1.067);
   }
}

function boom9::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom9,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom9,0,true);
      damageArea($boom9,0,0,0,150,2000);
      schedule("deleteobject($boom9);",1.067);
   }
   else
   {
      schedule("deleteobject($boom9);",1.067);
   }
}

function boom10::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom10,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom10,0,true);
      damageArea($boom10,0,0,0,150,2000);
      schedule("deleteobject($boom10);",1.067);
   }
   else
   {
      schedule("deleteobject($boom10);",1.067);
   }
}

function boom11::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom11,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom11,0,true);
      damageArea($boom11,0,0,0,150,2000);
      schedule("deleteobject($boom11);",1.067);
   }
   else
   {
      schedule("deleteobject($boom11);",1.067);
   }
}

function boom12::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom12,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom12,0,true);
      damageArea($boom12,0,0,0,150,2000);
      schedule("deleteobject($boom12);",1.067);
   }
   else
   {
      schedule("deleteobject($boom12);",1.067);
   }
}

function boom13::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom13,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom13,0,true);
      damageArea($boom13,0,0,0,150,2000);
      schedule("deleteobject($boom13);",1.067);
   }
   else
   {
      schedule("deleteobject($boom13);",1.067);
   }
}

function boom14::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom14,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom14,0,true);
      damageArea($boom14,0,0,0,150,2000);
      schedule("deleteobject($boom14);",1.067);
   }
   else
   {
      schedule("deleteobject($boom14);",1.067);
   }   
}

function boom15::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom15,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom15,0,true);
      damageArea($boom15,0,0,0,150,2000);
      schedule("deleteobject($boom15);",1.067);
   }
   else
   {
      schedule("deleteobject($boom15);",1.067);
   }
}

function setDefaultMissionItems()
{
   allowWeapon( 3, FALSE );    //Disrupter Weapon  
}