//---------------------------------------------------------------------------+
// Graves.cs by Gen. Powio [MIB]                                            |
// Original script by Gen. Raven [M.I.B]                                     |
// Tombstones!                                                               |
//                                                                           |
// Copyright  2001 Starsiege Men In Black - All Rights Reserved             |
//---------------------------------------------------------------------------+
// Features pop-up "tombstones" with epitaphs. Scan them for more information|
// on the "lost" ones.                                                       |
//                                                                           |
// Now also featuring ghosts!                                                |
//---------------------------------------------------------------------------+

$AnybodyGhost = True;
$GhostRateX = 50;
$GhostRateY = 50;
$Tomb = getPathOf("Monument.tmp");
$Ghost1 = getPathOf("Ghost1.tmp");
$Ghost2 = getPathOf("Ghost2.tmp");
$Ghost3 = getPathOf("Ghost3.tmp");

function vehicle::onadd(%v)
{
   %v.time=getTime();
}

function vehicle::onDestroyed(%d,%r)
{
   %p = playerManager::VehicleIdToPlayerNum(%d);
   %m = getFancyDeathMessage(getHUDName(%d),getHUDName(%r));
   if(%m!="")
   {
      say(0,0,%m);
   }
   %x=getposition(%d,x);
   %y=getposition(%d,y);
   %z=getposition(%d,z) - 20;
   %g=loadObject("Grave",$Tomb@"/Monument.tmp");
   %p.lastGrave = %g;
   %o=(getPosition(%d,rot)*180)/3.14159;
   setposition(%g,%x,%y,%z,%o);
   schedule("raiseGrave("@%g@",20,"@%x@","@%y@","@%z@","@%o@");",0.1);
   setStaticShapeShortName(%g,"R.I.P "@getHUDName(%d)@" - Death #"@getDeaths(playermanager::vehicleidtoplayernum(%d)));
   %g.message="<F3>Rest in pieces <F1>"@getHUDName(%d)@"... <F3>Destroyed by <F5>"@getHUDName(%r)@".<F3> "@%d.time@"-"@getTime()@". Death <F5>#"@getDeaths(playermanager::vehicleidtoplayernum(%d));
   schedule(%p@".lastGrave = \"\";",300);
   schedule("deleteObject("@%g@");",300);
   if((%p == 0)||($AnybodyGhost == True))
   {
      %AI = True;
      %r = randomInt(1,6);
      echo(%r);
      if(%r == 1)
      {
         makeGhost(getHUDName(%d),%x,%y,%AI);
      }
      if(%p == 0)
      {
         schedule("deleteObject("@%d@");",5);
      }
   }
}

function raiseGrave(%g,%t,%x,%y,%z,%o)
{
   %z = %z + 1;
   %t--;
   setPosition(%g,%x,%y,%z,%o);
   if(%t > 0)
   {
      schedule("raiseGrave("@%g@","@%t@","@%x@","@%y@","@%z@","@%o@");",0.1);
   }
}

function structure::onScan(%d,%r)
{
   %p = playermanager::vehicleidtoplayernum(%r);
   if(getObjectName(%d)=="Grave")
   {
      say(%p,%p,"<f5>"@%d.message);
   }
}

function player::onAdd(%p)
{
   if(strAlign(1, left, getname(%player))=="/")
   {
      say(0,0,"<f4>"@getname(%player)@" joined the game with a slash","sfx_spot_locking.wav");
   }
   say(%p,0,"<f1>Welcome to DeathMatch! Check the Game Info tab for rules and scoring information.");
   if($AnybodyGhost != True)
   {
      for(%i=8000;%i<9000;%i++)
      {
         %pn = getName(%p);
         %on = getObjectName(%i);
         if((%pn == %on)&&(%i.Ghost == True))
         { 
            %i.Ghost = "";
         }
      }
   }
}

function player::onLeave(%p)
{
   if(strAlign(1, left, getname(%player))=="/")
   {
      say(0,0,"<f4>"@getname(%player)@" left the game with a slash","sfx_spot_locking.wav");
   }
   if((%p.lastGrave != "")&&($AnybodyGhost != True))
   {
      %x = getPosition(%p.lastGrave, y);
      %y = getPosition(%p.lastGrave, y);
      %r = randomInt(1,2);
      if(%r == 1)
      {
         makeGhost(getName(%p),%x,%y);
      }
   }
}

function makeGhost(%n,%x,%y,%AI)
{
   %r = randomInt(1,3);
   if(%r == 3)
   {
      %rot = -90;
   }
   else
   {
      %rot = 0;
   }
   %o = loadObject(%n,$Ghost[%r]@"/Ghost"@%r@".tmp");
   if(%AI == True)
   {
      %o.Ghost = AI;
   }
   else
   {
      %o.Ghost = True;
   }
   schedule(%o@".ghost = \"\";",300);
   setPosition(%o,%x,%y,getTerrainHeight(%x,%y)+6,0,%rot);
   setStaticShapeShortName(%o,%n@"'s Ghost");
   ghostTrack(%o,%x,%y,%rot);
}

function ghostTrack(%o,%x,%y,%rot)
{
   %targetx = randomInt(%x - $GhostrateX,%x + $GhostrateX);
   %targety = randomInt(%y - $GhostrateY,%y + $GhostrateY);
   schedule("ghostFloat("@%o@","@%targetx@","@%targety@","@%x@","@%y@","@%rot@");",0.1);
}

function ghostFloat(%o,%targetx,%targety,%nowx,%nowy,%rot)
{
   if(%o.Ghost == "")
   {
      setShapeVisibility(%o,false);
      schedule("deleteObject("@%o@");",600);
   }
   else
   {
      if(%nowx <= %targetx)
      {
         %sidex = %targetx - %nowx;
      }
      else if(%nowx >= %targetx)
      {
         %sidex = %nowx - %targetx;
      }
      if(%nowy <= %targety)
      {
         %sidey = %targety - %nowy;
      }
      else if(%nowy >= %targety)
      {
         %sidey = %nowy - %targety;
      }
      %distance = sqrt((%sidex * %sidex) + (%sidey * %sidey));
      if(%distance <= 2)
      {
         damageArea(%o,0,0,0,40,50);
         ghostTrack(%o,%nowx,%nowy,%rot);
      }
      else
      {
         %inc = %distance / 2.8; //Speed
         %xMove = (%targetx - %nowx) / %inc;
         %yMove = (%targety - %nowy) / %inc;
         %xNext = %nowx + %xMove;
         %yNext = %nowy + %yMove;
         %zNext = getTerrainHeight(%xNext,%yNext) + 6;
         setPosition(%o,%xNext,%yNext,%zNext,0,%rot);
         damageArea(%o,0,0,0,50,100);
         schedule("ghostFloat("@%o@","@%targetx@","@%targety@","@%xNext@","@%yNext@","@%rot@");",0.1);
      }
   }
}

function cleanUp()
{
   function vehicle::onadd(){}
   function vehicle::ondestroyed(){}
   function raiseGrave(){}
   function structure::onScan(){}
   function player::onadd(){}
   function player::onleave(){}
   function makeGhost(){}
   function ghostTrack(){}
   function ghostFloat(){}
}