// FILENAME:	DM_Snow_Blind.cs
//
// AUTHOR:  	Com. Sentinal [M.I.B.]
//------------------------------------------------------------------------------

$missionName = "DM_Snow_Blind";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function setDefaultMissionItems()
{
   allowComponent(                                        all, TRUE  );
   allowComponent(                                        400, FALSE  );
   allowComponent(                                        401, FALSE  );
   allowComponent(                                        408, FALSE  );
   allowComponent(                                        409, FALSE  );
   allowComponent(                                        410, FALSE  );
   allowComponent(                                        411, FALSE  );
   allowComponent(                                        412, FALSE  );
   allowComponent(                                        413, FALSE  );
   allowComponent(                                        414, FALSE  );
   allowComponent(                                        426, FALSE  );
   allowComponent(                                        427, FALSE  );
   allowComponent(                                        428, FALSE  );
   allowComponent(                                        429, FALSE  );
   allowComponent(                                        430, FALSE  );
   allowComponent(                                        431, FALSE  );
   allowComponent(                                        432, FALSE  );
   allowComponent(                                        433, FALSE  );
   allowComponent(                                        434, FALSE  );
}

function onMissionStart()
{
	iceSounds();
      $killPoints = 0;
      $deathPoints = 2;
      $healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;
      $lock = false;
      $turret1 = getObjectId("MissionGroup\\turret1");
      $turret2 = getObjectId("MissionGroup\\turret2");
      $turret3 = getObjectId("MissionGroup\\turret3");
      $turret4 = getObjectId("MissionGroup\\turret4");
      $turret5 = getObjectId("MissionGroup\\turret5");
      $turret6 = getObjectId("MissionGroup\\turret6");
      $turret7 = getObjectId("MissionGroup\\turret7");
      $turret8 = getObjectId("MissionGroup\\turret8");
}

function player::onAdd(%player)
{
   say(%player, 0, "Welcome to Hide & Seek (H&S)! Find other players & \"tag\" them to destroy them. To tag an enemy vehicle, lock onto your target & scan him with the \" I \" key. Radar is NOT allowed. Tags are worth 3 points & deaths are worth -2. You DO NOT recieve points for normal kills. You can download H&S_Snow_Blind & other missions made by Com. Sentinal [M.I.B.] in the \"MIB Map Packs\" on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %player.points = 0;
}

function vehicle::onAdd(%vehicleId)
{
   setVehicleRadarVisible(%vehicleId, false);
   if(($lock==false)&&($server::TeamPlay == false))
   {
      deActivateTurrets();
   }
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
// left over from missionStdLib.cs
//   vehicle::onDestroyedLog(%destroyed, %destroyer);
//   
// this is weird but %destroyer isn't necessarily a vehicle
//   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
//   if(%message != "")
//   {
//      say( 0, 0, %message);
//   }
//   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if(
         (getTeam(%destroyed) == getTeam(%destroyer)) &&
         (%destroyed != %destroyer)
      )
      {
         antiTeamKill(%destroyer);
      }
   }   
}

function onMissionLoad()
{
   cdAudioCycle("Yougot", "Newtech", "Mechsoul"); 
   setGameInfo("<F2>GAME TYPE:<F0>  Hide & Seek\n\n<F2>MISSION:<F0>  H&S_Snow_Blind\n\nWelcome to Hide & Seek (H&S)! Find other players & \"tag\" them to destroy them. To tag an enemy vehicle, lock onto your target & scan him with the \" <F3>I<F0> \" key. Radar is NOT allowed. Tags are worth <F3>3<F0> points & deaths are worth <F3>-2<F0>. You DO NOT recieve points for normal kills. You can download H&S_Snow_Blind & other missions made by Com. Sentinal [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      %player.points = 0;
   }
}

function deActivateTurrets()
{  
   $lock = true;
   setTeam($turret1, *IDSTR_TEAM_NEUTRAL);
   setTeam($turret2, *IDSTR_TEAM_NEUTRAL);
   setTeam($turret3, *IDSTR_TEAM_NEUTRAL);
   setTeam($turret4, *IDSTR_TEAM_NEUTRAL);
   setTeam($turret5, *IDSTR_TEAM_NEUTRAL);
   setTeam($turret6, *IDSTR_TEAM_NEUTRAL);
   setTeam($turret7, *IDSTR_TEAM_NEUTRAL);
   setTeam($turret8, *IDSTR_TEAM_NEUTRAL);
   order($turret1, shutdown, true);
   order($turret2, shutdown, true);
   order($turret3, shutdown, true);
   order($turret4, shutdown, true);
   order($turret5, shutdown, true);
   order($turret6, shutdown, true);
   order($turret7, shutdown, true);
   order($turret8, shutdown, true);
}

function vehicle::OnScan(%scanned, %scanner, %string)
{
   %player = playerManager::vehicleIdToPlayerNum(%scanner);
   if(($server::TeamPlay == true) && (getTeam(%scanner) == getTeam(%scanned)))
   {  
      say(%player, %player, getHudName(%scanned) @ " is on your team!");
   }
   else
   {
      healObject(%scanned, -10000);
	healObject(%scanned, -10000);
	healObject(%scanned, -10000);
	healObject(%scanned, -10000);
	healObject(%scanned, -10000);
      %player.points = %player.points + 3;
      say("everybody", 0, getHudName(%scanned) @ " was tagged by " @ getHudName(%scanner) @ "!");
   } 
}

function getPlayerScore(%player)
{
   return((%player.points) + (getKills(%player) * $killPoints) - (getDeaths(%player) * $deathPoints));
}

//Explosives....handle with care
//------------------------------------------------------------------------------
function box1::structure::onDestroyed(%destroyed, %destroyer)
{
   blast(%destroyer, 200, 5000);
}

function box2::structure::onDestroyed(%destroyed, %destroyer)
{
   blast(%destroyer, 200, 5000);
}

function box3::structure::onDestroyed(%destroyed, %destroyer)
{
   blast(%destroyer, 200, 5000);
}

function box4::structure::onDestroyed(%destroyed, %destroyer)
{
   blast(%destroyer, 200, 5000);
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}
