//---------------------------------------------------------------------------+
// ItemStdLib.cs by Gen. Powio [MIB]                                        |
// PowiUps! v1.7.1                                                          |
//                                                                           |
// Copyright  2001, Powio - All Rights Reserved                            |
//---------------------------------------------------------------------------+
// Features 8 special PowiUps that can benefit or harm your vehicle.        |
// Good items include Instant Heals, Supply Pack, Ion Gun, Poison Gun, and   |
// special Regenerating armor.                                               |
// Bad items include Poison Traps, Instant Warps, and the eVil Death Traps!  |
//---------------------------------------------------------------------------+

//---------------------------------------------------------------------------+
// Misc notes:                                                               |
//------------                                                               |
// - Getting any item is based on a 1:32 basis.                              |
//    Energy Tank   1:4  ( 8:32) ( 25.000%)                                 |
//    Ion Gun       1:4  ( 8:32) ( 25.500%)                                 |
//    Supply Cache  1:8  ( 4:32) ( 12.000%)                                 |
//    Poison Trap   1:8  ( 4:32) ( 12.500%)                                 |
//    Regen Armor   1:8  ( 4:32) ( 12.500%)                                 |
//    Poison Gun    1:16 ( 2:32) (  6.250%)                                 |
//    Death Trap    1:32 ( 1:32) (  3.125%)                                 |
//    Warp Trap     1:32 ( 1:32) (  3.125%)                                 |
//---------------------------------------------------------------------------+

$Drone = getPathOf("TargetDrone.tmp");

function PowiUp()
{
   %x = randomInt(-2000,2000);
   %y = randomInt(-2000,2000);
   %z = getTerrainHeight(%x,%y);
   dropPod(%x,%y,%z+3200,%x,%y,%z);
   %o = loadObject("PowiUp",$Drone@"/TargetDrone.tmp");
   %o.Ready = True;
   setshapevisibility(%o,false);
   schedule("setPosition("@%o@","@%x@","@%y@","@%z@"-6);",8);
   schedule("setshapevisibility("@%o@",true);",8);
   %o.Min = 3;
   %o.Sec = 0;
   schedule("capsuleCount("@%o@");",9);
   schedule("PowiUp();",20);
}

function CapsuleCount(%o)
{
   if(%o.Ready == True)
   {
      if(%o.Sec == 0)
      {
            %o.Min--;
            %o.Sec = %o.Sec + 59;
      }
      else
      {
         %o.Sec--;
      }
      if((%o.Min == 0)&&(%o.Sec == 0))
      {
         %o.Ready = "";
         deleteObject(%o);
      }
      else if(%o.Sec < 10)
      {
         setStaticShapeShortName(%o,"Item Capsule ["@%o.Min@":0"@%o.Sec@"]");
         schedule("CapsuleCount("@%o@");",1);
      }
      else
      {
         setStaticShapeShortName(%o,"Item Capsule ["@%o.Min@":"@%o.Sec@"]");
         schedule("CapsuleCount("@%o@");",1);
      }
   }
}

function structure::onScan(%d,%r)
{
   %p=playermanager::vehicleIdToPlayerNum(%r);
   if((getObjectName(%d)=="PowiUp")&&(%d.ready==true))
   {
      %x=getPosition(%d,x);
      %y=getPosition(%d,y);
      setshapevisibility(%d,false);
      %d.ready="";
      schedule("deleteObject("@%d@");",1.0);
      %i=randomInt(1,32);
      else if(%i<9)
      {
         //Supply Pack
         say(%p,199,"<F3>Inside the <F1>Item Capsule<F3> is...an <F1>Energy Tank!");
         if(%r.Pack != Yes)
         {
            say(%p,199,"<F3>An <F1>Energy Tank<F3> resupplies and repairs part of your vehicle. You can activate it by <F0>scanning anything (no shut-down)<F3>, or by pressing <F0>Ctrl+D if you have the Hercboost keymap.<F3> This will also remove nano-leeches.","sfx_cmd.wav");
            %r.Pack = Yes;
            %r.Items++;
         }
         else
         {
            say(%p,199,"<F3>You already have an <F1>Energy Tank.","sfx_shieldcap_unready.wav");
         }
         say(%p,187,"<F4>If you have the <F3>Hercboost keymap<F4>, you can use <F3>Ctrl+S<F4> to the items you've collected.");
      }
      else if(%i<17)
      {
         //Ion Gun
         say(%p,198,"<F3>Inside the <F1>Item Capsule<F3> is...an <F1>Ion Shot!");
         if(%r.Ion != Yes)
         {
            say(%p,198,"<F3>An <F1>Ion Shot<F3> can only be used once but does devestating damage to your target. You can activate it by <F0>shutting down and scanning your target<F3> or <F0>spotting a vehicle using LTADs.","sfx_shield_on.wav");
            %r.Ion = Yes;
            %r.Items++;
         }
         else
         {
            say(%p,198,"<F3>You already have an <F1>Ion Shot.","sfx_shieldcap_unready.wav");
         }
         say(%p,187,"<F4>If you have the <F3>Hercboost keymap<F4>, you can use <F3>Ctrl+S<F4> to the items you've collected.");
      }
      if(%i<21)
      {
         //Supply Cache
         say(%p,%p,"<F3>Inside the <F1>Item Capsule<F3> is...a <F1>Supply Cache!");
         say(%p,%p,"<F3>A <F1>Supply Cache<F3> totally resupplies and repairs part of your vehicle. This will also remove nano-leeches.","sfx_reactorcap.wav");
         healObject(%v,99999;
         reloadObject(%v,1000);
         %r.Poison = No;
      }
      else if(%i<25)
      {
         //Poison Trap
         say(%p,197,"<F3>Inside the <F1>Item Capsule<F3> is...a <F5>Poison Trap!");
         say(%p,197,"<F5>You have been infected with nano-leeches. Your vehicle will slowly take damage untill you use a <F1>Supply Pack<F5> or find a <F1>Supply Cache.","sfx_cybrid_indust.wav");
         if(%r.Poison != Yes)
         {
            %r.Poison=Yes;
            checkPoison(%r,%p);
         }
      }
      else if(%i<28)
      {
         //Regen Armor
         say(%p,196,"<F3>Inside the <F1>Item Capsule<F3> is...<F1>Regen Armor!");
         if(%r.RArmor != Yes)
         {
            say(%p,196,"<F1>Regen Armor<F3> cures your vehicle of poison and gradually repairs your vehicle over time. Be careful though being poisoned while using <F1>Regen Armor<F3> will cancel both effects out!","sfx_cmd.wav");
            %r.RArmor = Yes;
            %r.Items++;
            if(%d.Healing != True)
            {
               %d.Healing = True;
            }
            checkRegen(%r);
         }
         else
         {
            say(%p,196,"<F3>You already have Regen Armor.","sfx_shieldcap_unready.wav");
         }
         say(%p,187,"<F4>If you have the <F3>Hercboost keymap<F4>, you can use <F3>Ctrl+S<F4> to the items you've collected.");
      }
      else if(%i<31)
      {
         //Poison Gun
         say(%p,195,"<F3>Inside the <F1>Item Capsule<F3> is...a <F1>Poison Add-on!");
         if(%r.Pgun != Yes)
         {
            say(%p,195,"<F3>A <F1>Poison Add-on<F3> allows you to 'poison' your enemy with nano-leeches simply by shooting them with any regular weapon. They will only affect the next person you attack, if that person has Regen Armor, both effects will cancel out.","sfx_cmd.wav");
            %r.Pgun = Yes;
            %r.Items++;
         }
         else
         {
            say(%p,195,"<F3>You already have an Poison Add-on.","sfx_shieldcap_unready.wav");
         }
         say(%p,187,"<F4>If you have the <F3>Hercboost keymap<F4>, you can use <F3>Ctrl+S<F4> to the items you've collected.");
      }
      else if(%i<32)
      {
         //Death Trap
         say(%p,194,"<F3>Inside the <F1>Item Capsule<F3> is...a <F5>Death Trap!","sfx_reactor_xplo.wav");
         %r.BlowUp = True;
         schedule("damageObject("@%r@",99999);",0.6);
      }
      else
      {
         //Warp Trap
         say(%p,193,"<F3>Inside the <F1>Item Capsule<F3> is...a <F5>Warp Trap!");
         say(%p,193,"<F3>You have been transported to another area...","teleporter.wav");
         fadeEvent(%p,in,0.5,0,0,0);
         %x=randomInt(-2500,2500);
         %y=randomInt(-2500,2500);
         setPosition(%r,%x,%y,getTerrainHeight(%x,%y));
      }
   }
   else
   {
      %p=playermanager::vehicleIdToPlayerNum(%r);
      remotehoverswitch(%p);
   }
}


function remotehoverswitch(%p)
{
   %v=playermanager::playernumtovehicleid(%p);
   if(%v.Pack == Yes)
      {
         say(%p,192,"<F1>Vehicle resupplied.","sfx_reactorcap.wav");
         healObject(%v,5000);
         reloadObject(%v,1000);
         %v.Poison = No;
         %v.Pack = No;
         %r.Items--;
      }
}

function structure::onspot(%r,%d)
{
   %p=playermanager::vehicleIdToPlayerNum(%r);
   remotehoverswitch(%p);
}

function vehicle::onspot(%r,%d)
{
   %p1 = playermanager::vehicleIdtoPlayerNum(%r);
   %p2 = playermanager::vehicleIdtoPlayerNum(%d);
   if(%r.Ion==Yes)
   {
      if($server::Teamplay==false)
      {
         if(%d!="")
         {
            fireIon(%p1,%p2,%r,%d);
         }
      }
      else if(($server::TeamPlay == true)&&(getTeam(%r)!=getTeam(%d)))
      {
         if(%d!="")
         {
            fireIon(%p1,%p2,%r,%d);
         }
      }
      else
      {
         say(%player,%player,"<F3>You cannot fire on your own team!");
      }
   }
   else
   {
      say(%p1,%p1,"<F3>You do not have an Ion Shot.");
   }
}

function vehicle::onscan(%d,%r)
{
   %p = playerManager::vehicleIdToPlayerNum(%r);
   if(isShutDown(%r) == True)
   {
      vehicle::onspot(%r,%d);
   }
   else
   {
      remoteHoverSwitch(%p);
   }
}

function fireIon(%p1,%p2,%r,%d)
{
   %d.killer=%p1;
   %r.Ion=No;
   %r.Items--;
   %x1=getposition(%r,x);
   %y1=getposition(%r,y);
   %z1=getposition(%r,z)+10;
   %x2=getposition(%d,x);
   %y2=getposition(%d,y);
   %z2=getposition(%d,z);
   droppod(%x1,%y1,%z1,%x2,%y2,%z2);
   %i=getdistance(%r,%d);%t=%i/400;
   schedule("damagearea("@%d@",0,0,0,150,1000);",%t);
   schedule("playSound(%p2,\"sfx_fog.wav\",IDPRF_2D);",%t-0.4);
   playSound(%r,"sfx_shrk.wav",IDPRF_2D);
}

function vehicle::onattacked(%d,%r)
{
   limitMissiles(%d,%r); //If missle boat limiting on, Powiofav.txt
   if((%d != %r)&&(%d.Poison != Yes)&&(%r.Pgun == Yes))
   {
      if(($server::TeamPlay == true)&&(getTeam(%r)!=getTeam(%d)))
      {
         %p1=playermanager::vehicleIdToPlayerNum(%r);
         %p2=playermanager::vehicleIdToPlayerNum(%d);
         if(%d.Armor == Yes)
         {
            say(%p1,%p1,"<F0>"@getName(%d)@"<F3> was carring <F1>Regen Armor<F3>, however both effects have cancelled out.");
            say(%p2,191,"<F5>You were hit by <F0>"@getName(%r)@"<F5>'s Poison Add-on! However, your Regen Armor cancelled the attack and was destroyed in the process.");
            %d.Armor = No;
            %r.PGun = No;
         }
         else
         {
            say(%p1,%p1,"<F3>You have poisoned <F0>"@getName(%d)@"<F3>'s vehicle with nano-leeches!");
            say(%p2,191,"<F5>You have been poisoned by <F0>"@getName(%r)@"<F5>'s Poison Add-on! Your vehicle will slowly take damage untill you use a supply pack or find a supply cache. Repair pads cannot cure you.","sfx_cybrid_indust.wav");
            %d.Poison = Yes;
            %r.PGun = No;
            checkPoison(%d,%p2);
         }
      }
      else if($server::TeamPlay == false)
      {
         %p1=playermanager::vehicleIdToPlayerNum(%r);
         %p2=playermanager::vehicleIdToPlayerNum(%d);
         say(%p1,%p1,"<F3>You have poisoned <F0>"@getName(%d)@"<F3>'s vehicle with nano-leeches!");
         say(%p2,191,"<F5>You have been poisoned by <F0>"@getName(%r)@"<F5>'s Poison Add-on! Your vehicle will slowly take damage untill you use a supply pack or find a supply cache. Repair pads cannot cure you.","sfx_cybrid_indust.wav");
         %d.Poison = Yes;
         if(%d.Poisoning != True)
         {
            %d.Poisoning = True;
         }
         checkPoison(%d,%p2);
      }
   }
}

function checkPoison(%v,%p)
{
   if((%v.Poison==Yes)&&(%v.Poisoning == True))
   {
         healObject(%v,-600);
         fadeevent(%p,in,0.1,0.6,0,0);
         schedule("checkPoison("@%v@","@%p@");",5);
   }
   else
   {
      %v.Poisoning = False;
   }
}

function checkRegen(%v)
{
   if((%v.Armor==Yes)&&(%v.Healing == True))
   {
         healObject(%v,600);
         schedule("checkRegen("@%v@");",5);
   }
   else
   {
      %v.Healing = False;
   }
}

function vehicle::onDestroyed(%d,%r)
{
   %p1=playermanager::vehicleIdToPlayerNum(%r);
   %p2=playermanager::vehicleIdToPlayerNum(%d);
   makeGrave(%d,%r); //If graves on, Powiofav.txt
   %d.Pack=No;
   %d.Ion=No;
   %d.Pgun=No;
   %d.Armor=No;
   %d.Poison=No;
   vehicle::onDestroyedLog(%d,%r);
   if((%r == %d)||(%r == -1))
   {
      if(%d.BlowUp==True)
      {
         %i = randomInt(0,2);
         if(%i == 0)
         {
            say(0,190,"<F1>"@getName(%p2)@"<F3> felt a little too lucky and ended up finding a <F5>Death Trap.");
         }
         else if(%i == 1)
         {
            say(0,190,"<F1>"@getName(%p2)@"<F3> was destroyed by a <F5>Death Trap.");
         }
         else if(%i == 2)
         {
            say(0,190,"<F1>"@getName(%p2)@"<F3> never knew there was a <F5>Death Trap<F3> in that Item Capsule.");    
         }
      }
      else if(%d.killer != "")
      {
         echo(%d.killer);
         %i = randomInt(0,2);
         if(%i == 0)
         {
            say(0,190,"<F1>"@getName(%d.killer)@"<F3>'s Ion Shot annihilated <F1>"@getName(%p2)@".");
         }
         else if(%i == 1)
         {
            say(0,190,"<F1>"@getName(%p2)@" was destroyed by <F1>"@getName(%d.killer)@"'s Ion Shot.");
         }
         else if(%i == 2)
         {
            say(0,190,"<F1>"@getName(%p2)@" couldn't escape the power of <F1>"@getName(%d.killer)@"'s Ion Shot until it was too late.");    
         }
      }
      else
      {
         %m=getFancyDeathMessage(getHUDName(%d),getHUDName(%r));
         if(%m != "")
         {
            say( 0, 0, %m);
         }
      }
   }
   else
   {   
      %m=getFancyDeathMessage(getHUDName(%d),getHUDName(%r));
      if(%m != "")
      {
         say(0,0, %m);
      }
      if(($server::TeamPlay == true)&&(getTeam(%d) == getTeam(%r))&&(%d != %r))
      {
            antiTeamKill(%r);
      }   
   }
   %d.killer="";
   %d.BlowUp="";
   %d.Items=0;
   say(%p2,189,"<F4>You lost all your items.");
}

function remoteboostswitch(%p)
{
   %v = playermanager::playerNumToVehicleId(%p);
   say(%p,188,"<F6>You are carrying:");
   if(%v.Items > 0)
   {
      if(%v.Pack == Yes)
      {
         say(%p,188,"<F3>An <F1>Energy Tank");
      }
      if(%v.Ion == Yes)
      {
         say(%p,188,"<F3>An <F1>Ion Shot");
      }
      if(%v.PGun == Yes)
      {
         say(%p,188,"<F3>A <F1>Poison Add-on");
      }
      if(%v.RArmor == Yes)
      {
         say(%p,188,"<F1>Regen Armor");
      }
   }
   else
   {
      %SBtV = randomInt(1,64);
      if(%SBtV == 64)
      {
         //"Space Balls the Video" Easter Egg
         say(%p,188,"<F0><<Voice = \"<F2>Dark Helmet<F0>\"> <F3>Absolutely Nothing!");
      }
      else
      {
         say(%p,188,"<F3>Nothing");
      }
   }
}
  
PowiUp();