// FILENAME: RACE_WC_Bristol.cs
//
// TRACK CREATOR: Com. Sentinal [M.I.B.]
//
// Original NASHERC Racing script created by Com. Sentinal [M.I.B.].
//------------------------------------------------------------------------------ 

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("NASHERCstdLib.cs");

//Fill out these global variables before you make a custom race track!!!
//------------------------------------------------------------------------------
$missionName = "Bristol Motor Speedway"; //Track Name

//Different series allow different vehicles, weapons, components,
//mass limits, and tech mixing options.
//Keep the series name & abbreviation the same if you don't want 
//to change the current restrictions.
//If you want to change the series, merely change the series name
//and abbreviation to one of the following:
//
//1.  "Winston Cup" & "WC"        //Allows Emans, Goads, Talons, & Seekers
//2.  "Busch" & "BSH"             //Allows Knight's Apocs (turbines)
//3.  "Seeker" & "SK"             //Allows Seekers (turbines & rockets)
//4.  "Craftsman Tank" & "TK"     //Allows Bolos, Preds, & Disrupters (turbines)
//5.  "Goad/Talon" & "GT"         //Allows Goads & Talons
//
//The script will automatically recognize the series name you chose
//and will use its restriction settings in the game.

$Series = "Winston Cup";  //Series name
$SeriesAbbreviation = "WC";  //Series Abbreviation

//The mission creator is used in the download message and in other areas of the script.
//The download message is used if you have any custom message you would 
//like to add when a player joins the game.

$missionCreator = "Com. Sentinal [M.I.B.]";
$downloadMessage = "You can download this & other missions made by " @ $missionCreator @ " in the \"MIB Map Packs\" on the MIB Website at www.starsiegemeninblack.cjb.net.";

//These are the coordinates where you respawn if you die during the race.
//You always start at the last checkpoint you crossed.
//Be sure to fill these out if you're making a custom track.
//------------------------------------------------------------------------------

//Checkpoint #1 coordinates
$checkpoint1x = -191.844; //Checkpoint #1 x coordinate
$checkpoint1y = 829.709;  //Checkpoint #1 y coordinate
$checkpoint1z = 114;  //Checkpoint #1 z coordinate
$checkpoint1rot = 180;  //Checkpoint #1 rotation coordinate (degrees)

//Checkpoint #2 coordinates
$checkpoint2x = -189.988;  //Checkpoint #2 x coordinate
$checkpoint2y = 201.014;  //Checkpoint #2 y coordinate
$checkpoint2z = 111;  //Checkpoint #2 z coordinate
$checkpoint2rot = 180;  //Checkpoint #2 rotation coordinate (degrees)

//Making a custom NASHERC RaceTrack
//------------------------------------------------------------------------------
//First, make sure you filled out all of the global variables above.
//
//The following is instructions on how to make a custom race track in the
//Starsiege Mission Editor:
//
//#1 - First you must have a track built that is fully enclosed and has
//a pit road. Make sure that the pit road is placed so that it doesn't
//become a short-cut. I recommend that your pit road contain 2-3 zen pads.
//Make sure that your Zen pad triggers have the script class "ZenAll".
//
//#2 - Next, you must place certain triggers around the track.
//VERY IMPORTANT: Make sure that all of the triggers in the map have
//"Is Sphere" disabled. IF they DO NOT have it disabled, then errors in 
//lap scoring WILL occur. The following is a list of the triggers that 
//you need and where they must be placed in order to work correctly. 
//The name of each trigger refers to the script class that must be used:
//
//    A. - The "finishline" trigger should be placed at the start/finish line.
//    B. - The "checkpoint1" trigger should be placed 1/3 of the way around
//         the track.
//    C. - The "checkpoint2" trigger should be placed 2/3 of the way around
//         the track.
//    D. - The "pitroad" trigger should be placed at the beginning of pit road.
//    E. - The "exitpitroad" trigger should be placed at the end of pit road.
//
//#3 - Next, you must make a folder in Missiongroup called "StartGates".
//Inside that folder, you must put in 2 bridges. Name one of them "StartGate"
//and name the other one "BackWall". Make sure that their script class is
//named this as well as their object names. Rotate the bridges so that they
//become walls. Place the one called "StartGate" right before the
//"finishline" trigger. Make sure that you allow enough space between the
//"startGate" wall and the "finishline" trigger. Then, lower the "StartGate"
//wall into the ground so that a herc can see over it. Next, place the
//"BackWall" wall about 100-150 meters behind the "StartGate" wall. Leave
//the "BackWall" wall high, so that nothing can see over it.
//
//#4 - Next, place 10 deathmatch drop points between the "StartGate" & the
//"Backwall".
//
//#5 - Finally, get the coordinates for the checkpoint triggers & write them
//in their proper location at the top of the script.
//
//Now, your custom NASHERC RaceTrack should work perfectly IF you followed
//the directions above for making the track & filled in the global variables
//at the top of the script.
//------------------------------------------------------------------------------


//If you want to customize your map's script in any way, modify the
//provided functions below.
//------------------------------------------------------------------------------

function NashercOnMissionStart()
{
   marsSounds();
}

function NashercOnMissionLoad()
{
   cdAudioCycle("CloudBurst", "NewTech", "Mechsoul");
}

function NashercPlayerOnAdd(%player)
{
   //Blank function
}

function NashercPlayerOnRemove(%player)
{
   //Blank function
}

function NashercVehicleOnAdd(%vehicleId)
{
   //Blank function
}

function NashercVehicleOnAttacked(%attacked, %attacker)
{
   //Blank function
}

function NashercVehicleOnDestroyed(%destroyed, %destroyer)
{
   //Blank function
}


//Extra optional functions (for advanced scripters)
//These functions are run whenever certain NASHERC race-related events occur.
//------------------------------------------------------------------------------

function NashercOnStartCountdown()
{
   //Blank function
}

function NashercOnStartRace()
{
   //Blank function
}

function NashercOnFinishRace()
{
   //Blank function
}

function NashercCheckpoint1OnArrived(%trigger, %vehicleId)
{
   //Blank function
}

function NashercCheckpoint2OnArrived(%trigger, %vehicleId)
{
   //Blank function
}

function NashercFinishLineOnArrived(%trigger, %vehicleId)
{
   //Blank function
}

function NashercPitRoadOnEnter(%trigger, %vehicleId)
{
   //Blank function
}

function NashercPitRoadOnLeave(%trigger, %vehicleId)
{
   //Blank function
}