// FILENAME:	SS_Mega_Arena.cs v1.02
//
// AUTHORS:  	Gen. Powio [MIB]
//------------------------------------------------------------------------------
// Defaulting Rules (Do not disable all of one group for what ever reason!)
// Please use True/False

      $FountainDisabled = False;

      $MatchTypeDisabled1 = False; // 1 vs 1
      $MatchTypeDisabled2 = False; // 3-Way
      $MatchTypeDisabled3 = False; // 4-Way
      $MatchTypeDisabled4 = False; // Royal Rumble
      $MatchTypeDisabled5 = False;  // Team Skirmish

      $ArenaDisabled1 = False;     // Open
      $ArenaDisabled2 = False;     // City
      $ArenaDisabled3 = False;     // 4-Corners
      $ArenaDisabled4 = False;     // Complex
      $ArenaDisabled5 = False;     // Minefield

      $PadsDisabled1 = False;      // No
      $PadsDisabled2 = False;      // Yes

      $DefaultMatchType = 1;       // Set Default Match Type (1-5)
      $DefaultArena = 1;           // Set Default Arena (1-5)
      $DefaultPads = 1;            // Set Pads Enabled (1-2)

$missionName = "SS_Mega_Arena";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = false;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
	marsSounds();
}

function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $zenWaitTime, true); 
}

function NDoor::Trigger::onContact(%t,%v)
{
   %v.InDoor = True;
   if($LockDoors != True)
   {
      playAnimSequence($NDoor1,0,true);
      playAnimSequence($NDoor2,0,true);
   }
}

function NDoor::Trigger::onLeave(%t,%v)
{
   %v.InDoor = "";
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if($LockDoors != True)
   {
      playAnimSequence($NDoor1,0,false);
      playAnimSequence($NDoor2,0,false);
   }
   if((%p.Player == True)&&($MatchStatus == InProgress)&&(%v.InArena != True))
   {
      %v.Hurt = Arena;
      damageObject(%v,999999);
   }
}

function WDoor::Trigger::onContact(%t,%v)
{
   %v.InDoor = True;
   if($LockDoors != True)
   {
      playAnimSequence($WDoor1,0,true);
      playAnimSequence($WDoor2,0,true);
   }
}

function WDoor::Trigger::onLeave(%t,%v)
{
   %v.InDoor = "";
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if($LockDoors != True)
   {
      playAnimSequence($WDoor1,0,false);
      playAnimSequence($WDoor2,0,false);
   }
   if((%p.Player == True)&&($MatchStatus == InProgress)&&(%v.InArena != True))
   {
      say(0,1,getName(%p)@" fell out of the arena!");
      damageObject(%v,999999);
   }
}

function SDoor::Trigger::onContact(%t,%v)
{
   %v.InDoor = True;
   if($LockDoors != True)
   {
      playAnimSequence($SDoor1,0,true);
      playAnimSequence($SDoor2,0,true);
   }
}

function SDoor::Trigger::onLeave(%t,%v)
{
   %v.InDoor = "";
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if($LockDoors != True)
   {
      playAnimSequence($SDoor1,0,false);
      playAnimSequence($SDoor2,0,false);
   }
   if((%p.Player == True)&&($MatchStatus == InProgress)&&(%v.InArena != True))
   {
      say(0,1,getName(%p)@" fell out of the arena!");
      damageObject(%v,999999);
   }
}

function EDoor::Trigger::onContact(%t,%v)
{
   %v.InDoor = True;
   if($LockDoors != True)
   {
      playAnimSequence($EDoor1,0,true);
      playAnimSequence($EDoor2,0,true);
   }
}

function EDoor::Trigger::onLeave(%t,%v)
{
   %v.InDoor = "";
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if($LockDoors != True)
   {
      playAnimSequence($EDoor1,0,false);
      playAnimSequence($EDoor2,0,false);
   }
   if((%p.Player == True)&&($MatchStatus == InProgress)&&(%v.InArena != True))
   {
      say(0,1,getName(%p)@" fell out of the arena!");
      damageObject(%v,999999);
   }
}

function Arena::Trigger::onEnter(%t,%v)
{
   %v.InArena = True;
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if((%p.Player == True)&&($MatchStatus != InProgress))
   {
      if(%p == $Competitor1)
      {
         setPosition(%v,8352,-232,101);
      }
      else if(%p == $Competitor2)
      {
         setPosition(%v,8352,-792,101);
      }
      else if(%p == $Competitor3)
      {
         setPosition(%v,8072,-512,101);
      }
      else if(%p == $Competitor4)
      {
         setPosition(%v,8632,-512,101);
      }
   }
}

function Arena::Trigger::onContact(%t,%v)
{
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if(($MatchStatus != "")&&(%p.Player != True))
   {
      redrop(%v);
   }
}

function Arena::Trigger::onLeave(%t,%v)
{
   %v.InArena = "";
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if((%p.Player == True)&&($MatchStatus == InProgress))
   {
      say(0,0,getName(%p)@" fell out of the arena!");
      damageObject(%v,999999);
   }
}

function NoEntry::Trigger::onEnter(%t,%v)
{
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if((%p.Player != True)&&($MatchStatus != ""))
   {
      reDrop(%v);
   }
}


function Fountain::Structure::onScan()
{
   if($fountainDisabled != True)
   {
      if($fountainOn == False)
      {
         $fountainOn = Water;
         splash();
      }
      else if($fountainOn == Water)
      {
         $fountainOn = Fire;
      }
      else if($fountainOn == Fire)
      {
         $fountainOn = Earth;
      }
      else if($fountainOn == Earth)
      {
         $fountainOn = Air;
      }
      else
      {
         $fountainOn = False;
      }
   }
}

function splash()
{
   if($fountainOn == Water)
   {
      storeObject($Water,"CopyObject.tmp");
      %o1 = loadObject("SplashWater","CopyObject.tmp");
      %o2 = loadObject("SplashWater","CopyObject.tmp");
      setPosition(%o1,8448,-160,149,randomInt(0,360));
      setPosition(%o2,8256,-160,149,randomInt(0,360));
      schedule("damageObject("@%o1@",99999);",0.1);
      schedule("damageObject("@%o2@",99999);",0.1);
      schedule("deleteObject("@%o1@");",0.3);
      schedule("deleteObject("@%o2@");",0.3);
      schedule("splash();",0.5);
   }
   else if($fountainOn == Fire)
   {
      storeObject($Fire,"CopyObject.tmp");
      %o1 = loadObject("SplashWater","CopyObject.tmp");
      %o2 = loadObject("SplashWater","CopyObject.tmp");
      setPosition(%o1,8448,-160,149,randomInt(0,360));
      setPosition(%o2,8256,-160,149,randomInt(0,360));
      schedule("damageObject("@%o1@",99999);",0.1);
      schedule("damageObject("@%o2@",99999);",0.1);
      schedule("deleteObject("@%o1@");",0.3);
      schedule("deleteObject("@%o2@");",0.3);
      schedule("splash();",0.5);
   }
   else if($fountainOn == Earth)
   {
      storeObject($Earth,"CopyObject.tmp");
      %o1 = loadObject("SplashWater","CopyObject.tmp");
      %o2 = loadObject("SplashWater","CopyObject.tmp");
      setPosition(%o1,8448,-160,152,randomInt(0,360));
      setPosition(%o2,8256,-160,152,randomInt(0,360));
      schedule("damageObject("@%o1@",99999);",0.1);
      schedule("damageObject("@%o2@",99999);",0.1);
      schedule("deleteObject("@%o1@");",0.3);
      schedule("deleteObject("@%o2@");",0.3);
      schedule("splash();",0.5);
   }
   else if($fountainOn == Air)
   {
      storeObject($Air,"CopyObject.tmp");
      %o1 = loadObject("SplashWater","CopyObject.tmp");
      %o2 = loadObject("SplashWater","CopyObject.tmp");
      setPosition(%o1,8448,-160,149,randomInt(0,360));
      setPosition(%o2,8256,-160,149,randomInt(0,360));
      schedule("damageObject("@%o1@",99999);",0.1);
      schedule("damageObject("@%o2@",99999);",0.1);
      schedule("deleteObject("@%o1@");",0.3);
      schedule("deleteObject("@%o2@");",0.3);
      schedule("splash();",0.5);
   }
}

function Call::Trigger::OnEnter(%t,%v)
{
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if((%p > 2048)&&(%p.Disabled < 1)&&($MatchStatus == ""))
   {
      %c = playerManager::getPlayerCount();
      for(%i=0;%i<%c;%i++)
      {
         %p1 = playerManager::getPlayerNum(%i);
         %v1 = playerManager::playerNumToVehicleId(%p1);
         if(%v1.InDoor == True)
         {
            %v1.InDoor = "";
            redrop(%v1);
         }
      }
      destroyArena();
      $Caller = %p;
      %p.Player = True;
      $LockDoors = True;
      $Opponents = 0;
      $BlueTeam = 0;
      $PurpleTeam = 0;
      $Opponents++;
      $Competitor1 = %p;
      playAnimSequence($NDoor1,0,false);
      playAnimSequence($NDoor2,0,false);
      playAnimSequence($WDoor1,0,false);
      playAnimSequence($WDoor2,0,false);
      playAnimSequence($SDoor1,0,false);
      playAnimSequence($SDoor2,0,false);
      playAnimSequence($EDoor1,0,false);
      playAnimSequence($EDoor2,0,false);
      $arena = %p.Arena;
      $pads = %p.Pads;
      if(%p.MatchType < 4)
      {
         callMatchFFA(%p,%v);
      }
      else if(%p.MatchType == 4)
      {
         callMatchRR(%p,%v);
      }
      else if(%p.MatchType == 5)
      {
         callMatchTS(%p,%v);
      }
      createArena();
      say(0,0,"Match Type: <F4>"@$matchTypeName[%p.MatchType]@"\n<F0>Arena: <F4>"@$arenaName[%p.arena]@"\n<F0>Pads: <F4>"@$YesNo[%p.Pads]);
      setHudTimer($Time,-1,getName(%p)@": "@$matchTypeName[%p.MatchType],1);
      $Time++;
      countdown();
   }
   else
   {
      JoinUp(%p,%v);
   }
}

function callMatchFFA(%p,%v)
{
   say(0,99,getName(%p)@"<F5> is calling a match! Step through the main gate to join.","bptslct.wav");
   $matchType = %p.MatchType;
   $Time = 60;
   $MatchStatus = Waiting;
   $OpponentsNeeded = $matchType + 1;
   setPosition(%v,8352,-232,101);
}

function callMatchRR(%p,%v)
{
   say(0,99,getName(%p)@"<F5> is calling for a Royal Rumble! Step through the main gate to join.","sfx_cybrid_alarm.wav");
   $matchType = %p.MatchType;
   $Time = 120;
   $MatchStatus = Waiting;
   $OpponentsNeeded = $matchType + 1;
}

function callMatchTS(%p,%v)
{
   say(0,99,getName(%p)@"<F5> is calling a Team Skirmish! Step through the main gate to join. (Teams will alternate)","bptslct.wav");
   say(0,0,getName(%p)@"<F4> is on <F1>Blue Team.");
   $BlueTeam++;
   $matchType = %p.MatchType;
   $Time = 60;
   $MatchStatus = Waiting;
}

function JoinUp(%p,%v)
{
   if((%p.Player != True)&&(%p.Disabled < 1)&&($MatchStatus == Waiting)&&($MatchType < 4))
   {
      say(0,0,getName(%p)@"<F0> has joined the match!");
      $Opponents++;
      for(%i=1;%i<17;%i++)
      {
         if(($Competitor[%i] == "")&&(%p.Player != True))
         {
            $Competitor[%i] = %p;
            %p.Player = True;
         }
      }
      if($MatchType < 4)
      {
         if(%p == $Competitor2)
         {
            setPosition(%v,8352,-792,101);
         }
         else if(%p == $Competitor3)
         {
            setPosition(%v,8072,-512,101);
         }
         else if(%p == $Competitor4)
         {
            setPosition(%v,8632,-512,101);
         }
      }
      checkForCompetitors();
   }
   else if((%p.Player != True)&&(%p.Disabled < 1)&&($MatchStatus == Waiting)&&($MatchType == 4))
   {
      $Opponents++;
      say(0,0,getName(%p)@"<F0> has joined the Royal Rumble! (<F1>"@$Opponents@"<F0>)");
      for(%i=1;%i<17;%i++)
      {
         if(($Competitor[%i] == "")&&(%p.Player != True))
         {
            $Competitor[%i] = %p;
            %p.Player = True;
         }
      }
      checkForCompetitors();
   }
   else if(($Caller == %p)&&($MatchStatus == Waiting)&&($MatchType > 3))
   {
      if(($Opponents >= 5)||(($BlueTeam > 0)&&($PurpleTeam > 0)))
      {
         if($MatchType == 4)
         {
            say(0,99,getName(%p)@"<F0> is starting the match!<F5> Let's get ready to rumble...","bptslct.wav");
         }
         else if($MatchType == 5)
         {
            say(0,99,getName(%p)@"<F0> is starting the match!<F5> Get ready to fight...","bptslct.wav");
         }
         $Time = 30;
         readyRumble();
      }
      else
      { 
         say(%p,0,"<F4>There are not yet enough competitors to start the match.");
      }
   }
   else if((%p.Player != True)&&(%p.Disabled < 1)&&($MatchStatus == Waiting)&&($MatchType == 5))
   {
      for(%i=1;%i<17;%i++)
      {
         if(($Competitor[%i] == "")&&(%p.Player != True))
         {
            if((%i == 3)||(%i == 5)||(%i == 7))
            {
               $BlueTeam++;
               say(0,0,getName(%p)@"<F0> has joined the Team Skirmish! (<F1>Blue Team<F0>)");
            }
            else
            {
               $PurpleTeam++;
               say(0,0,getName(%p)@"<F0> has joined the Team Skirmish! (<F2>Purple Team<F0>)");
            }
            $Competitor[%i] = %p;
            %p.Player = True;
         }
      }
      checkForCompetitors();
   }
}

function checkForCompetitors()
{
   if(($MatchType < 4)&&($Opponents == $OpponentsNeeded))
   {
      say(%p,99,"<F5>The match is now closed!","bptslct.wav");
      $MatchStatus = Ready;
      $Time = 30;
      setHudTimer(-1,-1,"",1);
      setHudTimer($Time,-1,"Match will begin in...",1);
      %c = playerManager::getPlayerCount();
      for(%i=0;%i<%c;%i++)
      {
         %p = playerManager::getPlayerNum(%i);
         %v = playerManager::playerNumToVehicleId(%p);
         if(%p.Player == True)
         {
            setTeam(%v,*IDSTR_TEAM_RED);
            say(%p,0,"<F4>You can quit this match now without suffering a loss by scanning the white Quit Match button.");
         }
      }
   }
   else if(($MatchType == 4)&&($Opponents == $OpponentsNeeded))
   {
      say($Caller,0,"<F4>There are now enough competitors to start the match. You may keep waiting for more competitors or start the match now by entering through the main gate.");
   }
   else if(($MatchType == 4)&&($Opponents == 16))
   {
      say(0,99,"The arena is full!<F5> Let's get ready to rumble...","bptslct.wav");
      $Time = 30;
      readyRumble();
   }
   else if(($MatchType == 5)&&($BlueTeam == 4)&&($ReadTeam == 4))
   {
      say(0,99,"The arena is full!<F5> Get ready to fight...","bptslct.wav");
      $Time = 30;
      readyRumble();
   }
}

function readyRumble()
{
   $MatchStatus = Ready;
   setHudTimer(-1,-1,"",1);
   setHudTimer($Time,-1,"Match will begin in...",1);
}

function countdown()
{
   if($Time > 0)
   {
      $Time--;
   }
   if($Time == 0)
   {
      if(($MatchStatus == Waiting))
      {
         %p = $Caller;
         %v = playerManager::playerNumToVehicleId(%p);
         if(($MatchType == 4)&&($Opponents >= 5))
         {
            say(0,99,"Time Up!<F5> Let's get ready to rumble...","bptslct.wav");
            $Time = 30;
            countDown();
            readyRumble();
         }
         else if(($MatchType == 5)&&($BlueTeam > 0)&&($PurpleTeam > 0))
         {
            say(0,99,"Time Up!<F5> Get ready to fight...","bptslct.wav");
            $Time = 30;
            countDown();
            readyRumble();
         }
         else
         {
            cancelMatch();
         }
      }
      else if($MatchStatus == Ready)
      {
         $MatchStatus = InProgress;
         $Time = 300;
         setHudTimer(-1,-1,"",1);
         setHudTimer($Time,-1,"Match Time Left",1);
         $Time++;
         countdown();
         %c = playerManager::getPlayerCount();
         for(%i=0;%i<%c;%i++)
         {
            %p = playerManager::getPlayerNum(%i);
            %v = playerManager::playerNumToVehicleId(%p);
            if(%p.Player == True)
            {
               healObject(%v,999999);
               healObject(%v,999999);
               healObject(%v,999999);
               healObject(%v,999999);
               healObject(%v,999999);
               reloadObject(%v,9999);
               if($MatchType != 5)
               {
                  setTeam(%v,*IDSTR_TEAM_RED);
               }
               else if(($Competitor1 == %p)||($Competitor3 == %p)||($Competitor5 == %p)||($Competitor7 == %p))
               {
                  setTeam(%v,*IDSTR_TEAM_BLUE);
               }
               else
               {
                  setTeam(%v,*IDSTR_TEAM_PURPLE);
               }
               arenaSpawn(%p,%v);
            }
         }
         say(0,99,"<F5><jc>- <F0>Fight!<F5> -","sfx_fog.wav");
      }
      else if($MatchStatus == InProgress)
      {
         say(0,99,"Time Up!<F5> The match is a draw!","alarm2.wav");
         %c = playerManager::getPlayerCount();
         for(%i=0;%i<%c;%i++)
         {
            %p = playerManager::getPlayerNum(%i);
            %v = playerManager::playerNumToVehicleId(%p);
            if(%p.Player == True)
            {
               setTeam(%v,*IDSTR_TEAM_YELLOW);
               $MatchStatus = "";
               $LockDoors = "";
               healObject(%v,999999);
               healObject(%v,999999);
               healObject(%v,999999);
               healObject(%v,999999);
               healObject(%v,999999);
               reloadObject(%v,9999);
               if($MatchType != 4)
               {
                  %p.Draws++;
               }
               %p.Player = "";
               $Caller = "";
            }
         }
         for(%i=1;%i<17;%i++)
         {
            $Competitor[%i] = "";
         }
      }
   }
   else
   {
      schedule("countDown();",1);
   }
}

function arenaSpawn(%p,%v)
{
   if(($Competitor1 == %p)&&($MatchType < 4))
   {
      setPosition(%v,8352,-272,101);
   }
   else if(($Competitor1 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8480,-272,101);
   }
   else if(($Competitor1 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8480,-288,101);
   }
   else if(($Competitor2 == %p)&&($MatchType < 4))
   {
      setPosition(%v,8352,-752,101);
   }
   else if(($Competitor2 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8592,-512,101);
   }
   else if(($Competitor2 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8224,-736,101);
   }
   else if(($Competitor3 == %p)&&($MatchType < 4))
   {
      setPosition(%v,8112,-512,101);
   }
   else if(($Competitor3 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8352,-752,101);
   }
   else if(($Competitor3 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8400,-272,101);
   }
   else if(($Competitor4 == %p)&&($MatchType < 4))
   {
      setPosition(%v,8592,-512,101);
   }
   else if(($Competitor4 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8112,-512,101);
   }
   else if(($Competitor4 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8304,-736,101);
   }
   else if(($Competitor5 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8224,-272,101);
   }
   else if(($Competitor5 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8304,-288,101);
   }
   else if(($Competitor6 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8592,-384,101);
   }
   else if(($Competitor6 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8400,-736,101);
   }
   else if(($Competitor7 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8480,-752,101);
   }
   else if(($Competitor7 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8224,-288,101);
   }
   else if(($Competitor8 == %p)&&($MatchType == 4))
   {
      setPosition(%v,8112,-640,101);
   }
   else if(($Competitor8 == %p)&&($MatchType == 5))
   {
      setPosition(%v,8480,-736,101);
   }
   arenaSpawn2(%p,%v);
}

function arenaSpawn2(%p,%v)
{
   if($Competitor9 == %p)
   {
      setPosition(%v,8400,-272,101);
   }
   else if($Competitor10 == %p)
   {
      setPosition(%v,8592,-560,101);
   }
   else if($Competitor11 == %p)
   {
      setPosition(%v,8304,-752,101);
   }
   else if($Competitor12 == %p)
   {
      setPosition(%v,8112,-464,101);
   }
   else if($Competitor13 == %p)
   {
      setPosition(%v,8304,-272,101);
   }
   else if($Competitor14 == %p)
   {
      setPosition(%v,8592,-464,101);
   }
   else if($Competitor15 == %p)
   {
      setPosition(%v,8304,-752,101);
   }
   else if($Competitor16 == %p)
   {
      setPosition(%v,8112,-560,101);
   }
}

function cancelMatch::Structure::onScan(%d,%r)
{
   %p = playerManager::vehicleIdToPlayerNum(%r);
   cancelMatch(%p);
} 

function cancelMatch(%p)
{
   if((%p == "")&&($MatchStatus != "")&&($MatchStatus != InProgress))
   {
      %p = $Caller;
      %p.Disabled = 11;
      disableCount(%p);
      say(0,99,"Time expired. <F5>The match has been cancelled!","alarm2.wav");
      $MatchStatus = "";
      $LockDoors = "";
      $Time = 0;
      setHudTimer(-1,-1,"",1);
      %c = playerManager::getPlayerCount();
      for(%i=0;%i<%c;%i++)
      {
         %p = playerManager::getPlayerNum(%i);
         %v = playerManager::playerNumToVehicleId(%p);
         %p.Player = "";
         setTeam(%v,*IDSTR_TEAM_YELLOW);
      }
      $Caller = "";
      for(%i=1;%i<17;%i++)
      {
         $Competitor[%i] = "";
      }
   }
   else if(((%p.Player == True)&&($MatchStatus == Ready)&&($MatchType < 4))||((%p == $Caller)&&($MatchStatus != "")&&($MatchStatus != InProgress)))
   {
      %p.Disabled = 11;
      disableCount(%p);
      say(0,99,getName(%p)@"<F5> has cancelled the match!","alarm2.wav");
      $MatchStatus = "";
      $LockDoors = "";
      $Time = 0;
      setHudTimer(-1,-1,"",1);
      %c = playerManager::getPlayerCount();
      for(%i=0;%i<%c;%i++)
      {
         %p = playerManager::getPlayerNum(%i);
         %v = playerManager::playerNumToVehicleId(%p);
         %p.Player = "";
         setTeam(%v,*IDSTR_TEAM_YELLOW);
      }
      $Caller = "";
      for(%i=1;%i<17;%i++)
      {
         $Competitor[%i] = "";
      }
   }
   else if((%p.Player == True)&&(($MatchStatus == Waiting)||(($MatchStatus == Ready)&&($MatchType > 3))))
   {
      %p.Player = "";
      %v = playerManager::playerNumToVehicleId(%p);
      $Opponents--;
      if($MatchType == 4)
      {
         redrop(%v);
      }
      for(%i=1;%i<17;%i++)
      {
         if(%p == $Competitor[%i])
         {
            $Competitor[%i] = "";
            if(((%p == $Competitor1)||(%p == $Competitor3)||(%p == $Competitor5)||(%p == $Competitor7))&&($MatchType == 5))
            {
               $BlueTeam--;
            }
            else if($MatchType == 5)
            {
               $PurpleTeam--;
            }
         }
      }
      say(0,0,getName(%p)@"<F5> has quit the match!");
      if(((($Opponents < 5)&&($MatchType == 4))||(($MatchType == 5)&&(($BlueTeam < 1)||($PurpleTeam < 1))))&&($MatchStatus == Ready))
      {
         say(0,99,"<F5>The match has been cancelled! There are not enough competitors.","alarm2.wav");
         %p.Disabled = 11;
         disableCount(%p);
         $MatchStatus = "";
         $LockDoors = "";
         $Time = 0;
         setHudTimer(-1,-1,"",1);
         %c = playerManager::getPlayerCount();
         for(%i=0;%i<%c;%i++)
         {
            %p = playerManager::getPlayerNum(%i);
            %p.Player = "";
         }
         $Caller = "";
         for(%i=1;%i<17;%i++)
         {
            $Competitor[%i] = "";
         }
      }
   }
}

function disableCount(%p)
{
   if(%p.disabled > 0)
   {
      %p.disabled--;
      schedule("disableCount("@%p@");",1);
   }
}

function checkEliminated()
{
   %c = playerManager::getPlayerCount();
   for(%i=0;%i<%c;%i++)
   {
      %p = playerManager::getPlayerNum(%i);
      if((%p.Player == True)&&($Opponents == 1)&&($MatchType < 5))
      {
         %v = playerManager::playerNumToVehicleId(%p);
         say(0,0,"<F1>Game Set!<F0> This match's winner is... "@getName(%p)@"<F0>!");
         %p.player = "";
         setTeam(%v,*IDSTR_TEAM_YELLOW);
         $MatchStatus = "";
         $LockDoors = "";
         setHudTimer(-1,-1,"",1);
         $Time = 0;
         healObject(%v,999999);
         healObject(%v,999999);
         healObject(%v,999999);
         healObject(%v,999999);
         healObject(%v,999999);
         reloadObject(%v,9999);
         if($MatchType == 4)
         {
            %p.Rumbles++;
         }
         else
         {
            %p.Wins++;
         }         $Caller = "";
         for(%i=1;%i<17;%i++)
         {
            $Competitor[%i] = "";
         }
      }
   }
   if((($BlueTeam < 1)||($PurpleTeam < 1))&&($MatchType == 5))
   {
      if($BlueTeam < 1)
      {
         say(0,0,"<F1>Game Set!<F0> This match's winner is... <F2>Purple Team!");
      }
      else
      {
         say(0,0,"<F1>Game Set!<F0> This match's winner is... <F1>Blue Team!");
      }
      %c = playerManager::getPlayerCount();
      for(%i=0;%i<%c;%i++)
      {
         %p = playerManager::getPlayerNum(%i);
         %v = playerManager::playerNumToVehicleId(%p);
         %p.player = "";
         setTeam(%v,*IDSTR_TEAM_YELLOW);
         healObject(%v,999999);
         healObject(%v,999999);
         healObject(%v,999999);
         healObject(%v,999999);
         healObject(%v,999999);
         reloadObject(%v,9999);
      }
      $MatchStatus = "";
      $LockDoors = "";
      setHudTimer(-1,-1,"",1);
      $Time = 0;
      $Caller = "";
      for(%i=1;%i<17;%i++)
      {
         $Competitor[%i] = "";
      }
   }
}

function matchType::Structure::onScan(%d,%r)
{
   %p = playerManager::vehicleIdToPlayerNum(%r);
   if(%p.matchType == 5)
   {
      %p.matchType = 1;
   }
   else
   {
      %p.matchType++;
   }
   if($MatchTypeDisabled[%p.matchType] == True)
   {
      matchType::Structure::onScan(%d,%r);
   }
   else
   {
      say(%p,0,"Match Type: <F4>"@$matchTypeName[%p.matchType]);
   }
}

function arena::Structure::onScan(%d,%r)
{
   %p = playerManager::vehicleIdToPlayerNum(%r);
   if(%p.arena == 5)
   {
      %p.arena = 1;
   }
   else
   {
      %p.arena++;
   }
   if($ArenaDisabled[%p.arena] == True)
   {
      arena::Structure::onScan(%d,%r);
   }
   else
   {
      say(%p,0,"Arena: <F4>"@$arenaName[%p.arena]);
   }
}

function pads::Structure::onScan(%d,%r)
{
   %p = playerManager::vehicleIdToPlayerNum(%r);
   if(%p.pads == 2)
   {
      %p.pads = 1;
   }
   else
   {
      %p.pads++;
   }
   if($PadsDisabled[%p.pads] == True)
   {
      pads::Structure::onScan(%d,%r);
   }
   else
   {
      say(%p,0,"Pads: <F4>"@$YesNo[%p.pads]);
   }
}

function createArena()
{
   if($Arena == 1)
   {
         %o = newObject("Arena Prop",staticShape,"hMarsBigWall_3.dts");
         setPosition(%o,8352,-352,101,0);
         %o = newObject("Arena Prop",staticShape,"hMarsBigWall_3.dts");
         setPosition(%o,8512,-512,101,90);
         %o = newObject("Arena Prop",staticShape,"hMarsBigWall_3.dts");
         setPosition(%o,8352,-672,101,0);
         %o = newObject("Arena Prop",staticShape,"hMarsBigWall_3.dts");
         setPosition(%o,8192,-512,101,90);
      if($Pads == 2)
      {
         %o = newObject("Arena Prop",staticInterior,"hZenlite.dis");
         setPosition(%o,8352,-512,101,-180);
         storeObject($LargePadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8352,-512,104);
      }
   }
   else if($Arena == 2)
   {
         %o = newObject("Arena Prop",staticInterior,"hbigsand6d.dis");
         setPosition(%o,8192,-352,101,-90);
         %o = newObject("Arena Prop",staticInterior,"hbigsand1d.dis");
         setPosition(%o,8480,-352,101,-180);
         %o = newObject("Arena Prop",staticInterior,"hbigsand3d.dis");
         setPosition(%o,8192,-512,101,90);
         %o = newObject("Arena Prop",staticInterior,"hbigsand5d.dis");
         setPosition(%o,8320,-480,101,-90);
         %o = newObject("Arena Prop",staticInterior,"hbigsand5d.dis");
         setPosition(%o,8320,-576,101,-90);
         %o = newObject("Arena Prop",staticInterior,"hbigsand4d.dis");
         setPosition(%o,8480,-512,101,90);
         %o = newObject("Arena Prop",staticInterior,"hbigsand4d.dis");
         setPosition(%o,8192,-672,101,-90);
         %o = newObject("Arena Prop",staticInterior,"hbigsand3d.dis");
         setPosition(%o,8352,-672,101,0);
         %o = newObject("Arena Prop",staticInterior,"hbigsand1d.dis");
         setPosition(%o,8512,-640,101,90);
      if($Pads == 2)
      {
         storeObject($HercPad,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8320,-528,101.02);
         storeObject($SmallPadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8320,-528,103);
      }
   }
   else if($Arena == 3)
   {
         %o = newObject("Arena Prop",staticInterior,"hwallhuge.dis");
         setPosition(%o,8480,-384,101,0);
         %o = newObject("Arena Prop",staticInterior,"hwallhuge.dis");
         setPosition(%o,8480,-640,101,-90);
         %o = newObject("Arena Prop",staticInterior,"hwallhuge.dis");
         setPosition(%o,8224,-640,101,-180);
         %o = newObject("Arena Prop",staticInterior,"hwallhuge.dis");
         setPosition(%o,8224,-384,101,90);
         %o = newObject("Arena Prop",staticInterior,"hbigkong3t.dis");
         setPosition(%o,8352,-512,101,90);
      if($Pads == 2)
      {
         %o = newObject("Arena Prop",staticInterior,"hZenlite.dis");
         setPosition(%o,8496,-368,101,-180);
         storeObject($LargePadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8496,-368,104);
         %o = newObject("Arena Prop",staticInterior,"hZenlite.dis");
         setPosition(%o,8496,-656,101,90);
         storeObject($LargePadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8496,-656,104);
         %o = newObject("Arena Prop",staticInterior,"hZenlite.dis");
         setPosition(%o,8208,-656,101,0);
         storeObject($LargePadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8208,-656,104);
         %o = newObject("Arena Prop",staticInterior,"hZenlite.dis");
         setPosition(%o,8208,-368,101,-90);
         storeObject($LargePadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8208,-368,104);
      }
   }
   else if($Arena == 4)
   {
         %o = newObject("Arena Prop",staticInterior,"hbigluna5.dis");
         setPosition(%o,8352,-512,101,0);
      if($Pads == 2)
      {
         storeObject($HercPad,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8352,-320,133.02);
         storeObject($SmallPadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8352,-320,135);
         storeObject($HercPad,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8168,-512,133.02);
         storeObject($SmallPadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8168,-512,135);
         storeObject($HercPad,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8352,-696,133.02);
         storeObject($SmallPadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8352,-696,135);
         storeObject($HercPad,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8536,-512,133.02);
         storeObject($SmallPadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8536,-512,135);
      }
   }
   else if($Arena == 5)
   {
      if($Pads == 2)
      {
         %o = newObject("Arena Prop",staticInterior,"hZenlite.dis");
         setPosition(%o,8352,-512,101,-180);
         storeObject($LargePadTrigger,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,8352,-512,104);
         %PadAvailable = True;
      }
      for(%i=1;%i<26;%i++)
      {  if(%PadAvailable == True)
         {
            %r1 = randomInt(1,2);
            if(%r1 == 1)
            {
               %x = randomInt(8144,8560);
               %r2 = randomInt(1,2);
               if(%r2 == 1)
               {
                  %y = randomInt(-470,-304);
               }
               else
               {
                  %y = randomInt(-720,-554);
               }
            }
            else
            {
               %y = randomInt(-720,-304);
               %r2 = randomInt(1,2);
               if(%r2 == 1)
               {
                  %x = randomInt(8394,8560);
               }
               else
               {
                  %x = randomInt(8144,8310);
               }
            }
         }
         else
         {
            %x = randomInt(8144,8560);
            %y = randomInt(-720,-304);
         }
         storeObject($MineTrigger,"CopyObject2.tmp");
         %o1 = loadObject("Arena Prop","CopyObject2.tmp");
         storeObject($Mine,"CopyObject2.tmp");
         %o2 = loadObject("Arena Prop","CopyObject2.tmp");
         %o1.Mine = %o2;
         setPosition(%o1,%x,%y,101);
         setPosition(%o2,%x,%y,101);
      }
      for(%i=1;%i<5;%i++)
      {
         %x = randomInt(8228,8476);
         %y = randomInt(-636,-388);
         storeObject($Bomb,"CopyObject2.tmp");
         %o = loadObject("Arena Prop","CopyObject2.tmp");
         setPosition(%o,%x,%y,101);
      }
   }
}

function destroyArena()
{
   for(%i=0;%i<10000;%i++)
   {
      if(getObjectName(%i) == "Arena Prop")
      {
         setPosition(%i,0,0,0);
         deleteObject(%i);
      }
   }
}

function Mine::Trigger::onEnter(%t,%v)
{
   if(getTeam(%v) == "Red Team")
   {
      damageObject(%t.Mine,999999);
      schedule("setPosition("@%t@",0,0,0);",0.1);
      schedule("deleteObject("@%t@");",0.3);
      for(%i=0;%i<%c;%i++)
      {
         %p = playerManager::getPlayerNum(%i);
         %v = playerManager::playerNumToVehicleId(%p);
         if((%v > 1)&&(getDistance(%v,%t.Mine) <= 20))
         {
            fadeEvent(%p,in,0.5,1,0.7,0);
            %v.Hurt = Mine;
         }
      }
      damageArea(%t.Mine,0,0,0,20,1500);
   }
}

function Bomb::Structure::onDestroyed(%d,%r)
{
   storeObject($Shockwave,"CopyObject2.tmp");
   %o = loadObject("Shockwave","CopyObject2.tmp");
   setPosition(%o,getPosition(%d,x),getPosition(%d,y),101);
   schedule("setPosition("@%o@",0,0,0);",1);
   schedule("deleteObject("@%o@");",1.2);
   playSound(0,"sfx_fog.wav",IDPRF_2D);
   %c = playerManager::getPlayerCount();
   for(%i=0;%i<%c;%i++)
   {
      %p = playerManager::getPlayerNum(%i);
      %v = playerManager::playerNumToVehicleId(%p);
      if((%v > 1)&&(getDistance(%v,%d) <= 100))
      {
         fadeEvent(%p,in,0.5,1,0.7,0);
         %v.Hurt = Bomb;
      }
   }
   damageArea(%d,0,0,0,100,4500);
}

function onMissionLoad()
{
   setGameInfo("<F2>Welcome to the Starsiege Mega Arena!\n <F1>Welcome to the Starsiege Mega Arena!\n\n<F3>Here you will be able to compete against other players in several events such as:\n\n<F4> One vs One\n 3-Way Elimination\n 4-Way Elimination\n Royal Rumble\n Mini Team Skirmish\n\n<F0>You can set your personalized rules at the control panel in front of the arena.\nTo start or join a match, enter through the main gate.\n\n<F0>You can download this & other missions made by Gen. Powio [MIB] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   $healRate = 100; // Per 0.1 Sec - Low Rate used to keep people from pad-camping to a draw.
   $ammoRate = 1;
   $padWaitTime = 0;
   $zenWaitTime = 45;
   $LockDoors = "";
   $Caller = "";
   $MatchStatus = "";

   $MatchTypeName1 = "1 vs 1";
   $MatchTypeName2 = "3-Way";
   $MatchTypeName3 = "4-Way";
   $MatchTypeName4 = "Royal Rumble";
   $MatchTypeName5 = "Team Skirmish";

   $ArenaName1 = "Open";
   $ArenaName2 = "City";
   $ArenaName3 = "4 Corners";
   $ArenaName4 = "Complex";
   $ArenaName5 = "Minefield";

   $YesNo1 = "No";
   $YesNo2 = "Yes";

   %c = playerManager::getPlayerCount();
   for(%i=0;%i<%c;%i++)
   {
      %p = playerManager::getPlayerNum(%i);
      %p.MatchType = $DefaultMatchType;
      %p.Arena = $DefaultArena;
      %p.Pads = $DefaultPads;
   }

   for(%i=1;%i<17;%i++)
   {
      $Competitor[%i] = "";
   }

   setHostile("Red Team", "Red Team");
   setHostile("Yellow Team");
   setHostile("Blue Team","Purple Team");
   setHostile("Purple Team","Blue Team");
   setHUDMapViewOffSet(8352,-512);

   cdAudioCycle("Purge", "Terror", "Watching");

   if($DefaultMatchType == "")
   {
      $DefaultMatchType = 1;
   }
   if($DefaultArena == "")
   {
      $DefaultArena = 1;
   }
   if($DefaultPads == "")
   {
      $DefaultPads = 1;
   }

   for(%i=1;%i<3;%i++)
   {
      $NDoor[%i] = getObjectId("MissionGroup/Arena/NDoor"@%i);
      $WDoor[%i] = getObjectId("MissionGroup/Arena/WDoor"@%i);
      $SDoor[%i] = getObjectId("MissionGroup/Arena/SDoor"@%i);
      $EDoor[%i] = getObjectId("MissionGroup/Arena/EDoor"@%i);
   }

   $fountainOn = False;
   $Water = getObjectId("MissionGroup/Fountain/Water");
   $Fire = getObjectId("MissionGroup/Fountain/Fire");
   $Earth = getObjectId("MissionGroup/Fountain/Earth");
   $Air = getObjectId("MissionGroup/Fountain/Air");

   $HercPad = getObjectId("MissionGroup/StoredObjects/HercPad");
   $SmallPadTrigger = getObjectId("MissionGroup/StoredObjects/SmallPadTrigger");
   $LargePadTrigger = getObjectId("MissionGroup/StoredObjects/LargePadTrigger");
   $Bomb = getObjectId("MissionGroup/StoredObjects/Bomb");
   $Shockwave = getObjectId("MissionGroup/StoredObjects/Shockwave");
   $Mine = getObjectId("MissionGroup/StoredObjects/Mine");
   $MineTrigger = getObjectId("MissionGroup/StoredObjects/MineTrigger");

   deleteVariables("$Scoreboard::PlayerColumn*");
   deleteVariables("$Scoreboard::Team*");
   $ScoreBoard::PlayerColumnHeader1 = "Wins";
   $ScoreBoard::PlayerColumnHeader2 = "Losses";
   $ScoreBoard::PlayerColumnHeader3 = "Draws";
   $ScoreBoard::PlayerColumnHeader4 = "Rumbles Won";

   $ScoreBoard::PlayerColumnFunction1 = "getWins";
   $ScoreBoard::PlayerColumnFunction2 = "getLoses";
   $ScoreBoard::PlayerColumnFunction3 = "getDraws";
   $ScoreBoard::PlayerColumnFunction4 = "getRumbles";
   serverInitScoreBoard();
}

function getWins(%p)
{
   return %p.Wins;
}

function getLoses(%p)
{
   return %p.Losses;
}

function getDraws(%p)
{
   return %p.Draws;
}

function getRumbles(%p)
{
   return %p.Rumbles;
}

function getPoints(%p)
{
   return %p.Points;
}

function player::onAdd(%p)
{
   say(%p,0,"Welcome to the Starsiege Mega Arena! Please read the game info tab for details. You can download this & other missions made by Gen. Powio [MIB] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %p.MatchType = $DefaultMatchType;
   %p.Arena = $DefaultArena;
   %p.Pads = $DefaultPads;
   %p.Wins = 0;
   %p.Losses = 0;
   %p.Draws = 0;
   %p.Rumbles = 0;
   %p.Disabled = 0;
   %p.Player = "";
   %p.Code = "";
   if(strAlign(1, left, getname(%p))=="/")
   {
      say(0,0,"<f4>"@getname(%p)@" joined the game with a slash","sfx_spot_locking.wav");
   }
}

function player::onRemove(%p)
{
   if(strAlign(1, left, getname(%p))=="/")
   {
      say(0,0,"<f4>"@getname(%p)@" left the game with a slash","sfx_spot_locking.wav");
   }
}

function vehicle::onAdd(%v)
{
   %v.Hurt = "";
   setTeam(%v,*IDSTR_TEAM_YELLOW);
   %p = playerManager::vehicleIdToPlayerNum(%v);
   if($MatchStatus == Waiting)
   {
      setHudTimer($Time,-1,getName(%p)@": "@$matchTypeName,1);
   }
   if($MatchStatus == Ready)
   {
      setHudTimer($Time,-1,"Match will begin in...",1);
   }
}

function vehicle::onDestroyed(%d,%r)
{
   %p = playerManager::vehicleIdToPlayerNum(%d);
   vehicle::onDestroyedLog(%d,%r);
   %m = getFancyDeathMessage(getHUDName(%d),getHUDName(%r));
   if(%d.Hurt == Bomb)
   {
      say(0,0,getName(%p)@" was blown to smitherines by a bomb!");
   }
   else if(%d.Hurt == Mine)
   {
      say(0,0,getName(%p)@" was blown to pieces by a mine!");
   }
   else if(%d.Hurt == Arena)
   {
      say(0,0,getName(%p)@" fell out of the arena!");
   }
   else if(%m != "")
   {
      say(0,0, %m);
   }
   if(%p.Player == True)
   {
      if($MatchStatus == InProgress)
      {
         say(0,0,getName(%p)@"<F5> has been elminated!");
         $Opponents--;
         %p.Player = "";
         if($MatchType < 4)
         {
            %p.Losses++;
         }
         if($MatchType == 5)
         {
            if((%p == $Competitor1)||(%p == $Competitor3)||(%p == $Competitor5)||(%p == $Competitor7))
            {
               $BlueTeam--;
            }
            else
            {
               $PurpleTeam--;
            }
         }
         for(%i=1;%i<17;%i++)
         {
            if(%p == $Competitor[%i])
            {
               $Competitor[%i] = "";
            }
         }
         checkEliminated();
      }
      else
      {
         cancelMatch(%p);
      }
   }
}

function vehicle::onAttacked(%d,%r)
{
   %d.Hurt = "";
}

function round(%number)
{
   %roundNum = %number;
   if(%number > 0)
   {
      %excess = (%number - floor(%number));
      if(%excess >= 0.5)
      {
         %roundNum = (floor(%number) + 1);
      }
      else
      {
         %roundNum = floor(%number);
      }
   }
   if(%number < 0)
   {
      %excess = (floor(%number) - %number);
      if(%excess <= 0.5)
      {
         %roundNum = floor(%number);
      }
      else
      {
         %roundNum = (floor(%number) - 1);
      }
   }
   return %roundNum;
}