// FILENAME:	SS_Sorcery.cs
//
// AUTHORS:  	Com. Sentinal [M.I.B.]
//------------------------------------------------------------------------------

$missionName = "Starsiege Sorcery";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

//Pilot Elite
//{
//   id = 28;
//   skill = 2.0;
//   accuracy = 1.0;
//   aggressiveness = 2.0;
//   activateDist = 500.0;
//   deactivateBuff = 100.0;
//   targetFreq = 1.0;
//   trackFreq = 0.1;
//   fireFreq = 0.3;
//   LOSFreq = 0.1;
//};

$maxMana = 300;
$lastMeteorHit = "";

function onMissionStart()
{
   temperateSounds();
   $nav1 = getObjectId("MissionGroup\\navOne");
   $nav2 = getObjectId("MissionGroup\\navTwo");
   $nav3 = getObjectId("MissionGroup\\navRed");
   $nav4 = getObjectId("MissionGroup\\navBlue");
   $nav5 = getObjectId("MissionGroup\\navOmega");
   $stasis = getObjectId("MissionGroup\\spells\\stasis");
   $wave = getObjectId("MissionGroup\\spells\\wave");
   $explosion = getObjectId("MissionGroup\\spells\\explosion");
   $flame = getObjectId("MissionGroup\\spells\\flame");
   $pod = getObjectId("MissionGroup\\spells\\pod");
   $ghost = getObjectId("MissionGroup\\spells\\ghost");
   $deflect = getObjectId("MissionGroup\\spells\\deflect");
   $shield = getObjectId("MissionGroup\\spells\\shield");
   $lightning = getObjectId("MissionGroup\\spells\\lightning");
   $deathTrap = getObjectId("MissionGroup\\spells\\deathtrap");
   $hut = getObjectId("MissionGroup\\spells\\hut");
   $plague = getObjectId("MissionGroup\\spells\\plague");
   $meteorite = getObjectId("MissionGroup\\spells\\meteorite");
   $fireBlast = getObjectId("MissionGroup\\spells\\fireBlast");
   $grave = getObjectId("MissionGroup\\spells\\grave");
   $impale = getObjectId("MissionGroup\\spells\\impale");
   $spike = getObjectId("MissionGroup\\spells\\spike");
}

function onMissionLoad()
{
   cdAudioCycle("Purge", "Watching", "Mechsoul", "Terror");
   setGameInfo("<f2>GAME TYPE:<f0>  Starsiege Sorcery\n\n<f2>CREATOR:<f0>  Com. Sentinal [M.I.B.]\n\n<f0>At the beginning of the game, you have no mana. Your amount of mana will charge for as long as you are spawned. The maximum amount of mana a player can have is <f3>" @ $maxMana @ "<f0>. Then scan the target drone balls at each base or use the HercBoost keymap to select and cast different spells. When you cast a spell, you will lose the specified amount of mana that the spell requires.\n\n<f2>HERCBOOST KEYMAP CONTROLS:\n\n<f3>CTRL + D = <f0>Cycle forward through the spell selection menu\n<f3>CTRL + A = <f0>Cycle backward through the spell selection menu\n<f3>CTRL + S = <f0>Display more information about the selected spell\n<f3>CTRL + W = <f0>Cast the selected spell\n\n<f2>DOWNLOAD INFO:\n\n<f5>You can download HercBoost keymap, SS_Sorcery, & other missions made by Com. Sentinal [M.I.B.] in the \"MIB Map Packs\" on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      %player.extraKills = 0;
      %player.trapped = false;
      %player.haste = false;
      %player.repel = false;
      %player.poisoned = false;
      %player.poisonlock = false;
      %player.deflect = false;
      %player.deflectCount = 0;
      %player.shield = "";
      %player.haste = false;
      %player.num = 1;
      %player.deathdelay = false;
      %player.meteorDelay = false;
      //%player.attackdelay = false;
      if(%player.group == "")
      {  
         %player.group = newObject("group"@%player, simGroup);
         addToSet("Missiongroup", %player.group);
      }
   }
}

function player::onAdd(%player)
{
   say(%player, 0, "Welcome to Starsiege Sorcery! Check the game info tab for information on how to play and cast spells. You can download SS_Sorcery & other missions made by Com. Sentinal [M.I.B.] in the \"MIB Map Packs\" on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %player.leftgame = false;
   %player.extraKills = 0;
   %player.trapped = false;
   %player.haste = false;
   %player.repel = false;
   %player.poisoned = false;
   %player.poisonlock = false;
   %player.deflect = false;
   %player.deflectCount = 0;
   %player.shield = "";
   %player.mana = 0;
   %player.num = 1;
   %player.spell = "Mana";
   %player.cost = 1;
   %player.shutDownSpell = false;
   %player.deathdelay = false;
   %player.meteorDelay = false;
   //%player.attackdelay = false;
   deleteObject(%player.group);
   %player.group = newObject("group"@%player, simGroup);
   addToSet("Missiongroup", %player.group);
}

function player::onRemove(%player)
{
   %player.leftgame = true;
   echo(%player.group@" GROUP"@%player@" deleted");
   deleteObject(%player.group);
   %player.group = "";
}

function copyObject(%object, %name)
{
   storeObject(%object, "copyObject.tmp");
   if(%name == "")
   {
      %copy = loadObject(getObjectName(%object), "copyObject.tmp");
   }
   else
   {
      %copy = loadObject(%name, "copyObject.tmp");
   }
   return %copy;
}

function vehicle::onadd(%vehicleId)
{
   %player = playermanager::vehicleidtoplayernum(%vehicleId);
   %vehicleId.deathMethod = "";
   %vehicleId.killer = "";   
   if(%player != 0)
   {      
      setHudTimer(0,-1,"",1,%player);       
      setHudTimer(0,-1,"",2,%player);       
      setHudTimer(0,-1,"",3,%player);           
      %vehicleId.owner = "";
      %player.trapped = false;
      %player.num = 1;
      %player.haste = false;
      %player.repel = false;
      %player.poisoned = false;
      %player.poisonlock = false;
      %player.deflect = false;
      %player.deflectCount = 0;
      %player.delay = false;         
      %player.InPad = false; 
      %player.justlaid = false;
      %player.meteorDelay = false;
      //%player.attackDelay = false;
      //setHercOwner(%player.group, %player.group);
      //setHercOwner(%player.group, %vehicleId);
      //%obj = getNextObject(%player.group, 0);
      //while(%obj != 0)
      //{
      //  setTeam(%obj, getTeam(%player));
      //  if(getTeam(%player) != %player.lastteam)
      //  {
      //    if((getobjectname(%obj) == "veh")||(getobjectname(%obj) == "mirage"))
      //    {
      //      %tempX = randomInt(5000, 8000);
      //      %tempY = randomInt(5000, 8000);
      //      setPosition(%obj, %tempX, %tempY, -5000);
      //      setTeam(%obj, getTeam(%player));
      //      schedule("randomTransport("@%obj@",getPosition("@%vehicleid@",x)-300,getPosition("@%vehicleid@",y)-300,getPosition("@%vehicleid@",x)+300,getPosition("@%vehicleid@",y)+300);",1);
      //    }
      //  }
      //  %obj = getNextObject(%player.group, %obj);
      //}
      //order("MissionGroup\\group"@%player, guard, %vehicleId);
      //reloadObject("MissionGroup\\group"@%player, 5000);
      //%player.lastteam = getTeam(%player);
   }
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   %player2 = playermanager::vehicleIdtoPlayerNum(%destroyed);
   %player2.deathdelay = true;
   %player2.poisonlock = true;
   %player2.poisoned = false;
   %player2.deflect = false;
   %player2.deflectCount = 0;
   schedule("cleanUpShield(" @ %player2 @ ");", 1);
   schedule("deathdelay(" @ %player2 @ ");", 5);
   if(%player2 == 0)
   {
      schedule("deleteObject(" @ %destroyed @ ");", 2);
   }
   
   if(%destroyed.deathMethod == "FireStorm")
   {
      %killer = %destroyed.killer;
      %killer.extraKills++;
      say(0, 0, getHudName(%destroyed) @ " was annihilated by " @ getName(%killer) @ "'s FireStorm attack.");
   }
   else if(%destroyed.deathMethod == "DinsFire")
   {
      %killer = %destroyed.killer;
      %killer.extraKills++;
      say(0, 0, getName(%killer) @ " incinerated " @ getHudName(%destroyed) @ " with Din's Fire.");
   }
   else if(%destroyed.deathMethod == "Stormreaver")
   {
      %killer = %destroyed.killer;
      %killer.extraKills++;
      say(0, 0, getHudName(%destroyed) @ " was struck down by " @ getName(%killer) @ "'s Stormreaver attack.");
   }
   else if(%destroyed.deathMethod == "Flash")
   {
      %killer = %destroyed.killer;
      if(%killer == %player2)
      {
         say(0, 0, getHudName(%destroyed) @ " was killed by his own Stormreaver attack.");
      }
      else
      {
         %killer.extraKills++;
         say(0, 0, getHudName(%destroyed) @ " was killed by " @ getName(%killer) @ "'s Stormreaver attack.");
      }
   }
   else if(%destroyed.deathMethod == "DeathTrap")
   {
      %killer = %destroyed.killer;
      if(%killer == %player2)
      {
         say(0, 0, getHudName(%destroyed) @ " got caught inside his own DeathTrap and was burned alive.");
      }
      else
      {
         %killer.extraKills++;
         say(0, 0, getHudName(%destroyed) @ " got caught inside " @ getName(%killer) @ "'s DeathTrap and was burned alive.");
      }
   }
   else if(%destroyed.deathMethod == "Plague")
   {
      %killer = %destroyed.killer;
      if(%killer == %player2)
      {
         say(0, 0, getHudName(%destroyed) @ " was burned to death by his own Plague of Fire.");
      }
      else
      {
         %killer.extraKills++;
         say(0, 0, getHudName(%destroyed) @ " was burned to death by " @ getName(%killer) @ "'s Plague of Fire.");
      }
   }
   else if(%destroyed.deathMethod == "FireBlast")
   {
      %killer = %destroyed.killer;
      if(%killer == %player2)
      {
         say(0, 0, getHudName(%destroyed) @ " was burned to a smoldering pile of ashes by his own FireBlast attack.");
      }
      else
      {
         %killer.extraKills++;
         say(0, 0, getHudName(%destroyed) @ " was burned to a smoldering pile of ashes by " @ getName(%killer) @ "'s FireBlast attack.");
      }
   }
   else if(%destroyed.deathMethod == "Impale")
   {
      %killer = %destroyed.killer;
      if(%killer == %player2)
      {
         say(0, 0, getHudName(%destroyed) @ " was impaled by his own spike trap.");
      }
      else
      {
         %killer.extraKills++;
         say(0, 0, getHudName(%destroyed) @ " was impaled by " @ getName(%killer) @ "'s spike trap.");
      }
   }
   else if(%destroyed.deathMethod == "Venom")
   {
      %killer = %destroyed.killer;
      %killer.extraKills++;
      say(0, 0, getHudName(%destroyed) @ " was poisoned to death by " @ getName(%killer) @ "'s venom.");
   }
   else if(%destroyed.deathMethod == "Ghost")
   {
      %killer = %destroyed.killer;
      %killer.extraKills++;
      say(0, 0, getHudName(%destroyed) @ " was murdered by the Ghost of " @ getName(%killer) @ ".");
      playSound(0, "sfx_cybrid_com.wav", IDPRF_2D);
   }
   else if(%destroyed.deathMethod == "LifeForce")
   {
      %killer = %destroyed.killer;
      say(0, 0, getHudName(%destroyed) @ " tranferred too much of his lifeforce to " @ getHudName(%killer) @ " and killed himself in the process.");
   }
   else
   {
      if((%player == 0)&&(%destroyer == -1))
      {
         say(0, 0, getHudName(%destroyed) @ " got caught in a Rain of Death storm and was reduced to ashes.");
      }
      else
      {
         // this is weird but %destroyer isn't necessarily a vehicle
         %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
         if(%message != "")
         {
            say( 0, 0, %message);
         }
            
         // enforce the rules
         if($server::TeamPlay == true)
         {
            if((getTeam(%destroyed)==getTeam(%destroyer))&&(%destroyed!=%destroyer))
            {
               antiTeamKill(%destroyer);
            }
         }
      }
   }
   %destroyed.owner = "";
   %destroyed.deathMethod = "";
   %destroyed.killer = "";   
}

function cleanUpShield(%player2)
{
   deleteObject(%player2.shield);
   %player2.shield = "";
}

function deathdelay(%player2)
{
   %player2.deathdelay = false;
}

//function vehicle::onAttacked(%attacked, %attacker)
//{
//   %player = playermanager::vehicleIdtoPlayerNum(%attacker);
//   %player2 = playermanager::vehicleIdtoPlayernum(%attacked);
//   if((%player.attackdelay == false)&&(%attacked.owner == %player)&&(%player != 0)&&(%player2 == 0))
//   {
//      %player.attackdelay = true;
//      say(%player,%player, "<f5>WARNING: You are firing upon your own vehicle!");
//      schedule("resetAttack(" @ %player @ ");", 3);   
//   }
//}

//function resetAttack(%player)
//{
//   %player.attackDelay = false;
//}

function resetMeteor(%player)
{
   %player.meteorDelay = false;
}

function remoteBoostSwitch(%player)
{
   if(%player.spell == "Mana")
   {
      say(%player, %player, "<f4>Spell Info: Scan another player's vehicle to transfer 10 mana to him.");
   }
   else if(%player.spell == "LifeForce")
   {
      say(%player, %player, "<f4>Spell Info: Scan another vehicle to transfer some of your lifeforce to it. WARNING: Transferring too much lifeforce can be hazardous to your health.");
   }
   else if(%player.spell == "Levitate")
   {
      say(%player, %player, "<f4>Spell Info: Scan an enemy vehicle or shut down to levitate your vehicle.");
   }
   else if(%player.spell == "Replenish")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to fully replenish your vehicle's ammunition.");
   }
   else if(%player.spell == "Haste")
   {
      say(%player, %player, "<f4>Spell Info: Place a nav marker, then shut down to travel there at an incredibly high speed.");
   }
   else if(%player.spell == "Stasis")
   {
      say(%player, %player, "<f4>Spell Info: Scan an enemy vehicle to trap them inside a stasis field for 60 seconds. Shut down to create a protective stasis field around your own vehicle.");
   }
   else if(%player.spell == "AntiVenom")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to drink the Anti-Venom. This potion will cure you of poisonous venom.");
   }
   else if(%player.spell == "FireStorm")
   {
      say(%player, %player, "<f4>Spell Info: Scan an enemy vehicle to fire a stream of 5 fireballs. Shut down to fire your fireballs at all enemy vehicles within a 300 meter radius of your vehicle.");
   }
   else if(%player.spell == "Repel")
   {
      say(%player, %player, "<f4>Spell Info: Shut down or scan a vehicle to repel all vehicles within a 300 meter radius of your vehicle.");
   }
   else if(%player.spell == "Deflect")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to place a Deflector Shield around your vehicle. The shield will move with you and protects against the projectile attacks FireStorm and FireBlast, reflecting them back at the attacker. The shield will last for 60 seconds or until its energy has been depleted.");
   }
   else if(%player.spell == "DinsFire")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to produce a tidal wave of fire which will incinerate any vehicle within 150 meters of your vehicle.");
   }
   else if(%player.spell == "Enslave")
   {
      say(%player, %player, "<f4>Spell Info: Scan an enemy vehicle to enslave it. The enslaved vehicle will be forced to follow you against his will. The spell wears off after 30 seconds.");
   }
   else if(%player.spell == "Shield")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to deploy a shield. Each piece of the shield can sustain 25,000 units of weapon damage. If not destroyed, the shield will dissipate after 90 seconds. This spell is ideal for defending bases against invasion.");
   }
   else if(%player.spell == "Heal")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to fully repair your vehicle.");
   }
   else if(%player.spell == "Restore")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to fully repair/reload your vehicle.");
   }
   else if(%player.spell == "Venom")
   {
      say(%player, %player, "<f4>Spell Info: Scan an enemy vehicle to poison him with venom. The victim will slowly die unless he drinks the Anti-Venom in time.");
   }
   else if(%player.spell == "Stormreaver")
   {
      say(%player, %player, "<f4>Spell Info: Scan an enemy vehicle to command lightning to strike him down.");
   }
   else if(%player.spell == "Cloak")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to make your vehicle invisible to radar until you are killed or until Reveal Truth is cast.");
   }
   else if(%player.spell == "Impale")
   {
      say(%player, %player, "<f4>Spell Info: Place a nav marker, then shut down to lay 5 spike traps in a 150 meter radius around your nav. When a vehicle steps on one of the traps, a giant spike will shoot out of the ground impaling the victim.");
   }
   else if(%player.spell == "DeathTrap")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to set a DeathTrap at your location. The trap will arm after 10 seconds. When someone walks into the trap, a giant pod will rise up out of the ground and enclose around them, trapping them inside. With nowhere to run, the victim will be burned alive.");
   }
   else if(%player.spell == "RevealTruth")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to cast Reveal Truth. It will make all players who are using Cloak of Darkness visible to radar once again, including you.");
   }
   else if(%player.spell == "FireBlast")
   {
      say(%player, %player, "<f4>Spell Info: Scan an enemy vehicle to set him on fire and watch him burn to death in the FireBlast.");
   }
   else
   {
      boostSwitch2(%player);
   }
}

function boostSwitch2(%player)
{   
   if(%player.spell == "Plague")
   {
      say(%player, %player, "<f4>Spell Info: Place a nav marker, then shut down to cast a Plague of Fire in a 300 meter radius around your nav. The spell will last 2 minutes after it is cast.");
   }
   else if(%player.spell == "RainOfDeath")
   {
      say(%player, %player, "<f4>Spell Info: Place a nav marker, then shut down to cast Rain Of Death in a 500 meter radius around your nav. The spell will last 2 minutes after it is cast.");
   }
   else if(%player.spell == "Ghost")
   {
      say(%player, %player, "<f4>Spell Info: Shut down to conjure up an evil spirit which will go out and kill your enemies without mercy.");
   }
}

function remoteHoverSwitch(%player)
{
   if(%player.spell == "Ghost")
   {
      %player.spell = "Mana";
      %player.shutDownSpell = false;
      %player.cost = 1;
      say(%player, %player, "<f1>Selected Spell: Transfer Mana (10 mana at a time)");
   }
   else if(%player.spell == "Mana")
   {
      %player.spell = "LifeForce";
      %player.shutDownSpell = false;
      %player.cost = 10;
      say(%player, %player, "<f1>Selected Spell: Transfer LifeForce (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "LifeForce")
   {
      %player.spell = "Levitate";
      %player.shutDownSpell = true;
      %player.cost = 15;
      say(%player, %player, "<f1>Selected Spell: Levitate (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Levitate")
   {
      %player.spell = "Replenish";
      %player.shutDownSpell = true;
      %player.cost = 20;
      say(%player, %player, "<f1>Selected Spell: Replenish (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Replenish")
   {
      %player.spell = "Haste";
      %player.shutDownSpell = true;
      %player.cost = 50;
      say(%player, %player, "<f1>Selected Spell: Haste (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Haste")
   {
      %player.spell = "Stasis";
      %player.shutDownSpell = true;
      %player.cost = 50;
      say(%player, %player, "<f1>Selected Spell: Stasis (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Stasis")
   {
      %player.spell = "FireStorm";
      %player.shutDownSpell = true;
      %player.cost = 60;
      say(%player, %player, "<f1>Selected Spell: FireStorm (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "FireStorm")
   {
      %player.spell = "Repel";
      %player.shutDownSpell = true;
      %player.cost = 70;
      say(%player, %player, "<f1>Selected Spell: Repel (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Repel")
   {
      %player.spell = "AntiVenom";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Anti-Venom (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "AntiVenom")
   {
      %player.spell = "Deflect";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Deflect (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Deflect")
   {
      %player.spell = "DinsFire";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Din's Fire (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "DinsFire")
   {
      %player.spell = "Enslave";
      %player.shutDownSpell = false;
      %player.cost = 100;
      say(%player, %player, "<f1>Selected Spell: Enslave (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Enslave")
   {
      %player.spell = "Shield";
      %player.shutDownSpell = true;
      %player.cost = 100;
      say(%player, %player, "<f1>Selected Spell: Shield (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Shield")
   {
      %player.spell = "Heal";
      %player.shutDownSpell = true;
      %player.cost = 110;
      say(%player, %player, "<f1>Selected Spell: Heal (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Heal")
   {
      %player.spell = "Restore";
      %player.shutDownSpell = true;
      %player.cost = 120;
      say(%player, %player, "<f1>Selected Spell: Restore (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Restore")
   {
      %player.spell = "Venom";
      %player.shutDownSpell = false;
      %player.cost = 120;
      say(%player, %player, "<f1>Selected Spell: Venom (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Venom")
   {
      %player.spell = "Stormreaver";
      %player.shutDownSpell = false;
      %player.cost = 130;
      say(%player, %player, "<f1>Selected Spell: Stormreaver (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Stormreaver")
   {
      %player.spell = "Cloak";
      %player.shutDownSpell = true;
      %player.cost = 135;
      say(%player, %player, "<f1>Selected Spell: Cloak of Darkness (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Cloak")
   {
      %player.spell = "Impale";
      %player.shutDownSpell = true;
      %player.cost = 150;
      say(%player, %player, "<f1>Selected Spell: Impale (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Impale")
   {
      %player.spell = "DeathTrap";
      %player.shutDownSpell = true;
      %player.cost = 170;
      say(%player, %player, "<f1>Selected Spell: DeathTrap (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "DeathTrap")
   {
      %player.spell = "RevealTruth";
      %player.shutDownSpell = true;
      %player.cost = 180;
      say(%player, %player, "<f1>Selected Spell: Reveal Truth (" @ %player.cost @ " mana)");
   }
   else
   {
      hoverSwitch2(%player);
   }
}

function hoverSwitch2(%player)
{     
   if(%player.spell == "RevealTruth")
   {
      %player.spell = "FireBlast";
      %player.shutDownSpell = false;
      %player.cost = 180;
      say(%player, %player, "<f1>Selected Spell: FireBlast (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "FireBlast")
   {
      %player.spell = "Plague";
      %player.shutDownSpell = true;
      %player.cost = 200;
      say(%player, %player, "<f1>Selected Spell: Plague of Fire (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Plague")
   {
      %player.spell = "RainOfDeath";
      %player.shutDownSpell = true;
      %player.cost = 270;
      say(%player, %player, "<f1>Selected Spell: Rain of Death (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "RainOfDeath")
   {
      %player.spell = "Ghost";
      %player.shutDownSpell = true;
      %player.cost = 300;
      say(%player, %player, "<f1>Selected Spell: Ghost (" @ %player.cost @ " mana)");
   }
}

function remoteCancelSwitch(%player)
{
   if(%player.delay == false)
   {
      reverseSpell(%player);
   }
   %player.delay = false;
}

function reverseSpell(%player)
{
   if(%player.spell == "LifeForce")
   {
      %player.spell = "Mana";
      %player.shutDownSpell = false;
      %player.cost = 1;
      say(%player, %player, "<f1>Selected Spell: Transfer Mana (10 mana at a time)");
   }
   else if(%player.spell == "Levitate")
   {
      %player.spell = "LifeForce";
      %player.shutDownSpell = false;
      %player.cost = 10;
      say(%player, %player, "<f1>Selected Spell: Transfer LifeForce (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Replenish")
   {
      %player.spell = "Levitate";
      %player.shutDownSpell = true;
      %player.cost = 15;
      say(%player, %player, "<f1>Selected Spell: Levitate (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Haste")
   {
      %player.spell = "Replenish";
      %player.shutDownSpell = true;
      %player.cost = 20;
      say(%player, %player, "<f1>Selected Spell: Replenish (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Stasis")
   {
      %player.spell = "Haste";
      %player.shutDownSpell = true;
      %player.cost = 50;
      say(%player, %player, "<f1>Selected Spell: Haste (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "FireStorm")
   {
      %player.spell = "Stasis";
      %player.shutDownSpell = true;
      %player.cost = 50;
      say(%player, %player, "<f1>Selected Spell: Stasis (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Repel")
   {
      %player.spell = "FireStorm";
      %player.shutDownSpell = true;
      %player.cost = 60;
      say(%player, %player, "<f1>Selected Spell: FireStorm (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "AntiVenom")
   {
      %player.spell = "Repel";
      %player.shutDownSpell = true;
      %player.cost = 70;
      say(%player, %player, "<f1>Selected Spell: Repel (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Deflect")
   {
      %player.spell = "AntiVenom";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Anti-Venom (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "DinsFire")
   {
      %player.spell = "Deflect";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Deflect (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Enslave")
   {
      %player.spell = "DinsFire";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Din's Fire (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Shield")
   {
      %player.spell = "Enslave";
      %player.shutDownSpell = false;
      %player.cost = 100;
      say(%player, %player, "<f1>Selected Spell: Enslave (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Heal")
   {
      %player.spell = "Shield";
      %player.shutDownSpell = true;
      %player.cost = 100;
      say(%player, %player, "<f1>Selected Spell: Shield (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Restore")
   {
      %player.spell = "Heal";
      %player.shutDownSpell = true;
      %player.cost = 110;
      say(%player, %player, "<f1>Selected Spell: Heal (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Venom")
   {
      %player.spell = "Restore";
      %player.shutDownSpell = true;
      %player.cost = 120;
      say(%player, %player, "<f1>Selected Spell: Restore (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Stormreaver")
   {
      %player.spell = "Venom";
      %player.shutDownSpell = false;
      %player.cost = 120;
      say(%player, %player, "<f1>Selected Spell: Venom (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Cloak")
   {
      %player.spell = "Stormreaver";
      %player.shutDownSpell = false;
      %player.cost = 130;
      say(%player, %player, "<f1>Selected Spell: Stormreaver (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Impale")
   {
      %player.spell = "Cloak";
      %player.shutDownSpell = true;
      %player.cost = 135;
      say(%player, %player, "<f1>Selected Spell: Cloak of Darkness (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "DeathTrap")
   {
      %player.spell = "Impale";
      %player.shutDownSpell = true;
      %player.cost = 150;
      say(%player, %player, "<f1>Selected Spell: Impale (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "RevealTruth")
   {
      %player.spell = "DeathTrap";
      %player.shutDownSpell = true;
      %player.cost = 170;
      say(%player, %player, "<f1>Selected Spell: DeathTrap (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "FireBlast")
   {
      %player.spell = "RevealTruth";
      %player.shutDownSpell = true;
      %player.cost = 180;
      say(%player, %player, "<f1>Selected Spell: Reveal Truth (" @ %player.cost @ " mana)");
   }
   else
   {
      cancelSwitch2(%player);
   }
}

function cancelSwitch2(%player)
{
   if(%player.spell == "Plague")
   {
      %player.spell = "FireBlast";
      %player.shutDownSpell = false;
      %player.cost = 180;
      say(%player, %player, "<f1>Selected Spell: FireBlast (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "RainOfDeath")
   {
      %player.spell = "Plague";
      %player.shutDownSpell = true;
      %player.cost = 200;
      say(%player, %player, "<f1>Selected Spell: Plague of Fire (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Ghost")
   {
      %player.spell = "RainOfDeath";
      %player.shutDownSpell = true;
      %player.cost = 270;
      say(%player, %player, "<f1>Selected Spell: Rain of Death (" @ %player.cost @ " mana)");
   }
   else if(%player.spell == "Mana")
   {
      %player.spell = "Ghost";
      %player.shutDownSpell = true;
      %player.cost = 300;
      say(%player, %player, "<f1>Selected Spell: Ghost (" @ %player.cost @ " mana)");
   }
}

function remoteForwardSwitch(%player)
{
   %player.delay = true;
   castSpellHercboost(%player);
}

function structure::onScan(%scanned, %scanner)
{
   vehicle::onScan(%scanned, %scanner);
}

function vehicle::onSpot(%spotter, %target)
{
   %player = playerManager::vehicleIdToPlayerNum(%spotter);
   if(%target != "")
   {
      vehicle::onScan(%target, %spotter);
   }
   else
   {
      say(%player, %player, "<F4>Target lost.");
   }
}

function select::structure::onScan(%scanned, %scanner)
{
   %player = playerManager::vehicleIdToPlayerNum(%scanner);
   if(%player.spell == "Ghost")
   {
      %player.spell = "Mana";
      %player.shutDownSpell = false;
      %player.cost = 1;
      say(%player, %player, "<f1>Selected Spell: Transfer Mana (10 mana at a time)\n<F4>To Cast: Scan another player's vehicle to transfer 10 mana to him.");
   }
   else if(%player.spell == "Mana")
   {
      %player.spell = "LifeForce";
      %player.shutDownSpell = false;
      %player.cost = 10;
      say(%player, %player, "<f1>Selected Spell: Transfer LifeForce (" @ %player.cost @ " mana)\n<F4>To Cast: Scan another vehicle to transfer some of your lifeforce to it. WARNING: Transferring too much lifeforce can be hazardous to your health.");
   }
   else if(%player.spell == "LifeForce")
   {
      %player.spell = "Levitate";
      %player.shutDownSpell = true;
      %player.cost = 15;
      say(%player, %player, "<f1>Selected Spell: Levitate (" @ %player.cost @ " mana)\n<F4>To Cast: Scan an enemy vehicle or shut down to levitate your vehicle.");
   }
   else if(%player.spell == "Levitate")
   {
      %player.spell = "Replenish";
      %player.shutDownSpell = true;
      %player.cost = 20;
      say(%player, %player, "<f1>Selected Spell: Replenish (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to fully replenish your vehicle's ammunition.");
   }
   else if(%player.spell == "Replenish")
   {
      %player.spell = "Haste";
      %player.shutDownSpell = true;
      %player.cost = 50;
      say(%player, %player, "<f1>Selected Spell: Haste (" @ %player.cost @ " mana)\n<F4>To Cast: Place a nav marker, then shut down to travel there at an incredibly high speed");
   }
   else if(%player.spell == "Haste")
   {
      %player.spell = "Stasis";
      %player.shutDownSpell = true;
      %player.cost = 50;
      say(%player, %player, "<f1>Selected Spell: Stasis (" @ %player.cost @ " mana)\n<F4>To Cast: Scan an enemy vehicle to trap them inside a stasis field for 60 seconds. Shut down to create a protective stasis field around your own vehicle.");
   }
   else if(%player.spell == "Stasis")
   {
      %player.spell = "FireStorm";
      %player.shutDownSpell = true;
      %player.cost = 60;
      say(%player, %player, "<f1>Selected Spell: FireStorm (" @ %player.cost @ " mana)\n<F4>To Cast: Scan an enemy vehicle to fire a stream of 5 fireballs. Shut down to fire your fireballs at all enemy vehicles within a 300 meter radius of your vehicle.");
   }
   else if(%player.spell == "FireStorm")
   {
      %player.spell = "Repel";
      %player.shutDownSpell = true;
      %player.cost = 70;
      say(%player, %player, "<f1>Selected Spell: Repel (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down or scan a vehicle to repel all vehicles within a 300 meter radius of your vehicle.");
   }
   else if(%player.spell == "Repel")
   {
      %player.spell = "AntiVenom";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Anti-Venom (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to drink the Anti-Venom. This potion will cure you of poisonous venom.");
   }
   else if(%player.spell == "AntiVenom")
   {
      %player.spell = "Deflect";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Deflect (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to place a Deflector Shield around your vehicle. The shield will move with you and protects against the projectile attacks FireStorm and FireBlast, reflecting them back at the attacker. The shield will last for 60 seconds or until its energy has been depleted.");
   }
   else if(%player.spell == "Deflect")
   {
      %player.spell = "DinsFire";
      %player.shutDownSpell = true;
      %player.cost = 90;
      say(%player, %player, "<f1>Selected Spell: Din's Fire (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to produce a tidal wave of fire which will incinerate any vehicle within 150 meters of your vehicle.");
   }
   else if(%player.spell == "DinsFire")
   {
      %player.spell = "Enslave";
      %player.shutDownSpell = false;
      %player.cost = 100;
      say(%player, %player, "<f1>Selected Spell: Enslave (" @ %player.cost @ " mana)\n<F4>To Cast: Scan an enemy vehicle to enslave it. The enslaved vehicle will be forced to follow you against his will. The spell wears off after 30 seconds.");
   }
   else if(%player.spell == "Enslave")
   {
      %player.spell = "Shield";
      %player.shutDownSpell = true;
      %player.cost = 100;
      say(%player, %player, "<f1>Selected Spell: Shield (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to deploy a shield. Each piece of the shield can sustain 25,000 units of weapon damage. If not destroyed, the shield will dissipate after 90 seconds. This spell is ideal for defending bases against invasion.");
   }
   else if(%player.spell == "Shield")
   {
      %player.spell = "Heal";
      %player.shutDownSpell = true;
      %player.cost = 110;
      say(%player, %player, "<f1>Selected Spell: Heal (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to fully repair your vehicle.");
   }
   else if(%player.spell == "Heal")
   {
      %player.spell = "Restore";
      %player.shutDownSpell = true;
      %player.cost = 120;
      say(%player, %player, "<f1>Selected Spell: Restore (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to fully repair/reload your vehicle.");
   }
   else if(%player.spell == "Restore")
   {
      %player.spell = "Venom";
      %player.shutDownSpell = false;
      %player.cost = 120;
      say(%player, %player, "<f1>Selected Spell: Venom (" @ %player.cost @ " mana)\n<F4>To Cast: Scan an enemy vehicle to poison him with venom. The victim will slowly die unless he drinks the Anti-Venom in time.");
   }
   else if(%player.spell == "Venom")
   {
      %player.spell = "Stormreaver";
      %player.shutDownSpell = false;
      %player.cost = 130;
      say(%player, %player, "<f1>Selected Spell: Stormreaver (" @ %player.cost @ " mana)\n<F4>To Cast: Scan an enemy vehicle to command lightning to strike him down.");
   }
   else if(%player.spell == "Stormreaver")
   {
      %player.spell = "Cloak";
      %player.shutDownSpell = true;
      %player.cost = 135;
      say(%player, %player, "<f1>Selected Spell: Cloak of Darkness (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to make your vehicle invisible to radar until you are killed or until Reveal Truth is cast.");
   }
   else if(%player.spell == "Cloak")
   {
      %player.spell = "Impale";
      %player.shutDownSpell = true;
      %player.cost = 150;
      say(%player, %player, "<f1>Selected Spell: Impale (" @ %player.cost @ " mana)\n<F4>To Cast: Place a nav marker, then shut down to lay 5 spike traps in a 150 meter radius around your nav. When a vehicle steps on one of the traps, a giant spike will shoot out of the ground impaling the victim.");
   }
   else if(%player.spell == "Impale")
   {
      %player.spell = "DeathTrap";
      %player.shutDownSpell = true;
      %player.cost = 170;
      say(%player, %player, "<f1>Selected Spell: DeathTrap (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to set a DeathTrap at your location. The trap will arm after 10 seconds. When someone walks into the trap, a giant pod will rise up out of the ground and enclose around them, trapping them inside. With nowhere to run, the victim will be burned alive.");
   }
   else if(%player.spell == "DeathTrap")
   {
      %player.spell = "RevealTruth";
      %player.shutDownSpell = true;
      %player.cost = 180;
      say(%player, %player, "<f1>Selected Spell: Reveal Truth (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to cast Reveal Truth. It will make all players who are using Cloak of Darkness visible to radar once again, including you.");
   }
   else
   {
      selectOnScan2(%player);
   }
}

function selectOnScan2(%player)
{   
   if(%player.spell == "RevealTruth")
   {
      %player.spell = "FireBlast";
      %player.shutDownSpell = false;
      %player.cost = 180;
      say(%player, %player, "<f1>Selected Spell: FireBlast (" @ %player.cost @ " mana)\n<F4>To Cast: Scan an enemy vehicle to set him on fire and watch him burn to death in the FireBlast.");
   }
   else if(%player.spell == "FireBlast")
   {
      %player.spell = "Plague";
      %player.shutDownSpell = true;
      %player.cost = 200;
      say(%player, %player, "<f1>Selected Spell: Plague of Fire (" @ %player.cost @ " mana)\n<F4>To Cast: Place a nav marker, then shut down to cast a Plague of Fire in a 300 meter radius around your nav. The spell will last 2 minutes after it is cast.");
   }
   else if(%player.spell == "Plague")
   {
      %player.spell = "RainOfDeath";
      %player.shutDownSpell = true;
      %player.cost = 270;
      say(%player, %player, "<f1>Selected Spell: Rain of Death (" @ %player.cost @ " mana)\n<F4>To Cast: Place a nav marker, then shut down to cast Rain Of Death in a 500 meter radius around your nav. The spell will last 2 minutes after it is cast.");
   }
   else if(%player.spell == "RainOfDeath")
   {
      %player.spell = "Ghost";
      %player.shutDownSpell = true;
      %player.cost = 300;
      say(%player, %player, "<f1>Selected Spell: Ghost (" @ %player.cost @ " mana)\n<F4>To Cast: Shut down to conjure up an evil spirit which will go out and kill your enemies without mercy.");
   }
}

function castSpellHercboost(%player)
{
   if(%player.shutDownSpell == true)
   {
      if((%player.spell == "Stasis")||(%player.spell == "FireStorm")||(%player.spell == "Levitate"))
      {
         %target = getTargetId(playerManager::playerNumToVehicleId(%player));
         if(%target == "")
         {
            castSpell(%player);
         }
         else
         {
            %scanner = playerManager::playerNumToVehicleId(%player);
            %scanned = getTargetId(%scanner);
            vehicle::onScan(%scanned, %scanner);
         }
      }
      else
      {
         castSpell(%player);
      }
   }
   else
   {
      %target = getTargetId(playerManager::playerNumToVehicleId(%player));
      if(%target == "")
      {
         say(%player, %player, "<F5>Cannot cast spell. You do not have a target.");
      }
      else
      {
         %scanner = playerManager::playerNumToVehicleId(%player);
         %scanned = getTargetId(%scanner);
         vehicle::onScan(%scanned, %scanner);
      }
   }
}

function hasMana(%player)
{
   if(%player.mana >= %player.cost)
   {
      return true;
   }
   else
   {
      say(%player, %player, "<f5>You do not have enough mana to cast this spell! It requires " @ %player.cost @ " mana, and you only have " @ %player.mana @ " mana. Please wait for your mana to charge.", "alarm2.wav");
      return false;
   }
}

function spendMana(%player)
{
   %player.mana -= %player.cost;
}

function castSpell::trigger::onContact(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdtoPlayerNum(%vehicleId);
   if(%player != 0)
   {
      if(%player.mana < $maxMana)
      {
         if(%player.num == 1)
         {
            %player.mana++;
            %player.num = 2;
         }
         else if(%player.num == 2)
         {
            %player.num = 1;
         }
      }

      if(isshutdown(%vehicleId) == false)
      {
         %player.justlaid = false;
      }
      if((%player.InPad == false)&&(isshutdown(%vehicleId) == true)&&(%player.shutDownSpell == true)&&(%player.justlaid == false)&&(%player.deathdelay == false))
      {  
         %player.justlaid = true;
         castSpell(%player);
      }  
      else if((%player.InPad == false)&&(isshutdown(%vehicleId) == true)&&(%player.shutDownSpell == false)&&(%player.justlaid == false)&&(%player.deathdelay == false))
      {  
         %player.justlaid = true;
      }
   }
}

function castSpell(%player)
{
   %vehicleId = playerManager::playerNumToVehicleId(%player);
   if(%player.spell == "Levitate")
   {
      if(%player.trapped == true)
      {
         say(%player, %player, "<F5>Cannot cast Levitate. Your vehicle is currently trapped.");
      }
      else if(%player.haste == true)
      {
         say(%player, %player, "<F5>Cannot cast Levitate. Your are currently using Haste.");
      }
      else if(%player.repel == true)
      {
         say(%player, %player, "<F5>Cannot cast Levitate. Your vehicle is currently being repelled.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Casting Levitate...");
            levitate(%vehicleId);
         }
      }
   }
   else if(%player.spell == "Replenish")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         reloadObject(%vehicleId, 50000);
         reloadObject(%vehicleId, 50000);
         reloadObject(%vehicleId, 50000);
         reloadObject(%vehicleId, 50000);
         reloadObject(%vehicleId, 50000);
         say(%player, %player, "<F4>Casting Replenish...", "reload_complete.wav");
      }
   }
   else if(%player.spell == "Haste")
   {
      if(%player.trapped == true)
      {
         say(%player, %player, "<F5>Cannot cast Haste. Your vehicle is currently trapped.");
      }
      else
      {
         if(%player.haste == true)
         {
            say(%player, %player, "<F5>Cannot cast. You are currently using Haste.");
         }
         else if(%player.repel == true)
         {
            say(%player, %player, "<F5>Cannot cast spell. You are currently being repelled.");
         }
         else
         {
            if(getPosition(getVehicleNavMarkerId(%vehicleId)) == "0.000000 0.000000 0.000000")
            {
               say(%player, %player, "<f5>You must first set a nav marker to specify the desired destination.");
            }
            else
            {
               if(hasMana(%player) == true)
               {
                  spendMana(%player);
                  say(%player, %player, "<F4>Casting Haste...", "C5_pbbbbbt.wav");
                  %player.haste = true;
                  %x1 = getPosition(%vehicleId, x);
                  %y1 = getPosition(%vehicleId, y);
                  %nav = getVehicleNavMarkerId(%vehicleId);
                  %x2 = getPosition(%nav, x);
                  %y2 = getPosition(%nav, y);
                  %distance = getDistance(%vehicleId, %nav);
                  %increments = %distance / 10;
                  %xDist = %x2 - %x1;
                  %yDist = %y2 - %y1;
                  %xOffset = %xDist / %increments;
                  %yOffset = %yDist / %increments;
                  haste(%vehicleId, %xOffset, %yOffset, %increments);     
               }
            }
         }
      }
   }
   else if(%player.spell == "Stasis")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         %field1 = copyObject($stasis);
         %field2 = copyObject($stasis);
         %field3 = copyObject($stasis);
         %field4 = copyObject($stasis);
         addToSet(%player.group,%field1);
         addToSet(%player.group,%field2);
         addToSet(%player.group,%field3);
         addToSet(%player.group,%field4);    
         %x = getposition(%vehicleId,x);
         %y = getposition(%vehicleId,y);
         %z1 = getTerrainHeight(%x,%y+30)+24;
         %z2 = getTerrainHeight(%x+30,%y)+24;
         %z3 = getTerrainHeight(%x,%y-30)+24;
         %z4 = getTerrainHeight(%x-30,%y)+24;
         setPosition(%field1,%x,%y+30,%z1,90,180);
         setPosition(%field2,%x+30,%y,%z2,0,180);
         setPosition(%field3,%x,%y-30,%z3,90,180);
         setPosition(%field4,%x-30,%y,%z4,0,180);
         say(%player,%player,"<f4>Casting protective Stasis...","sfx_electrical_bzzt.wav");
         setHudTimer(0,-1,"",3,%player);
         setHudTimer(60,-1,"Stasis Field:",3,%player);
         schedule("deleteObject("@%field1@");",60);
         schedule("deleteObject("@%field2@");",60);
         schedule("deleteObject("@%field3@");",60);
         schedule("deleteObject("@%field4@");",60);
      }
   }
   else if(%player.spell == "AntiVenom")
   {
      if(%player.poisoned == false)
      {
         say(%player, %player, "<F5>You are not poisoned and do not require anti-venom.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Drinking Anti-Venom...");
            playSound(%player, "sfx_cybrid_alarm.wav", IDPRF_2D);
            %player.poisonlock = true;
            %player.poisoned = false;
            schedule("resetPoisonLock(" @ %player @ ");", 6);
            schedule("say(" @ %player @ ", " @ %player @ ", \"<F4>You have been successfully cured of poisoning.\");", 2);
         }
      }
   }
   else if(%player.spell == "FireStorm")
   {
      if(hasMana(%player) == true)
      {
         %team = getTeam(%player);
         %num = 0;
         %count = playerManager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player2 = playerManager::getPlayerNum(%i);
            %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
            if((%player2 != %player)&&(getDistance(%vehicleId, %vehicleId2) <= 300))
            {
               if($server::TeamPlay == true)
               {
                  if(getTeam(%player2) != %team)
                  {
                     %num++;                     
                  }                  
               }
               else
               {
                  %num++;
               }
            }
         }
         //if($server::TeamPlay == true)
         //{
         //   for(%i = 8000; %i <= 10000; %i++)
         //   {
         //      if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
         //      {
         //         if((getTeam(%i) != getTeam(%player))&&(getDistance(%vehicleId, %i) <= 300))
         //         {
         //            %num++;
         //         }
         //      }
         //   }
         //}
         //else
         //{
         //   for(%i = 8000; %i <= 10000; %i++)
         //   {
         //      if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
         //      {
         //         if((%i.owner != %player)&&(getDistance(%vehicleId, %i) <= 300))
         //         {
         //            %num++;
         //         }
         //      }
         //   }
         //}
         if(%num == 0)
         {
            %shots = 0;
            say(%player, %player, "<F5>Cannot cast spell. There are no targets within range.");
            return;
         }
         else if(%num == 1)
         {
            %shots = 5;
            playSound(%player, "sfx_shrk.wav", IDPRF_2D);
            schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 0.33);
            schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 0.66);
            schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 1);
            schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 1.33);
         }
         else if(%num == 2)
         {
            %shots = 3;
            playSound(%player, "sfx_shrk.wav", IDPRF_2D);
            schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 0.33);
            schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 0.66);
         }
         else if(%num == 3)
         {
            %shots = 2;
            playSound(%player, "sfx_shrk.wav", IDPRF_2D);
            schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 0.33);
         }
         else if(%num >= 4)
         {
            %shots = 1;
            playSound(%player, "sfx_shrk.wav", IDPRF_2D);
         }         
         spendMana(%player);
         say(%player, %player, "<F4>Casting FireStorm...");
         for(%i = 0; %i < %count; %i++)
         {
            %player2 = playerManager::getPlayerNum(%i);
            %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
            if((%player2 != %player)&&(getDistance(%vehicleId, %vehicleId2) <= 300))
            {
               if($server::TeamPlay == true)
               {
                  if(getTeam(%player2) != %team)
                  {
                     %target = playerManager::playerNumToVehicleId(%player2);
                     shootIons(%vehicleId, %target, %shots);
                  }                  
               }
               else
               {
                  %target = playerManager::playerNumToVehicleId(%player2);
                  shootIons(%vehicleId, %target, %shots);
               }
            }
         }
         //if($server::TeamPlay == true)
         //{
         //   for(%i = 8000; %i <= 10000; %i++)
         //   {
         //      if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
         //      {
         //         if((getTeam(%i) != getTeam(%player))&&(getDistance(%vehicleId, %i) <= 300))
         //         {
         //            shootIons(%vehicleId, %i, %shots);
         //         }
         //      }
         //   }
         //}
         //else
         //{
         //   for(%i = 8000; %i <= 10000; %i++)
         //   {
         //      if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
         //      {
         //         if((%i.owner != %player)&&(getDistance(%vehicleId, %i) <= 300))
         //         {
         //            shootIons(%vehicleId, %i, %shots);
         //         }
         //      }
         //   }
         //}
      }
   }
   else if(%player.spell == "Repel")
   {
      if(hasMana(%player) == true)
      {
         %num = 0;
         %count = playerManager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player2 = playerManager::getPlayerNum(%i);
            %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
            if((%player2 != %player)&&(getDistance(%vehicleId, %vehicleId2) <= 300)&&(%player2.trapped == false)&&(%player2.haste == false)&&(%player2.repel == false))
            {
               %num++;
            }
         }
         //for(%i = 8000; %i <= 10000; %i++)
         //{
         //   if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
         //   {
         //      if(getDistance(%vehicleId, %i) <= 300)
         //      {
         //         %num++;
         //      }
         //   }
         //}
         if(%num == 0)
         {
            say(%player, %player, "<F5>Cannot cast spell. There are no targets within range.");
            return;
         }
         else
         {
            spendMana(%player);
            %wave = copyObject($wave);
            addToSet(%player.group, %wave);
            %x1 = getPosition(%vehicleId, x);
            %y1 = getPosition(%vehicleId, y);
            %z1 = getPosition(%vehicleId, z) + 3;
            addToSet(%player.group, %wave);
            schedule("setPosition(" @ %wave @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 @ ");", 0.1);
            schedule("playAnimSequence(" @ %wave @ ", 0, true);", 0.2);
            schedule("deleteObject(" @ %wave @ ");", 1.867);
            say(%player, %player, "<F4>Casting Repel...");
            playSound(%player, "bc_mfd.wav", IDPRF_2D);
            for(%i = 0; %i < %count; %i++)
            {
               %player2 = playerManager::getPlayerNum(%i);
               %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
               if((%player2 != %player)&&(getDistance(%vehicleId, %vehicleId2) <= 300)&&(%player2.trapped == false)&&(%player2.haste == false)&&(%player2.repel == false))
               {
                  playSound(%player2, "bc_mfd.wav", IDPRF_2D);
                  %x2 = getPosition(%vehicleId2, x);
                  %y2 = getPosition(%vehicleId2, y);
                  %angle = round(adjustAngle(getAngle(%x1, %y1, %x2, %y2)));
                  %dist = 300;
                  %speed = 5;
                  %xOffset = %speed * cos(%angle);
                  %yOffset = %speed * sin(%angle);
                  %increments = %dist / %speed;
                  %height = %dist / 5;
                  %zOffset = 3 * (%height / %increments);
                  %initHeight = getPosition(%vehicleId2, z);
                  %finalHeight = %initHeight + %height;
                  %dir = 0;
                  %inc = %increments / 3;
                  %player2.repel = true;
                  say(%player2, %player2, "<F4>Your vehicle is being repelled by " @ getName(%player) @ ".");
                  fly(%vehicleId2, %xOffset, %yOffset, %zOffset, %finalHeight, %dir, %dist, %inc);
               }
            }
            //for(%i = 8000; %i <= 10000; %i++)
            //{
            //   if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
            //   {
            //      if(getDistance(%vehicleId, %i) <= 300)
            //      {
            //         %x2 = getPosition(%i, x);
            //         %y2 = getPosition(%i, y);
            //         %angle = round(adjustAngle(getAngle(%x1, %y1, %x2, %y2)));
            //         %dist = 300;
            //         %speed = 5;
            //         %xOffset = %speed * cos(%angle);
            //         %yOffset = %speed * sin(%angle);
            //         %increments = %dist / %speed;
            //         %height = %dist / 5;
            //         %zOffset = 3 * (%height / %increments);
            //         %initHeight = getPosition(%i, z);
            //         %finalHeight = %initHeight + %height;
            //         %dir = 0;
            //         %inc = %increments / 3;
            //         fly(%i, %xOffset, %yOffset, %zOffset, %finalHeight, %dir, %dist, %inc);
            //      }
            //   }
            //}
         }
      }
   }
   else if(%player.spell == "Deflect")
   {
      if(%player.deflect == true)
      {
         say(%player, %player, "<F5>You already have a deflector shield protecting your vehicle.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            %player.deflect = true;
            %player.deflectCount = 8;
            %player.shield = copyObject($deflect);
            addToSet(%player.group, %player.shield);
            setHudTimer(0,-1,"",1,%player);           
            setHudTimer(60,-1,"Deflector Shield:",1,%player);
            %x = getPosition(%vehicleId, x);
            %y = getPosition(%vehicleId, y);
            %z = getPosition(%vehicleId, z) - 17;
            setPosition(%player.shield, %x, %y, %z);            
            say(%player, %player, "<f4>Casting Deflect...", "sfx_electrical_bzzt.wav");
            deflectorShield(%player, %vehicleId, 300);
         }
      } 
   }
   else if(%player.spell == "DinsFire")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         %explosion = copyObject($explosion);
         addToSet(%player.group, %explosion);
         say(%player, %player, "<F4>Casting Din's Fire...");
         playSound(%player, "sfx_quake.wav", IDPRF_2D);
         playSound(%player, "explo3.wav", IDPRF_2D);
         playSound(%player, "sfx_fire.wav", IDPRF_2D);
         schedule("playSound(" @ %player @ ", \"sfx_fire.wav\", IDPRF_2D);", 1);
         %count = playerManager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player2 = playerManager::getPlayerNum(%i);
            %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
            %dist = getDistance(%vehicleId, %vehicleId2);
            if((%player2 != %player)&&(%dist <= 150))
            {
               playSound(%player2, "sfx_quake.wav", IDPRF_2D);
               playSound(%player2, "explo3.wav", IDPRF_2D);
               playSound(%player2, "sfx_fire.wav", IDPRF_2D);
               schedule("playSound(" @ %player2 @ ", \"sfx_fire.wav\", IDPRF_2D);", 1);
               %vehicleId2.deathMethod = "DinsFire";
               %vehicleId2.killer = %player;
               if(%dist > 100)
               {
                  schedule("healObject(" @ %vehicleId2 @ ", -9000);", 1.5); 
                  schedule("resetDeath(" @ %vehicleId2 @ ");", 2.5);   
               }
               else if((%dist > 50)&&(%dist <= 100))
               {
                  schedule("healObject(" @ %vehicleId2 @ ", -10000);", 1); 
                  schedule("resetDeath(" @ %vehicleId2 @ ");", 2);   
               }
               else if(%dist <= 50)
               {
                  schedule("healObject(" @ %vehicleId2 @ ", -11000);", 0.5); 
                  schedule("resetDeath(" @ %vehicleId2 @ ");", 1.5);   
               }
            }
         }
         //for(%i = 8000; %i <= 10000; %i++)
         //{
         //   if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
         //   {
         //      %dist = getDistance(%vehicleId, %i);
         //      if(%dist <= 150)
         //      {
         //         %i.deathMethod = "DinsFire";
         //         %i.killer = %player;
         //         if(%dist > 100)
         //         {
         //            schedule("healObject(" @ %i @ ", -9000);", 1.5); 
         //            schedule("resetDeath(" @ %i @ ");", 2.5);   
         //         }
         //         else if((%dist > 50)&&(%dist <= 100))
         //         {
         //            schedule("healObject(" @ %i @ ", -10000);", 1); 
         //            schedule("resetDeath(" @ %i @ ");", 2);   
         //         }
         //         else if(%dist <= 50)
         //         {
         //            schedule("healObject(" @ %i @ ", -11000);", 0.5); 
         //            schedule("resetDeath(" @ %i @ ");", 1.5);   
         //         }
         //      }                       
         //   }
         //}
         %x = getPosition(%vehicleId, x);
         %y = getPosition(%vehicleId, y);
         %z = getPosition(%vehicleId, z);
         setPosition(%explosion, %x, %y, %z);
         schedule("playAnimSequence(" @ %explosion @ ", 0, true);",0.25);
         schedule("deleteObject(" @ %explosion @ ");", 5.2);
      }
   }
   else if(%player.spell == "Shield")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         %shield1 = copyObject($shield);
         addToSet(%player.group, %shield1);
         setTeam(%shield1, getTeam(%player));
         %shield2 = copyObject($shield);
         addToSet(%player.group, %shield2);
         setTeam(%shield2, getTeam(%player));
         %shield3 = copyObject($shield);
         addToSet(%player.group, %shield3);
         setTeam(%shield3, getTeam(%player));
         %angle1 = adjustAngle(radToDeg(getPosition(%vehicleId, rot)) + 90);
         %angle2 = %angle1 - 45;
         %angle3 = %angle1 + 45;
         %xDist1 = 22 * cos(%angle1);
         %yDist1 = 22 * sin(%angle1);
         %var = 30 / sqrt(2);
         %xDist2 = (30 + %var) * cos(%angle1 - 90);
         %yDist2 = (30 + %var) * sin(%angle1 - 90);
         %xDist3 = (30 + %var) * cos(%angle1 + 90);
         %yDist3 = (30 + %var) * sin(%angle1 + 90);
         %x = getPosition(%vehicleId, x);
         %y = getPosition(%vehicleId, y);
         %x1 = %x + %xDist1;
         %y1 = %y + %yDist1;
         %x2 = %x + %xDist2;
         %y2 = %y + %yDist2;
         %x3 = %x + %xDist3;
         %y3 = %y + %yDist3;
         %z1 = getTerrainHeight(%x1, %y1) + 24;
         %z2 = getTerrainHeight(%x2, %y2) + 24;
         %z3 = getTerrainHeight(%x3, %y3) + 24;
         say(%player, %player, "<F4>Casting Shield...", "sfx_electrical_bzzt.wav");
         setPosition(%shield1, %x1, %y1, %z1, %angle1, 180);
         setPosition(%shield2, %x2, %y2, %z2, %angle2, 180);
         setPosition(%shield3, %x3, %y3, %z3, %angle3, 180);
         schedule("deleteObject(" @ %shield1 @ ");", 90);
         schedule("deleteObject(" @ %shield2 @ ");", 90);
         schedule("deleteObject(" @ %shield3 @ ");", 90);
      }
   }
   else if(%player.spell == "Heal")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         say(%player, %player, "<F4>Casting Heal...", "repairs_complete.wav");
      }
   }
   else if(%player.spell == "Restore")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         healObject(%vehicleId, 99999);
         reloadObject(%vehicleId, 99999);
         reloadObject(%vehicleId, 99999);
         reloadObject(%vehicleId, 99999);
         reloadObject(%vehicleId, 99999);
         reloadObject(%vehicleId, 99999);
         say(%player, %player, "<F4>Casting Restore...", "repairs_complete.wav");
      }
   }
   else if(%player.spell == "Impale")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId)) == "0.000000 0.000000 0.000000")
      {
         say(%player, %player, "<f5>You must first set a nav marker to specify the location to cast Impale.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            %access = true;
            %nav = getVehicleNavMarkerId(%vehicleId);
            for(%i = 1; %i <= 5; %i++)
            {
               if((%access == true)&&(getDistance(%nav, $nav[%i]) <= 150))
               {
                  %access = false;
               }
            }
            if(%access == true)
            {
               spendMana(%player);
               %x = getPosition(%nav, x);
               %y = getPosition(%nav, y);
               impale(%player, %x, %y, 5);
               say(%player, %player, "<F4>Casting Impale...");
            }
            else
            {
               say(%player, %player, "<F5>You cannot cast Impale on sacred ground! Impale traps must be placed at least 150 meters away from a base.");
            }
         }
      }
   }
   else if(%player.spell == "Cloak")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         setVehicleRadarVisible(%vehicleId, false);
         say(%player, %player, "<F4>Casting Cloak of Darkness...", "bc_mfd.wav");
      }
   }
   else if(%player.spell == "RevealTruth")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         say(%player, %player, "<F4>Casting Reveal Truth...", "sfx_cybrid_alarm.wav");
         %name = getName(%player);
         %count = playerManager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player2 = playerManager::getPlayerNum(%i);
            %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
            setVehicleRadarVisible(%vehicleId2, true);
            if(%player2 != %player)
            {               
               say(%player2, %player2, "<F2>" @ %name @ " has cast Reveal Truth!\n<F4>All players using Cloak of Darkness are now visible to radar.", "sfx_cybrid_alarm.wav");
            }
         }
      }
   }
   else if(%player.spell == "Plague")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId)) == "0.000000 0.000000 0.000000")
      {
         say(%player, %player, "<f5>You must first set a nav marker to specify the location to cast the Plague of Fire.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Casting Plague of Fire...", "sfx_fire.wav");
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getPosition(%nav, x);
            %y = getPosition(%nav, y);
            plagueOfFire(%player, %x, %y, 15);         
         }
      }
   }
   else if(%player.spell == "DeathTrap")
   {
      if(hasMana(%player) == true)
      {
         %access = true;
         for(%i = 1; %i <= 5; %i++)
         {
            if((%access == true)&&(getDistance(%vehicleId, $nav[%i]) <= 150))
            {
               %access = false;
            }
         }
         if(%access == true)
         {
            spendMana(%player);
            %trigger = copyObject($deathTrap);
            addToSet(%player.group, %trigger);
            setPosition(%trigger, 10000, 10000, -5000);
            %trigger.obj = copyObject($hut);
            addToSet(%player.group, %trigger.obj);
            setPosition(%trigger.obj, 10000, 10000, -5000);
            %trigger.obj2 = copyObject($pod);
            addToSet(%player.group, %trigger.obj2);
            setPosition(%trigger.obj2, 10000, 10000, -5000);
            %trigger.owner = %player;
            %trigger.victim = "";
            playAnimSequence(%trigger.obj, 0, true);
            %x = getPosition(%vehicleId, x);
            %y = getPosition(%vehicleId, y);
            %z = getTerrainHeight(%x, %y);
            say(%player, %player, "<F4>Casting DeathTrap...", "C5_pbbbbbt.wav");
            setHudTimer(0, -1, "", 2, %player);          
            setHudTimer(10, -1, "DeathTrap Arms In:" , 2, %player);
            schedule("armDeathTrap(" @ %trigger @ ", " @ %x @ ", " @ %y @ ", " @ %z @ ");", 10);
         }
         else
         {
            say(%player, %player, "<F5>You cannot lay a DeathTrap on sacred ground! DeathTraps must be placed at least 150 meters away from a base.");
         }
      }
   }
   else
   {
      castSpell2(%player);
   }
}

function castSpell2(%player)
{
   %vehicleId = playerManager::playerNumToVehicleId(%player);
   if(%player.spell == "RainOfDeath")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId)) == "0.000000 0.000000 0.000000")
      {
         say(%player, %player, "<f5>You must first set a nav marker to specify the location to cast the Rain of Death.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Casting Rain of Death...");
            %nav = getVehicleNavMarkerId(%vehicleId);
            %count = playerManager::getPlayerCount();
            for(%i = 0; %i < %count; %i++)
            {
               %player2 = playerManager::getPlayerNum(%i);
               %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
               if((getDistance(%vehicleId2, %nav) <= 500)||(%player2 == %player))
               {
                  playSound(%player2, "sfx_thunder2.wav", IDPRF_2D);
                  playSound(%player2, "sfx_quake.wav", IDPRF_2D);
               }
            }
            %x = getPosition(%nav, x);
            %y = getPosition(%nav, y);
            %z = getTerrainHeight(%x, %y);
            %x1 = %x - 500;
            %y1 = %y - 500;
            %x2 = %x + 500;
            %y2 = %y + 500;
            startRain(%player, %x1, %y1, %x2, %y2);
            schedule("startRain(" @ %player @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %x2 @ ", " @ %y2 @ ");", 1);
            schedule("startRain(" @ %player @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %x2 @ ", " @ %y2 @ ");", 2);
            schedule("startRain(" @ %player @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %x2 @ ", " @ %y2 @ ");", 3);
         }
      }
   }
   else if(%player.spell == "Ghost")
   {
      if(hasMana(%player) == true)
      {
         %count = playerManager::getPlayerCount();
         %smallestDist = 9999999;
         %victim = "";
         if($server::teamplay == true)
         {
            %team = getTeam(%player);
            for(%i = 0; %i < %count; %i++)
            {
               %player2 = playerManager::getPlayerNum(%i);
               %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
               %dist = getDistance(%vehicleId, %vehicleId2);
               if((%player2 != %player)&&(isGroupDestroyed(%vehicleId2) == false)&&(%vehicleId2 != 0)&&(getTeam(%player2) != %team)&&(%dist < %smallestDist))
               {
                  %smallestDist = %dist;
                  %victim = %vehicleId2;
               }
            }
         }
         else
         {
            for(%i = 0; %i < %count; %i++)
            {
               %player2 = playerManager::getPlayerNum(%i);
               %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
               %dist = getDistance(%vehicleId, %vehicleId2);
               if((%player2 != %player)&&(isGroupDestroyed(%vehicleId2) == false)&&(%vehicleId2 != 0)&&(%dist < %smallestDist))
               {
                  %smallestDist = %dist;
                  %victim = %vehicleId2;
               }
            }
         }
         if(%victim == "")
         {
            say(%player, %player, "<F5>Cannot cast spell. There are no enemy players spawned.");
            return;
         }
         spendMana(%player);
         %ghost = copyObject($ghost);        
         addToSet(%player.group, %ghost);
         %ghost.owner = %player;
         setStaticShapeShortName(%ghost, "Ghost of " @ getName(%player));
         setStaticShapeLongName(%ghost, "Ghost of " @ getName(%player));
         %grave = copyObject($grave);        
         addToSet(%player.group, %grave);
         riseFromGrave(%ghost, %victim, %vehicleId, %grave);
      }
   }
}

function impale(%player, %x, %y, %num)
{    
   if((%num > 0)&&(%player.leftgame == false))
   {
      %num--;
      %trigger = copyObject($impale);
      addToSet(%player.group, %trigger);
      %trigger.owner = %player;
      %trigger.victim = "";
      %trigger.obj = copyObject($spike);
      addToSet(%player.group, %trigger.obj);
      %randomX = randomInt(%x - 150, %x + 150);
      %randomY = randomInt(%y - 150, %y + 150);
      %z = getTerrainHeight(%randomX, %randomY);
      setPosition(%trigger.obj, %randomX, %randomY, %z - 500);
      setPosition(%trigger, %randomX, %randomY, %z);
      playSound(%player, "C2_tattadit.wav", IDPRF_2D);
      schedule("impale(" @ %player @ ", " @ %x @ ", " @ %y @ ", " @ %num @ ");", 1);
   }
}

function impale::trigger::onEnter(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   if((%trigger.victim == "")&&(%player.haste == false)&&(%player.repel == false))
   {
      %trigger.victim = %vehicleId;
      %count = playerManager::getPlayerCount();
      for(%i = 0; %i < %count; %i++)
      {
         %player2 = playerManager::getPlayerNum(%i);
         %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
         if((getDistance(%vehicleId2, %trigger) <= 300)||(%player2 == %player))
         {
            playSound(%player2, "sfx_had.wav", IDPRF_2D);
            playSound(%player2, "sfx_cmd.wav", IDPRF_2D);
         }
      }
      setPosition(%trigger, 10000, 10000, -5000);
      %x = getPosition(%vehicleId, x);
      %y = getPosition(%vehicleId, y);
      %z = getTerrainHeight(%x, %y);
      setPosition(%trigger.obj, %x, %y, %z - 70);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 60 @ ");", 0.1);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 50 @ ");", 0.2);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 40 @ ");", 0.3);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 30 @ ");", 0.4);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 20 @ ");", 0.5);
      schedule("hurtVictim(" @ %trigger @ ", " @ %vehicleId @ ");", 0.5);
      schedule("say(" @ %player @ ", " @ %player @ ", \"<F4>Your vehicle has been impaled by a spike.\");", 0.5);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 10 @ ");", 0.6);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z @ ");", 0.7);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 5 @ ");", 4);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 10 @ ");", 4.1);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 15 @ ");", 4.2);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 20 @ ");", 4.3);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 25 @ ");", 4.4);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 30 @ ");", 4.5);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 35 @ ");", 4.6);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 40 @ ");", 4.7);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 45 @ ");", 4.8);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 50 @ ");", 4.9);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 55 @ ");", 5);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 60 @ ");", 5.1);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 65 @ ");", 5.2);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 70 @ ");", 5.3);
      schedule("setPosition(" @ %trigger.obj @ ", " @ %x @ ", " @ %y @ ", " @ %z - 100 @ ");", 5.4);
   }
}

function hurtVictim(%trigger, %vehicleId)
{
   %vehicleId.deathMethod = "Impale";
   %vehicleId.killer = %trigger.owner;
   healObject(%vehicleId, -5000);
   schedule("resetDeath(" @ %vehicleId @ ");", 1);
   schedule("cleanUpSpike(" @ %trigger @ ");", 5);
}

function cleanUpSpike(%trigger)
{   
   %trigger.owner = "";
   %trigger.victim = "";
   schedule("deleteObject(" @ %trigger.obj @ ");", 1);
   schedule("deleteObject(" @ %trigger @ ");", 2);
}

//------------------------------------------------------------------------
// I got the idea for the ghosts from Gen. Powio [MIB].
// The code is mine, but the concept is his.
//------------------------------------------------------------------------

function riseFromGrave(%ghost, %victim, %vehicleId, %grave)
{  
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player2 = playerManager::getPlayerNum(%i);
      %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
      if((getDistance(%vehicleId2, %grave) <= 300)||(%player2 == %player))
      {
         playSound(%player2, "sfx_cybrid_com.wav", IDPRF_2D);
      }
   }        
   %angle = radToDeg(getPosition(%vehicleId, rot));
   %xDist1 = 30 * cos(%angle + 90);
   %yDist1 = 30 * sin(%angle + 90);
   %xDist2 = 40 * cos(%angle + 90);
   %yDist2 = 40 * sin(%angle + 90);
   %x1 = getPosition(%vehicleId, x) + %xDist1;
   %y1 = getPosition(%vehicleId, y) + %yDist1;
   %z1 = getTerrainHeight(%x1, %y1);
   %x2 = getPosition(%vehicleId, x) + %xDist2;
   %y2 = getPosition(%vehicleId, y) + %yDist2;
   %z2 = getTerrainHeight(%x2, %y2);
   setPosition(%grave, %x, %y, %z - 30, %angle);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 28 @ ", " @ %angle @ ");", 0.1);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 26 @ ", " @ %angle @ ");", 0.2);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 24 @ ", " @ %angle @ ");", 0.3);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 22 @ ", " @ %angle @ ");", 0.4);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 20 @ ", " @ %angle @ ");", 0.5);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 18 @ ", " @ %angle @ ");", 0.6);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 16 @ ", " @ %angle @ ");", 0.7);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 14 @ ", " @ %angle @ ");", 0.8);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 12 @ ", " @ %angle @ ");", 0.9);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 10 @ ", " @ %angle @ ");", 1);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 8 @ ", " @ %angle @ ");", 1.1);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 6 @ ", " @ %angle @ ");", 1.2);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 4 @ ", " @ %angle @ ");", 1.3);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 - 2 @ ", " @ %angle @ ");", 1.4);
   schedule("setPosition(" @ %grave @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %z2 @ ", " @ %angle @ ");", 1.5);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 @ ");", 1.6);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 + 1 @ ");", 1.7);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 + 2 @ ");", 1.8);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 + 3 @ ");", 1.9);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 + 4 @ ");", 2);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 + 5 @ ");", 2.1);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 + 6 @ ");", 2.2);
   schedule("setPosition(" @ %ghost @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 + 7 @ ");", 2.3);
   %range = 3000;    //Ghosts will have a maximum life-span of 5 minutes 
   %attackNum = 25;  //How many times the ghost will attack before returning to its grave
   schedule("homing(" @ %ghost @ ", " @ %victim @ ", " @ %vehicleId @ ", " @ %range @ ", " @ %attackNum @ ", " @ %grave @");", 3);
}

function homing(%ghost, %victim, %vehicleId, %range, %attackNum, %grave)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %player2 = playerManager::vehicleIdToPlayerNum(%victim);
   if((%range > 0)&&(%player.leftgame == false))
   {
      %range--;
      %distance = getDistance(%ghost, %victim);
      if((%distance > 10)&&(isGroupDestroyed(%victim) == false)&&(%victim != 0)&&(%player2.leftgame == false))
      {
         %x1 = getPosition(%ghost, x);
         %y1 = getPosition(%ghost, y);
         %x2 = getPosition(%victim, x);
         %y2 = getPosition(%victim, y);
         %increments = %distance / 7;
         %xOffset = (%x2 - %x1) / %increments;
         %yOffset = (%y2 - %y1) / %increments;
         %x = %x1 + %xOffset;
         %y = %y1 + %yOffset;
         if((getVehicleName(%victim) == "Banshee") || (getVehicleName(%victim) == "Knight's Banshee") || (getVehicleName(%victim) == "Advocate") || (getVehicleName(%vehicleId) == "Banshee") || (getVehicleName(%vehicleId) == "Knight's Banshee") || (getVehicleName(%vehicleId) == "Advocate"))
         {
            %z1 = getPosition(%ghost, z);
            %z2 = getPosition(%victim, z);
            %increments = %distance / 7;
            %zOffset = (%z2 - %z1) / %increments;
            %z = %z1 + %zOffset;
         }
         else
         {
            %z = getTerrainHeight(%x1, %y1) + 7;
         }
         setPosition(%ghost, %x, %y, %z);
         schedule("homing(" @ %ghost @ ", " @ %victim @ ", " @ %vehicleId @ ", " @ %range @ ", " @ %attackNum @ ", " @ %grave @ ");", 0.1);
      }
      else if((%distance <= 10)&&(isGroupDestroyed(%victim) == false)&&(%victim != 0)&&(%player2.leftgame == false))
      {
         impact(%ghost, %victim, %vehicleId, %range, %attackNum, %grave);
      }
      else
      {
         findNewTarget(%ghost, %victim, %vehicleId, %range, %attackNum, %grave);
      }
   }
   else
   {
      %ghost.owner = "";
      deleteObject(%ghost);
      deleteObject(%grave);
      say(%player, %player, "<F4>Your ghost has returned to its grave.", "sfx_cybrid_com.wav");
   }
}

function impact(%ghost, %victim, %vehicleId, %range, %attackNum, %grave)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %player2 = playerManager::vehicleIdToPlayerNum(%victim);
   %attackNum--;
   %victim.deathMethod = "Ghost";
   %victim.killer = %player;
   healObject(%victim, -1500);
   schedule("resetDeath(" @ %victim @ ");", 1);
   fadeEvent(%player2, in, 0.5, 0, 0, 0.75);
   playSound(%player2, "sfx_cybrid_com.wav", IDPRF_2D);
   if(%attackNum > 0)
   {
      if(isGroupDestroyed(%victim) == true)
      {
         findNewTarget(%ghost, %victim, %vehicleId, %range, %attackNum, %grave);
      }
      else
      {
         prepareNextAttack(%ghost, %victim, %vehicleId, %range, %attackNum, %grave);
      }
   }
   else
   {
      %ghost.owner = "";
      deleteObject(%ghost);
      deleteObject(%grave);
      say(%player, %player, "<F4>Your ghost has returned to its grave.", "sfx_cybrid_com.wav");
   }
}

function findNewTarget(%ghost, %victim, %vehicleId, %range, %attackNum, %grave)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %victim = "";
   %smallestDist = 9999999;
   %count = playerManager::getPlayerCount();
   if($server::teamplay == true)
   {
      %team = getTeam(%player);
      for(%i = 0; %i < %count; %i++)
      {
         %player2 = playerManager::getPlayerNum(%i);
         %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
         %dist = getDistance(%ghost, %vehicleId2);
         if((%player2 != %player)&&(isGroupDestroyed(%vehicleId2) == false)&&(%vehicleId2 != 0)&&(getTeam(%player2) != %team)&&(%dist < %smallestDist))
         {
            %smallestDist = %dist;
            %victim = %vehicleId2;
         }
      }
   }
   else
   {
      for(%i = 0; %i < %count; %i++)
      {
         %player2 = playerManager::getPlayerNum(%i);
         %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
         %dist = getDistance(%ghost, %vehicleId2);
         if((%player2 != %player)&&(isGroupDestroyed(%vehicleId2) == false)&&(%vehicleId2 != 0)&&(%dist < %smallestDist))
         {
            %smallestDist = %dist;
            %victim = %vehicleId2;
         }
      }
   }
   if(%victim == "")
   {
      %ghost.owner = "";
      deleteObject(%ghost);
      deleteObject(%grave);
      say(%player, %player, "<F4>Your ghost has returned to its grave.", "sfx_cybrid_com.wav");
   }
   else
   {
      schedule("homing(" @ %ghost @ ", " @ %victim @ ", " @ %vehicleId @ ", " @ %range @ ", " @ %attackNum @ ", " @ %grave @ ");", 0.1);     
   }
}

function prepareNextAttack(%ghost, %victim, %vehicleId, %range, %attackNum, %grave)
{
   %x1 = getPosition(%victim, x);
   %y1 = getPosition(%victim, y);
   %x2 = getPosition(%ghost, x);
   %y2 = getPosition(%ghost, y);
   %deltaX = %x2 - %x1;
   %deltaY = %y2 - %y1;
   %angle = getVector(%deltaX, %deltaY);
   %xDist = 30 * cos(%angle);
   %yDist = 30 * sin(%angle);
   %x = %x1 + %xDist;
   %y = %y1 + %yDist;
   if((getVehicleName(%victim) == "Banshee") || (getVehicleName(%victim) == "Knight's Banshee") || (getVehicleName(%victim) == "Advocate") || (getVehicleName(%vehicleId) == "Banshee") || (getVehicleName(%vehicleId) == "Knight's Banshee") || (getVehicleName(%vehicleId) == "Advocate"))
   {
      %z = getPosition(%victim, z);
   }
   else
   {            
      %z = getTerrainHeight(%x, %y) + 7;
   }
   setPosition(%ghost, %x, %y, %z);
   schedule("homing(" @ %ghost @ ", " @ %victim @ ", " @ %vehicleId @ ", " @ %range @ ", " @ %attackNum @ ", " @ %grave @ ");", 0.1);
}

function resetPoisonLock(%player)
{
   %player.poisonlock = false;
}

function shield::structure::onDestroyed(%destroyed, %destroyer)
{
   schedule("deleteObject(" @ %destroyed @ ");", 1);
}

function startRain(%player, %x1, %y1, %x2, %y2)
{
   %meteorite = copyObject($meteorite);
   addToSet(%player.group, %meteorite);
   %meteorite.owner = %player;
   rainOfDeath(%meteorite, %x1, %y1, %x2, %y2);
}

function rainOfDeath(%meteorite, %x1, %y1, %x2, %y2)
{
	dropMeteor2("default", 1, 3, %x1, %y1, %x2, %y2, %x1, %y1, %x2, %y2, %meteorite);
    
      %dropMeteors = "dropMeteor2(\"default\", 1, 3, " @ %x1 @ ", " @ %y1 @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %x2 @ ", " @ %y2 @ ", " @ %meteorite @ ");";

	schedule(%dropMeteors, 4);
	schedule(%dropMeteors, 8);
	schedule(%dropMeteors, 12);
	schedule(%dropMeteors, 16);
	schedule(%dropMeteors, 20);
	schedule(%dropMeteors, 24);
	schedule(%dropMeteors, 28);
	schedule(%dropMeteors, 32);
	schedule(%dropMeteors, 36);
	schedule(%dropMeteors, 40);
	schedule(%dropMeteors, 44);
	schedule(%dropMeteors, 48);
	schedule(%dropMeteors, 52);
	schedule(%dropMeteors, 56);
	schedule(%dropMeteors, 60);
	schedule(%dropMeteors, 64);
	schedule(%dropMeteors, 68);
	schedule(%dropMeteors, 72);
	schedule(%dropMeteors, 76);
	schedule(%dropMeteors, 80);
	schedule(%dropMeteors, 84);
	schedule(%dropMeteors, 88);
	schedule(%dropMeteors, 92);
	schedule(%dropMeteors, 96);
	schedule(%dropMeteors, 100);
	schedule(%dropMeteors, 104);
	schedule(%dropMeteors, 108);
	schedule(%dropMeteors, 112);
	schedule(%dropMeteors, 116);
	schedule(%dropMeteors, 120);
      schedule("cleanUpMeteorite(" @ %meteorite @ ");", 150);
}

function cleanUpMeteorite(%meteorite)
{
   %meteorite.owner = "";
   deleteObject(%meteorite);
}

function dropMeteor2(%type, %rate, %count, %xHigh1, %yHigh1, %xHigh2, %yHigh2, %xLow1, %yLow1, %xLow2, %yLow2, %meteorite)
{
	%ceiling = 1800;

	if(%xHigh2 == "") %xHigh2 = 0;
	if(%yHigh2 == "") %yHigh2 = 0;
	if(%xLow1 == "") %xLow1 = 0;
	if(%yLow1 == "") %yLow1 = 0;
	if(%xLow2 == "") %xLow2 = 0;
	if(%yLow2 == "") %yLow2 = 0;

	if(%xLow1 == 0 && %xLow2 == 0 && %yLow1 == 0 && %yLow2 == 0)
      {
		%xLow1 = %xHigh1;
		%xLow2 = %xHigh2;
		%yLow1 = %yHigh1;
		%yLow2 = %yHigh2;
	}

	%startX = randomInt(%xHigh1, %xHigh2);
	%startY = randomInt(%yHigh1, %yHigh2);

	%endX = randomInt(%xLow1, %xLow2);
	%endY = randomInt(%yLow1, %yLow2);

	if(%type == "focus")
      {
		%startX = %endX = %xHigh1;
		%startY = %endY = %yHigh1;		
	}
	else if(%type == "focalStart")
      {
		%startX = %xLow1;
		%startY = %yLow1;
	}
	else if(%type == "focalEnd")
      {
		%endX = %xLow1;
		%endY = %yLow1;
	}
	else if(%type == "vertical")
      {
		%startX = %endX;
		%startY = %endY;
	}

	%endZ = getTerrainHeight(%endX, %endY);

	// Determine when the next meteorite will fall
	%when = %rate;
	if(%when < 0)
      {
		%when = %when * -1;
		%when = randomFloat(0, %when);
	}

	if(count != -1)
		%count = %count - 1;

	%nextMeteorite = "dropMeteor2(";
	%nextMeteorite = strcat(%nextMeteorite, %type, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %rate, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %count, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %xHigh1, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %yHigh1, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %xHigh2, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %yHigh2, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %xLow1, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %yLow1, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %xLow2, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %yLow2, ", ");
	%nextMeteorite = strcat(%nextMeteorite, %meteorite, ");");

	dropPod(%startX, %startY, %ceiling, %endX, %endY, %endZ, %meteorite);
	
	// This next bit calculates when the meteor hits the ground and damages the herc when it does...
	%timeDrop = ((%endX - %startX) * (%endX - %startX));
	%timeDrop = %timeDrop + ((%endY - %startY) * (%endY - %startY));
	%timeDrop = %timeDrop + ((%ceiling - %endZ) * (%ceiling - %endZ));
	%timeDrop = sqrt(%timeDrop);
	%timeDrop = %timeDrop / 400;

	schedule("damageArea(" @ %meteorite @ ", 0, 0, 0, 150, 2000);", %timeDrop);

	if(%count != 0)
		schedule(%nextMeteorite, %when);
}

function plagueOfFire(%player, %x, %y, %timer)
{
   if((%timer > 0)&&(%player.leftgame == false))
   {
      %timer--;
      %flame1 = copyObject($flame);
      addToSet(%player.group, %flame1);
      %flame2 = copyObject($flame);
      addToSet(%player.group, %flame2);
      %flame3 = copyObject($flame);
      addToSet(%player.group, %flame3);
      %flame4 = copyObject($flame);
      addToSet(%player.group, %flame4);
      %trigger = copyObject($plague);
      addToSet(%player.group, %trigger);
      %trigger.owner = %player;
      %fireX = randomInt(%x - 300, %x + 300);
      %fireY = randomInt(%y - 300, %y + 300);
      %fireZ = getTerrainHeight(%fireX, %fireY);
      setPosition(%flame1, %fireX, %fireY, %fireZ, 0);
      setPosition(%flame2, %fireX, %fireY, %fireZ, 90);
      setPosition(%flame3, %fireX, %fireY, %fireZ, 180);
      setPosition(%flame4, %fireX, %fireY, %fireZ, 270);
      setPosition(%trigger, %fireX, %fireY, %fireZ);
      schedule("cleanUpFire(" @ %flame1 @ ", " @ %flame2 @ ", " @ %flame3 @ ", " @ %flame4 @ ", " @ %trigger @ ");", 120);
      schedule("plagueOfFire(" @ %player @ ", " @ %x @ ", " @ %y @ ", " @ %timer @ ");", 1);
   }
}

function cleanUpFire(%flame1, %flame2, %flame3, %flame4, %trigger)
{
   %trigger.owner = "";
   deleteObject(%flame1);
   deleteObject(%flame2);
   deleteObject(%flame3);
   deleteObject(%flame4);
   deleteObject(%trigger);
}

function plague::trigger::onEnter(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %vehicleId.deathMethod = "Plague";
   %vehicleId.killer = %trigger.owner;
}

function plague::trigger::onContact(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   healObject(%vehicleId, -1000);
   if(%player != 0)
   {
      playSound(%player, "sfx_fire.wav", IDPRF_2D);
   }
}

function plague::trigger::onLeave(%trigger, %vehicleId)
{
   schedule("resetDeath(" @ %vehicleId @ ");", 1);
}

function haste(%vehicleId, %xOffset, %yOffset, %increments)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   if((%increments > 1)&&(isGroupDestroyed(%vehicleId) == false)&&(%player.leftgame == false))
   {
      %increments--;
      %x = getPosition(%vehicleId, x) + %xOffset;
      %y = getPosition(%vehicleId, y) + %yOffset;
      %z = getTerrainHeight(%x, %y);
      setPosition(%vehicleId, %x, %y, %z);
      schedule("haste(" @ %vehicleId @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %increments @ ");", 0.1);
   }
   else
   {
      %player.haste = false;
      if(isGroupDestroyed(%vehicleId) == false)
      {
         say(%player, %player, "<F4>You have reached your destination.", "C2_tattadit.wav");
      }
   }
}

function armDeathTrap(%trigger, %x, %y, %z)
{
   %player = %trigger.owner;
   setPosition(%trigger, %x, %y, %z);
   setPosition(%trigger.obj, %x, %y, %z - 100);
   say(%player, %player, "<F4>DeathTrap Armed.", "C2_tattadit.wav");
}

function deathtrap::trigger::onEnter(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   if((%trigger.victim == "")&&(%player.haste == false)&&(%player.repel == false))
   {
      %player.trapped = true;
      %x = getPosition(%trigger, x);
      %y = getPosition(%trigger, y);
      %z = getTerrainHeight(%x, %y);
      hold(%vehicleId, %trigger, 25);
      %trigger.victim = %vehicleId;
      %vehicleId.deathMethod = "DeathTrap";
      %vehicleId.killer = %trigger.owner;
      setPosition(%trigger.obj, %x, %y, %z - 6);
      %count = playerManager::getPlayerCount();
      for(%i = 0; %i < %count; %i++)
      {
         %player2 = playerManager::getPlayerNum(%i);
         %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
         if(getDistance(%trigger, %vehicleId2) <= 300)
         {
            playSound(%player2, "sfx_steam.wav", IDPRF_2D);
            schedule("playSound(" @ %player2 @ ", \"sfx_machine2.wav\", IDPRF_2D);", 0.5);
            schedule("playSound(" @ %player2 @ ", \"sfx_machine1.wav\", IDPRF_2D);", 2.25);
            if(%player2 != %player)
            {
               schedule("playSound(" @ %player2 @ ", \"sfx_fire.wav\", IDPRF_2D);", 6.25);
            }
         }
      }
      if(%player != 0)
      {
         schedule("say(" @ %player @ ", " @ %player @ ", \"<F4>Your vehicle has been caught in a DeathTrap. Prepare to die.\");", 3.25);
      }
      schedule("playAnimSequence(" @ %trigger.obj @ ", 0, false);", 0.25);
      schedule("setPosition(" @ %trigger.obj2 @ ", " @ %x @ ", " @ %y @ ", " @ %z - 30 @ ");", 6.25);
      schedule("killVictim(" @ %trigger @ ", " @%vehicleId @ ");", 6.25);
   }
}

function hold(%vehicleId, %where, %timer)
{
   if(%timer > 0)
   {
      %timer--;
      %x = getPosition(%where, x);
      %y = getPosition(%where, y);
      %z = getTerrainHeight(%x, %y);
      setPosition(%vehicleId, %x, %y, %z);
      //order(%vehicleId, guard, %where);
      schedule("hold(" @ %vehicleId @ ", " @ %where @ ", " @ %timer @ ");", 0.25);
   }
}


function killVictim(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   if((isGroupDestroyed(%vehicleId) == false)&&(%player.leftgame == false))
   {      
      %x = getPosition(%trigger, x);
      %y = getPosition(%trigger, y);
      %z = getTerrainHeight(%x, %y);
      setPosition(%vehicleId, %x, %y, %z);
      //order(%vehicleId, guard, %trigger);
      healObject(%vehicleId, -250);
      if(%player != 0)
      {
         playSound(%player, "sfx_fire.wav", IDPRF_2D);
      }
      schedule("killVictim(" @ %trigger @ ", " @ %vehicleId @ ");", 0.25);
   }
   else
   {
      order(%vehicleId, clear);
      openPod(%trigger);
   }
}

function openPod(%trigger)
{
   setPosition(%trigger, 10000, 10000, -5000);
   %trigger.owner = "";
   %trigger.victim = "";
   deleteObject(%trigger.obj2);
   %trigger.obj2 = "";
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player2 = playerManager::getPlayerNum(%i);
      %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
      if(getDistance(%trigger, %vehicleId2) <= 300)
      {
         playSound(%player2, "sfx_steam.wav", IDPRF_2D);
         schedule("playSound(" @ %player2 @ ", \"sfx_machine2.wav\", IDPRF_2D);", 0.5);
         schedule("playSound(" @ %player2 @ ", \"sfx_machine1.wav\", IDPRF_2D);", 2.25);
      }
   }
   playAnimSequence(%trigger.obj, 0, true);
   schedule("cleanUpDeathTrap(" @ %trigger @ ");", 4);
}

function cleanUpDeathTrap(%trigger)
{
   deleteObject(%trigger.obj);
   %trigger.obj = "";
   deleteObject(%trigger);
}

function deflectorShield(%player, %vehicleId, %timer)
{
   if(%player.deflect == false)
   {
      %player.deflectCount = 0;
      deleteObject(%player.shield);
   }
   else
   {
      if((%timer > 0)&&(%player.leftgame == false))
      {
         %timer--;
         %x = getPosition(%vehicleId, x);
         %y = getPosition(%vehicleId, y);
         %z = getPosition(%vehicleId, z) - 17;
         setPosition(%player.shield, %x, %y, %z);
         schedule("deflectorShield(" @ %player @ ", " @ %vehicleId @ ", " @ %timer @ ");", 0.2);
      }
      else
      {
         %player.deflect = false;
         %player.deflectCount = 0;
         deleteObject(%player.shield);
         say(%player, %player, "<F4>Your deflector shield's energy has been depleted.", "sfx_electrical_bzzt.wav");   
      }
   }
}

function shootIons(%vehicleId, %target, %shots)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %player2 = playerManager::vehicleIdToPlayerNum(%target);
   if((%shots > 0)&&(%target != ""))
   {
      %shots--;
      %x1 = getposition(%vehicleId, x);
      %y1 = getposition(%vehicleId, y);
      %z1 = getposition(%vehicleId, z) + 10;
      %x2 = getposition(%target, x);
      %y2 = getposition(%target, y);
      %z2 = getposition(%target, z);
      droppod(%x1, %y1, %z1, %x2, %y2, %z2);
      %distance = getdistance(%vehicleId, %target);
      %time = %distance / 400; //400 m/s (speed of drop pod)
      if(%player2 != 0)
      {
         if(%player2.deflect == true)
         {
            if(%player2.deflectCount > 0)
            {
               %player2.deflectCount--;
               schedule("shootIons(" @ %target @ ", " @ %vehicleId @ ", 1);", %time);
               if(%player2 != 0)
               {
                  schedule("playSound(" @ %player2 @ ", \"sfx_electrical_bzzt.wav\", IDPRF_2D);", %time);
               }
            }
            else
            {
               %player2.deflect = false;
               %player2.deflectCount = 0;
               deleteObject(%player2.shield);              
               setHudTimer(0,-1,"",1,%player2);   
               say(%player2, %player2, "<F4>Your deflector shield's energy has been depleted.", "sfx_electrical_bzzt.wav");   
            }
         }
         else
         {
            %target.deathMethod = "FireStorm";
            %target.killer = %player;
            schedule("healObject(" @ %target @ ", -2000);", %time);
            if(%player2 != 0)
            {
               schedule("playSound(" @ %player2 @ ", \"explo3.wav\", IDPRF_2D);", %time);
            }
         }
      }
      else
      {
         %target.deathMethod = "FireStorm";
         %target.killer = %player;
         schedule("healObject(" @ %target @ ", -2000);", %time);
         if(%player2 != 0)
         {
            schedule("playSound(" @ %player2 @ ", \"explo3.wav\", IDPRF_2D);", %time);
         }
      }
      schedule("shootIons(" @ %vehicleId @ ", " @ %target @ ", " @ %shots @ ");", 0.33);
   }
   else
   {
      schedule("resetDeath(" @ %target @ ");", 1);
   }
}

function resetDeath(%vehicleId)
{   
   %vehicleId.deathMethod = "";
   %vehicleId.killer = "";
}

function resetTrapped(%player)
{
   %player.trapped = false;
}

function vehicle::onScan(%scanned, %scanner)
{
   %player = playerManager::vehicleIdToPlayerNum(%scanner);
   %player2 = playerManager::vehicleIdToPlayerNum(%scanned);
   if(%player.spell == "Mana")
   {
      if(getVehicleName(%scanned) == false)
      {
         say(%player, %player, "<F5>You cannot transfer mana to a structure!");         
      }
      else if(%player2 == 0)
      {
         say(%player, %player, "<F5>You cannot transfer mana to an AI vehicle!");
      }
      else
      {
         if(%player2.mana >= 300)
         {
            say(%player, %player, "<F5>You cannot transfer mana to " @ getName(%player2) @ ". He has already reached his maximum capacity.");
         }
         else
         {
            if(hasMana(%player) == true)
            {
               say(%player, %player, "<F4>Tranferring mana to " @ getName(%player2) @ "...");
               playSound(%player, "sfx_cybrid_alarm.wav", IDPRF_2D);
               playSound(%player2, "sfx_cybrid_alarm.wav", IDPRF_2D);
               if(%player.mana >= 10)
               {
                  %player.mana -= 10;
                  %player2.mana += 10;
                  say(%player2, %player2, "<F4>" @ getName(%player) @ " has transferred 10 mana to you. You currently have " @ %player2.mana @ " mana.");
               }
               else
               {
                  %player2.mana += %player.mana;
                  say(%player2, %player2, "<F4>" @ getName(%player) @ " has transferred " @ %player.mana @ " mana to you. You currently have " @ %player2.mana @ " mana.");
                  %player.mana = 0;
               }
            }
         }
      }
   }
   else if(%player.spell == "LifeForce")
   {      
      if(getVehicleName(%scanned) == false)
      {
         say(%player, %player, "<F5>You cannot transfer lifeforce to a structure!");         
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Tranferring lifeforce to " @ getName(%player2) @ "...");
            playSound(%player, "sfx_cybrid_alarm.wav", IDPRF_2D);
            healObject(%scanned, 5000);
            reloadObject(%scanned, 99999);
            if(%player2 != 0)
            {
               say(%player2, %player2, "<F4>" @ getName(%player) @ " has transferred some of his lifeforce to you.");
               playSound(%player2, "sfx_cybrid_alarm.wav", IDPRF_2D);
            }
            %scanner.deathMethod = "LifeForce";
            %scanner.killer = %scanned;
            healObject(%scanner, -2500);
            schedule("resetDeath(" @ %scanner @ ");", 1);
         }
      }
   }
   else if(%player.spell == "Levitate")
   {
      if(%player.trapped == true)
      {
         say(%player, %player, "<F5>Cannot cast Levitate. Your vehicle is currently trapped.");
      }
      else if(%player.haste == true)
      {
         say(%player, %player, "<F5>Cannot cast Levitate. Your are currently using Haste.");
      }
      else if(%player.repel == true)
      {
         say(%player, %player, "<F5>Cannot cast Levitate. Your vehicle is currently being repelled.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Casting Levitate...");
            levitate(%scanner);
         }
      }
   }
   else if(%player.spell == "Stasis")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         %player2.trapped = true;
         %field1 = copyObject($stasis);
         %field2 = copyObject($stasis);
         %field3 = copyObject($stasis);
         %field4 = copyObject($stasis);
         addToSet(%player.group,%field1);
         addToSet(%player.group,%field2);
         addToSet(%player.group,%field3);
         addToSet(%player.group,%field4);    
         %x = getposition(%scanned,x);
         %y = getposition(%scanned,y);
         %z1 = getTerrainHeight(%x,%y+30)+24;
         %z2 = getTerrainHeight(%x+30,%y)+24;
         %z3 = getTerrainHeight(%x,%y-30)+24;
         %z4 = getTerrainHeight(%x-30,%y)+24;
         setPosition(%field1,%x,%y+30,%z1,90,180);
         setPosition(%field2,%x+30,%y,%z2,0,180);
         setPosition(%field3,%x,%y-30,%z3,90,180);
         setPosition(%field4,%x-30,%y,%z4,0,180);
         say(%player,%player,"<f4>Casting Stasis...","sfx_electrical_bzzt.wav");
         if(%player2 != 0)
         {
            say(%player2,%player2,"<f4>Your vehicle has been temporarily trapped inside a stasis field.","sfx_electrical_bzzt.wav");
         }
         setHudTimer(0,-1,"",3,%player2);
         setHudTimer(60,-1,"Stasis Field:",3,%player2);
         schedule("deleteObject("@%field1@");",60);
         schedule("deleteObject("@%field2@");",60);
         schedule("deleteObject("@%field3@");",60);
         schedule("deleteObject("@%field4@");",60);         
         schedule("resetTrapped("@%player2@");",60);
      }
   }
   else if(%player.spell == "FireStorm")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         say(%player, %player, "<F4>Casting FireStorm...");
         playSound(%player, "sfx_shrk.wav", IDPRF_2D);
         schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 0.33);
         schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 0.66);
         schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 1);
         schedule("playSound(" @ %player @ ", \"sfx_shrk.wav\", IDPRF_2D);", 1.33);
         shootIons(%scanner, %scanned, 5);
      }
   }
   else if(%player.spell == "Repel")
   {
      if(hasMana(%player) == true)
      {
         %num = 0;
         %count = playerManager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player2 = playerManager::getPlayerNum(%i);
            %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
            if((%player2 != %player)&&(getDistance(%scanner, %vehicleId2) <= 300)&&(%player2.trapped == false)&&(%player2.haste == false)&&(%player2.repel == false))
            {
               %num++;
            }
         }
         //for(%i = 8000; %i <= 10000; %i++)
         //{
         //   if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
         //   {
         //      if(getDistance(%scanner, %i) <= 300)
         //      {
         //         %num++;
         //      }
         //   }
         //}
         if(%num == 0)
         {
            say(%player, %player, "<F5>Cannot cast spell. There are no targets within range.");
            return;
         }
         else
         {
            spendMana(%player);
            %wave = copyObject($wave);
            addToSet(%player.group, %wave);
            %x1 = getPosition(%scanner, x);
            %y1 = getPosition(%scanner, y);
            %z1 = getPosition(%scanner, z) + 3;
            addToSet(%player.group, %wave);
            schedule("setPosition(" @ %wave @ ", " @ %x1 @ ", " @ %y1 @ ", " @ %z1 @ ");", 0.1);
            schedule("playAnimSequence(" @ %wave @ ", 0, true);", 0.2);
            schedule("deleteObject(" @ %wave @ ");", 1.867);
            say(%player, %player, "<F4>Casting Repel...");
            playSound(%player, "bc_mfd.wav", IDPRF_2D);
            for(%i = 0; %i < %count; %i++)
            {
               %player2 = playerManager::getPlayerNum(%i);
               %vehicleId2 = playerManager::playerNumToVehicleId(%player2);
               if((%player2 != %player)&&(getDistance(%scanner, %vehicleId2) <= 300)&&(%player2.trapped == false)&&(%player2.haste == false)&&(%player2.repel == false))
               {
                  playSound(%player2, "bc_mfd.wav", IDPRF_2D);
                  %x2 = getPosition(%vehicleId2, x);
                  %y2 = getPosition(%vehicleId2, y);
                  %angle = round(adjustAngle(getAngle(%x1, %y1, %x2, %y2)));
                  %dist = 300;
                  %speed = 5;
                  %xOffset = %speed * cos(%angle);
                  %yOffset = %speed * sin(%angle);
                  %increments = %dist / %speed;
                  %height = %dist / 5;
                  %zOffset = 3 * (%height / %increments);
                  %initHeight = getPosition(%vehicleId2, z);
                  %finalHeight = %initHeight + %height;
                  %dir = 0;
                  %inc = %increments / 3;
                  %player2.repel = true;
                  say(%player2, %player2, "<F4>Your vehicle is being repelled by " @ getName(%player) @ ".");
                  fly(%vehicleId2, %xOffset, %yOffset, %zOffset, %finalHeight, %dir, %dist, %inc);
               }
            }
            //for(%i = 8000; %i <= 10000; %i++)
            //{
            //   if((getObjectName(%i) == "veh")||(getObjectName(%i) == "mirage"))
            //   {
            //      if(getDistance(%scanner, %i) <= 300)
            //      {
            //         %x2 = getPosition(%i, x);
            //         %y2 = getPosition(%i, y);
            //         %angle = round(adjustAngle(getAngle(%x1, %y1, %x2, %y2)));
            //         %dist = 300;
            //         %speed = 5;
            //         %xOffset = %speed * cos(%angle);
            //         %yOffset = %speed * sin(%angle);
            //         %increments = %dist / %speed;
            //         %height = %dist / 5;
            //         %zOffset = 3 * (%height / %increments);
            //         %initHeight = getPosition(%i, z);
            //         %finalHeight = %initHeight + %height;
            //         %dir = 0;
            //         %inc = %increments / 3;
            //         fly(%i, %xOffset, %yOffset, %zOffset, %finalHeight, %dir, %dist, %inc);
            //      }
            //   }
            //}
         }
      }
   }
   else if(%player.spell == "Enslave")
   {
      if(hasMana(%player) == true)
      {
         if(getVehicleName(%scanned) != false)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Casting Enslave on " @ getHudName(%scanned) @ "...", "bc_mfd.wav");
            enslave(%scanned, %scanner, %player, %player2, 30);
            if(%player2 != 0)
            {
               setHudTimer(0, -1, "", 2, %player2);          
               setHudTimer(30, -1, "Enslaved:" , 2, %player2);
               say(%player2, %player2, "<F4>Your vehicle has been enslaved by " @ getName(%player) @ ". The spell will wear off in 30 seconds.", "bc_mfd.wav");
            }
         }
         else
         {
            say(%player, %player, "<F5>You cannot cast Enslave on a structure!");
         }
      }
   }
   else if(%player.spell == "Venom")
   {
      if(getVehicleName(%scanned) == false)
      {
         say(%player, %player, "<F5>Cannot cast spell. Venom does not affect structures.");
      }
      else if(%player2 == 0)
      {
         say(%player, %player, "<F5>Cannot cast spell. Venom does not affect AI vehicles.");
      }
      else if((%player2.poisoned == true)||(%player2.poisonlock == true))
      {
         say(%player, %player, "<F5>Cannot cast spell. " @ getName(%player2) @ " is already poisoned.");
      }
      else
      {
         if(hasMana(%player) == true)
         {
            spendMana(%player);
            say(%player, %player, "<F4>Casting Venom on " @ getName(%player2) @ "...");
            playSound(%player, "bc_mfd.wav", IDPRF_2D);
            %player2.poisoned = true;
            say(%player2, %player2, "<F4>You have been poisoned by " @ getName(%player) @ "'s venom! You must drink the Anti-Venom to survive!");
            playSound(%player2, "bc_mfd.wav", IDPRF_2D);
            poison(%scanned, %player2, %player);
         }
      }
   }
   else if(%player.spell == "Stormreaver")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         %lightning = copyObject($lightning);
         addToSet(%player.group, %lightning);
         %x = getPosition(%scanned, x);
         %y = getPosition(%scanned, y);
         %z = getPosition(%scanned, z) - 150;
         setPosition(%lightning, %x, %y, %z);
         if(%player2 != 0)
         {
            say(%player2, %player2, "<f4>Your vehicle has been struck by lightning!");
         }
         playSound(0, "sfx_thunder1.wav", IDPRF_2D);
         %scanned.deathMethod = "Stormreaver";
         %scanned.killer = %player;
         %count = playerManager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player3 = playerManager::getPlayerNum(%i);
            %vehicleId3 = playerManager::playerNumToVehicleId(%player3);
            if((getDistance(%vehicleId3, %scanned) <= 150) && (%vehicleId3 != %scanned))
            {
               %vehicleId3.deathMethod = "Flash";
               %vehicleId3.killer = %player;
               schedule("resetDeath(" @ %vehicleId3 @ ");", 1);
            }
         }
         damageArea(%scanned, 0, 0, 0, 150, 1000);
         schedule("resetDeath(" @ %scanned @ ");", 1);
         if(%player2 != 0)
         {
            fadeEvent(%player2, in, 0.3, 1, 1, 1);
            schedule("fadeEvent(" @ %player2 @ ", in, 0.3, 1, 1, 1);", 0.7);
            schedule("fadeEvent(" @ %player2 @ ", in, 0.3, 1, 1, 1);", 1.2);
         }
         schedule("deleteObject(" @ %lightning @ ");",1.3);
         for(%i = 0; %i < %count; %i++)
         {
            %player3 = playerManager::getPlayerNum(%i);
            %vehicleId3 = playerManager::playerNumToVehicleId(%player3);
            if((getDistance(%vehicleId3, %scanned) <= 500) && (%player3 != %player2))
            {
               fadeEvent(%player3, in, 0.3, 1, 1, 1);
               schedule("fadeEvent(" @ %player3 @ ", in, 0.3, 1, 1, 1);", 0.7);
            }
         }
      }
   }   
   else if(%player.spell == "FireBlast")
   {
      if(hasMana(%player) == true)
      {
         spendMana(%player);
         say(%player, %player, "<F4>Casting FireBlast...");
         playSound(%player, "sfx_swrm.wav", IDPRF_2D);
         shootFireBlast(%player, %player2, %scanned, %scanner); 
      }
   }
}

function poison(%scanned, %player2, %player)
{
   if((%player2.poisoned == true)&&(%player.leftgame == false))
   {
      %scanned.deathMethod = "Venom";
      %scanned.killer = %player;
      fadeEvent(%player2, in, 1, 0.75, 0, 0);
      playSound(%player2, "sfx_pilot_hit.wav", IDPRF_2D);
      healObject(%scanned, -1500);
      schedule("resetDeath(" @ %scanned @ ");", 1);
      schedule("poison(" @ %scanned @ ", " @ %player2 @ ", " @ %player @ ");", 5);
   }
}

function fly(%vehicleId, %xOffset, %yOffset, %zOffset, %finalHeight, %dir, %dist, %inc)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   if((isGroupDestroyed(%vehicleId) == false)&&(%player.leftgame == false))
   {
      %x = getPosition(%vehicleId, x) + %xOffset;
      %y = getPosition(%vehicleId, y) + %yOffset;
      %z = getPosition(%vehicleId, z);
      %xFut = getPosition(%vehicleId, x) + (%xOffset * 2);
      %yFut = getPosition(%vehicleId, y) + (%yOffset * 2);
      if((%z < %finalHeight)&&(%dir == 0))
      {
         %lock = false;
         %z = getPosition(%vehicleId, z) + %zOffset;
         %zFut = getPosition(%vehicleId, z) + (%zOffset * 2);
      }
      else
      {
         %dir = 1;
         if((%dir == 1)&&(%inc > 0))
         {
            %inc--;
            %z = getPosition(%vehicleId, z);
            %zFut = getPosition(%vehicleId, z);
         }
         else
         {
            %z = getPosition(%vehicleId, z) - %zOffset;
            %zFut = getPosition(%vehicleId, z)- (%zOffset * 2);
         }
      }
      setPosition(%vehicleId, %x, %y, %z);
      if(%zFut > getTerrainHeight(%xFut, %yFut) + 5)
      {
         schedule("fly(" @ %vehicleId @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %zOffset @ ", " @ %finalHeight @ ", " @ %dir @ ", " @ %dist @ ", " @ %inc @ ");", 0.1);
      }
      else
      {
         %player.repel = false;
      }
   }
   else
   {
      %player.repel = false;
   }
}

function shootFireBlast(%player, %player2, %scanned, %scanner)
{   
   %x1 = getPosition(%scanner, x);
   %y1 = getPosition(%scanner, y);
   %z1 = getPosition(%scanner, z) + 10;
   %x2 = getPosition(%scanned, x);
   %y2 = getPosition(%scanned, y);
   %z2 = getPosition(%scanned, z);
   dropPod(%x1, %y1, %z1, %x2, %y2, %z2);
   %distance = getDistance(%scanner, %scanned);
   %time = %distance / 400; //400 m/s (speed of drop pod)
   schedule("startFireBlast(" @ %player @ ", " @ %player2 @ ", " @ %scanned @ ", " @ %scanner @ ");", %time);
}

function startFireBlast(%player, %player2, %scanned, %scanner)
{   
   if(%player2.deflect == false)
   {      
      %trigger = copyObject($fireBlast);
      addToSet(%player.group, %trigger);
      %trigger.owner = %player;
      for(%i = 1; %i <= 9; %i++)
      {
         %fire[%i] = copyObject($pod);
         addToSet(%player.group, %fire[%i]);
      }
      %count = playerManager::getPlayerCount();
      for(%i = 0; %i < %count; %i++)
      {
         %player3 = playerManager::getPlayerNum(%i);
         %vehicleId3 = playerManager::playerNumToVehicleId(%player3);
         if((getDistance(%vehicleId3, %scanned) <= 300)||(%player3 == %player)||(%player3 == %player2))
         {
            playSound(%player3, "sfx_swrm.wav", IDPRF_2D);
            playSound(%player3, "explo3.wav", IDPRF_2D);
            playSound(%player3, "sfx_fire.wav", IDPRF_2D);
         }
      }
      %x = getPosition(%scanned, x);
      %y = getPosition(%scanned, y);
      %z = getTerrainHeight(%x, %y);
      %scanned.deathMethod = "FireBlast";
      %scanned.killer = %player;   
      schedule("healObject(" @ %scanned @ ", -5000);", 0.1);
      schedule("setPosition(" @ %trigger @ ", " @ %x @ ", " @ %y @ ", " @ %z @ ");", 0.1);
      schedule("fireBlast(" @ %trigger @ ", " @ %fire1 @ ", " @ %fire2 @ ", " @ %fire3 @ ", " @ %fire4 @ ", " @ %fire5 @ ", " @ %fire6 @ ", " @ %fire7 @ ", " @ %fire8 @ ", " @ %fire9 @ ", 1, 0, " @ %x @ ", " @ %y @ ", " @ %z - 200 @ ");", 0.1);
   
      //Took out the violating part
      //schedule("empFix(" @ %player2 @ ");",0.4);
      //schedule("empFix(" @ %player2 @ ");",0.45);
      //schedule("empFix(" @ %player2 @ ");",0.49);
      //schedule("violate(" @ %scanned @ ");", 0.5);
      //schedule("reloadObject(" @ %scanned @ ", 99999);", 0.75);
      //if(%player2 == 0)
      //{
      //   %name = getObjectName(%scanned);
      //   if((%name == "veh")||(%name == "mirage"))
      //   {
      //      schedule("violate(" @ %scanned @ ");", 0.5);
      //      schedule("order(" @ %scanned @ ", shutdown, true);", 0.5);
      //      schedule("reloadObject(" @ %scanned @ ", 99999);", 0.75);
      //      schedule("order(" @ %scanned @ ", shutdown, false);", 6.5);
      //   }      
      //}
   }
   else
   {
      if(%player2.deflectCount > 0)
      {
         %player2.deflectCount--;
         if(%player2 != 0)
         {
            playSound(%player2, "sfx_electrical_bzzt.wav", IDPRF_2D);
         }
         shootFireBlast(%player2, %player, %scanner, %scanned);
      }
      else
      {
         %player2.deflect = false;
         %player2.deflectCount = 0;
         deleteObject(%player2.shield);              
         setHudTimer(0,-1,"",1,%player2);   
         say(%player2, %player2, "<F4>Your deflector shield's energy has been depleted.", "sfx_electrical_bzzt.wav");
         %trigger = copyObject($fireBlast);
         addToSet(%player.group, %trigger);
         %trigger.owner = %player;
         for(%i = 1; %i <= 9; %i++)
         {
            %fire[%i] = copyObject($pod);
            addToSet(%player.group, %fire[%i]);
         }
         %count = playerManager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player3 = playerManager::getPlayerNum(%i);
            %vehicleId3 = playerManager::playerNumToVehicleId(%player3);
            if((getDistance(%vehicleId3, %scanned) <= 300)||(%player3 == %player)||(%player3 == %player2))
            {
               playSound(%player3, "sfx_swrm.wav", IDPRF_2D);
               playSound(%player3, "explo3.wav", IDPRF_2D);
               playSound(%player3, "sfx_fire.wav", IDPRF_2D);
            }
         }
         %x = getPosition(%scanned, x);
         %y = getPosition(%scanned, y);
         %z = getTerrainHeight(%x, %y);
         %scanned.deathMethod = "FireBlast";
         %scanned.killer = %player;   
         schedule("healObject(" @ %scanned @ ", -5000);", 0.1);
         schedule("setPosition(" @ %trigger @ ", " @ %x @ ", " @ %y @ ", " @ %z @ ");", 0.1);
         schedule("fireBlast(" @ %trigger @ ", " @ %fire1 @ ", " @ %fire2 @ ", " @ %fire3 @ ", " @ %fire4 @ ", " @ %fire5 @ ", " @ %fire6 @ ", " @ %fire7 @ ", " @ %fire8 @ ", " @ %fire9 @ ", 1, 0, " @ %x @ ", " @ %y @ ", " @ %z - 200 @ ");", 0.1);
   
         //Took out the violating part
         //schedule("empFix(" @ %player2 @ ");",0.4);
         //schedule("empFix(" @ %player2 @ ");",0.45);
         //schedule("empFix(" @ %player2 @ ");",0.49);
         //schedule("violate(" @ %scanned @ ");", 0.5);
         //schedule("reloadObject(" @ %scanned @ ", 99999);", 0.75);
         //if(%player2 == 0)
         //{
         //   %name = getObjectName(%scanned);
         //   if((%name == "veh")||(%name == "mirage"))
         //   {
         //      schedule("violate(" @ %scanned @ ");", 0.5);
         //      schedule("order(" @ %scanned @ ", shutdown, true);", 0.5);
         //      schedule("reloadObject(" @ %scanned @ ", 99999);", 0.75);
         //      schedule("order(" @ %scanned @ ", shutdown, false);", 6.5);
         //   }      
         //}
      }
   }
}

function fireBlast(%trigger, %fire1, %fire2, %fire3, %fire4, %fire5, %fire6, %fire7, %fire8, %fire9, %dir, %frame, %x, %y, %z)
{
   if(%dir == 1)
   {
      if(%frame < 60)
      {
         %frame++;
         %z += 1;
         setPosition(%fire1, %x, %y, %z);
         setPosition(%fire2, %x - 15, %y, %z);
         setPosition(%fire3, %x, %y - 15, %z);
         setPosition(%fire4, %x + 15, %y, %z);
         setPosition(%fire5, %x, %y + 15, %z);
         setPosition(%fire6, %x - 15, %y - 15, %z);
         setPosition(%fire7, %x - 15, %y + 15, %z);
         setPosition(%fire8, %x + 15, %y - 15, %z);
         setPosition(%fire9, %x + 15, %y + 15, %z);
         schedule("fireBlast(" @ %trigger @ ", " @ %fire1 @ ", " @ %fire2 @ ", " @ %fire3 @ ", " @ %fire4 @ ", " @ %fire5 @ ", " @ %fire6 @ ", " @ %fire7 @ ", " @ %fire8 @ ", " @ %fire9 @ ", " @ %dir @ ", " @ %frame @ ", " @ %x @ ", " @ %y @ ", " @ %z @ ");", 0.25);
      }
      else
      {
         %dir = 2;
         %frame = 100;
         schedule("fireBlast(" @ %trigger @ ", " @ %fire1 @ ", " @ %fire2 @ ", " @ %fire3 @ ", " @ %fire4 @ ", " @ %fire5 @ ", " @ %fire6 @ ", " @ %fire7 @ ", " @ %fire8 @ ", " @ %fire9 @ ", " @ %dir @ ", " @ %frame @ ", " @ %x @ ", " @ %y @ ", " @ %z @ ");", 0.25);
      }
   }
   else
   {
      if(%frame > 0)
      {
         %frame--;
         %z -= 1;
         setPosition(%fire1, %x, %y, %z);
         setPosition(%fire2, %x - 15, %y, %z);
         setPosition(%fire3, %x, %y - 15, %z);
         setPosition(%fire4, %x + 15, %y, %z);
         setPosition(%fire5, %x, %y + 15, %z);
         setPosition(%fire6, %x - 15, %y - 15, %z);
         setPosition(%fire7, %x - 15, %y + 15, %z);
         setPosition(%fire8, %x + 15, %y - 15, %z);
         setPosition(%fire9, %x + 15, %y + 15, %z);
         schedule("fireBlast(" @ %trigger @ ", " @ %fire1 @ ", " @ %fire2 @ ", " @ %fire3 @ ", " @ %fire4 @ ", " @ %fire5 @ ", " @ %fire6 @ ", " @ %fire7 @ ", " @ %fire8 @ ", " @ %fire9 @ ", " @ %dir @ ", " @ %frame @ ", " @ %x @ ", " @ %y @ ", " @ %z @ ");", 0.25);         
      }
      else
      {
         %trigger.owner = "";
         for(%i = 1; %i <= 9; %i++)
         {
            deleteObject(%fire[%i]);
         }
         deleteObject(%trigger);         
      }
   }
}

function empFix(%player)
{
   %player.justlaid = true;
}

function fireBlast::trigger::onEnter(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %vehicleId.deathMethod = "FireBlast";
   %vehicleId.killer = %trigger.owner;
}

function fireBlast::trigger::onContact(%trigger, %vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   healObject(%vehicleId, -1000);
   if(%player != 0)
   {
      playSound(%player, "sfx_fire.wav", IDPRF_2D);
   }
}

function fireBlast::trigger::onLeave(%trigger, %vehicleId)
{
   schedule("resetDeath(" @ %vehicleId @ ");", 1);
}

function levitate(%scanner)
{
   jump(%scanner);
   schedule("jump("@%scanner@");",0.1);
   schedule("jump("@%scanner@");",0.2);
   schedule("jump("@%scanner@");",0.3);
   schedule("jump("@%scanner@");",0.4);
   schedule("jump("@%scanner@");",0.5);
   schedule("hover2("@%scanner@");",0.6);
   schedule("hover2("@%scanner@");",0.7);
   schedule("hover2("@%scanner@");",0.8);
   schedule("hover2("@%scanner@");",0.9);
   schedule("hover2("@%scanner@");",1.0);
   schedule("hover2("@%scanner@");",1.1);
   schedule("hover2("@%scanner@");",1.2);
   schedule("hover2("@%scanner@");",1.3);
   schedule("hover2("@%scanner@");",1.4);
   schedule("hover2("@%scanner@");",1.5);
   schedule("hover2("@%scanner@");",1.6);
   schedule("hover2("@%scanner@");",1.7);
   schedule("hover2("@%scanner@");",1.8);
   schedule("hover2("@%scanner@");",1.9);
   schedule("hover2("@%scanner@");",2.0);
   schedule("hover2("@%scanner@");",2.1);
   schedule("hover2("@%scanner@");",2.2);
   schedule("hover2("@%scanner@");",2.3);
   schedule("hover2("@%scanner@");",2.4);
   schedule("hover2("@%scanner@");",2.5);
   schedule("hover2("@%scanner@");",2.6);
   schedule("hover2("@%scanner@");",2.7);
   schedule("hover2("@%scanner@");",2.8);
   schedule("hover2("@%scanner@");",2.9);
   schedule("hover2("@%scanner@");",3.0);
   schedule("hover2("@%scanner@");",3.1);
   schedule("hover2("@%scanner@");",3.2);
   schedule("hover2("@%scanner@");",3.3);
   schedule("hover2("@%scanner@");",3.4);
   schedule("hover2("@%scanner@");",3.5);
   schedule("hover2("@%scanner@");",3.6);
   schedule("hover2("@%scanner@");",3.7);
   schedule("hover2("@%scanner@");",3.8);
   schedule("hover2("@%scanner@");",3.9);
   schedule("hover2("@%scanner@");",4.0);
}

function jump(%scanner)
{
   %posx = getPosition(%scanner, x);
   %posy = getPosition(%scanner, y);
   %posz = getPosition(%scanner, z) + 5;
   setPosition(%scanner, %posx, %posy, %posz);
}

function hover2(%scanner)
{
   %posx = getPosition(%scanner, x);
   %posy = getPosition(%scanner, y);
   %posz = getPosition(%scanner, z) + 0.2;
   setPosition(%scanner, %posx, %posy, %posz);
}

function enslave(%scanned, %scanner, %player, %player2, %timer)
{
   if((%timer > 0)&&(isGroupDestroyed(%scanned) == false)&&(isGroupDestroyed(%scanner) == false))
   {
      %timer--;
      order(%scanned, guard, %scanner);
      schedule("enslave(" @ %scanned @ ", " @ %scanner @ ", " @ %player @ ", " @ %player2 @ ", " @ %timer @ ");", 1);
   }
   else
   {
      order(%scanned, clear);
      if(isGroupDestroyed(%scanned) == false)
      {
         say(%player, %player, "<F4>" @ getHudName(%scanned) @ " is no longer under your control.", "bc_mfd.wav");
      }
      if(%player2 != 0)
      {
         say(%player2, %player2, "<F4>You are no longer under " @ getName(%player) @ "'s control.", "bc_mfd.wav");
      }
   }
}

// Zen Pad Functionality
function MagicZen::trigger::onEnter(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);
      %player.InPad = true; 
}

function MagicZen::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 1000, 40, 70, true); 
}

function MagicZen::trigger::onLeave(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
      %player.InPad = false; 
}

// Heal Pad Functionality
function MagicHeal::trigger::onEnter(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);
      %player.InPad = true; 
}

function MagicHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 1000, 0, 0, true); 
}

function MagicHeal::trigger::onLeave(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
      %player.InPad = false; 
}

// Ammo Pad Functionality
function MagicAmmo::trigger::onEnter(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);
      %player.InPad = true; 
}

function MagicAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, 40, 40, true); 
}

function MagicAmmo::trigger::onLeave(%this, %object)
{
      %player = playermanager::vehicleIdtoPlayerNum(%object);
      %player.InPad = false; 
}

function onMissionEnd()
{
   flushConsoleScheduler();
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      deleteObject(%player.group);
      %player.group = "";
      %player.mana = 0;
      %player.spell = "Mana";
      %player.cost = 1;
      %player.shutDownSpell = false;
   }
}

function getPlayerMana(%player)
{
   return %player.mana;
}

function getAllKills(%player)
{
   return(getKills(%player) + %player.extraKills);
}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   if($server::TeamPlay == "True")	
   {
	   // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
	   $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SQUAD;
	   $ScoreBoard::PlayerColumnHeader3 = "Mana";
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getTeam";
	   $ScoreBoard::PlayerColumnFunction2 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction3 = "getPlayerMana";
	   $ScoreBoard::PlayerColumnFunction4 = "getAllKills";
	   $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
   }
   else
   {
       // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
	   $ScoreBoard::PlayerColumnHeader2 = "Mana";
	   $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_DEATHS;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction2 = "getPlayerMana";
	   $ScoreBoard::PlayerColumnFunction3 = "getAllKills";
	   $ScoreBoard::PlayerColumnFunction4 = "getDeaths";
   }

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_PLAYERS;

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getNumberOfPlayersOnTeam";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}

// Easter Egg Function
// Fully charge every player's mana (For overly generous hosts)
// TYPE: focusserver(); maxMana(); focusclient();

function maxMana()
{
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      %player.mana = $maxMana;
   }
   echo("Everyone's mana has been fully charged.");
}

//Math Stuff (from TrigonometryStdLib.cs)
//-------------------------------------------------------------------------

function abs(%number)
{
   if(%number >= 0)
   {
      %answer = %number;
   }
   else if(%number < 0)
   {
      %answer = -%number;
   }
}

function getHypotenuse(%deltaX, %deltaY, %deltaZ)
{
   if(%deltaZ == "")
   {
      %answer = sqrt((%deltaX * %deltaX) + (%deltaY * %deltaY));
   }
   else if(%deltaZ != "")
   {
      %hyp = sqrt((%deltaX * %deltaX) + (%deltaY * %deltaY));
      %answer = sqrt((%hyp * %hyp) + (%deltaZ * %deltaZ));
   }
   return %answer;
}

function RadToDeg(%radians)
{
   %degrees = (%radians * 180) / 3.14159;
   return %degrees;
}

function round(%number)
{
   %roundNum = %number;
   if(%number > 0)
   {
      %excess = (%number - floor(%number));
      if(%excess >= 0.5)
      {
         %roundNum = (floor(%number) + 1);
      }
      else
      {
         %roundNum = floor(%number);
      }
   }
   if(%number < 0)
   {
      %excess = (floor(%number) - %number);
      if(%excess <= 0.5)
      {
         %roundNum = floor(%number);
      }
      else
      {
         %roundNum = (floor(%number) - 1);
      }
   }
   return %roundNum;
}

function adjustAngle(%angle)
{
   if(%angle >= 360)
   {
      while(%angle >= 360)
      {
         %angle = (%angle - 360);
      }
   }
   else if(%angle < 0)
   {
      while(%angle < 0)
      {
         %angle = (%angle + 360);
      }
   }
   return %angle;
}

function sin(%angle)
{
   %angle = round(adjustAngle(%angle));
   return $sin[%angle];
}

function cos(%angle)
{
   %angle = round(adjustAngle(%angle));
   return $cos[%angle];
} 

$sin0 = 0;
$sin1 = 0.017452;
$sin2 = 0.034899;
$sin3 = 0.052335;
$sin4 = 0.069756;
$sin5 = 0.087156;
$sin6 = 0.104528;
$sin7 = 0.121869;
$sin8 = 0.139173;
$sin9 = 0.156434;
$sin10 = 0.173648;
$sin11 = 0.190809;
$sin12 = 0.207912;
$sin13 = 0.224951;
$sin14 = 0.241922;
$sin15 = 0.258819;
$sin16 = 0.275637;
$sin17 = 0.292372;
$sin18 = 0.309017;
$sin19 = 0.325568;
$sin20 = 0.342020;
$sin21 = 0.358368;
$sin22 = 0.374607;
$sin23 = 0.390731;
$sin24 = 0.406737;
$sin25 = 0.422618;
$sin26 = 0.438371;
$sin27 = 0.453990;
$sin28 = 0.469472;
$sin29 = 0.484810;
$sin30 = 0.5;
$sin31 = 0.515038;
$sin32 = 0.529919;
$sin33 = 0.544639;
$sin34 = 0.559193;
$sin35 = 0.573576;
$sin36 = 0.587785;
$sin37 = 0.601815;
$sin38 = 0.615661;
$sin39 = 0.629320;
$sin40 = 0.642788;
$sin41 = 0.656059;
$sin42 = 0.669131;
$sin43 = 0.681998;
$sin44 = 0.694658;
$sin45 = 0.707107;
$sin46 = 0.719340;
$sin47 = 0.731354;
$sin48 = 0.743145;
$sin49 = 0.754710;
$sin50 = 0.766044;
$sin51 = 0.777146;
$sin52 = 0.788011;
$sin53 = 0.798636;
$sin54 = 0.809017;
$sin55 = 0.819152;
$sin56 = 0.829038;
$sin57 = 0.838671;
$sin58 = 0.848048;
$sin59 = 0.857167;
$sin60 = 0.866025;
$sin61 = 0.874620;
$sin62 = 0.882948;
$sin63 = 0.891007;
$sin64 = 0.898794;
$sin65 = 0.906308;
$sin66 = 0.913545;
$sin67 = 0.920505;
$sin68 = 0.927184;
$sin69 = 0.933580;
$sin70 = 0.939693;
$sin71 = 0.945519;
$sin72 = 0.951057;
$sin73 = 0.956305;
$sin74 = 0.961262;
$sin75 = 0.965926;
$sin76 = 0.970296;
$sin77 = 0.974370;
$sin78 = 0.978148;
$sin79 = 0.981627;
$sin80 = 0.984808;
$sin81 = 0.987688;
$sin82 = 0.990268;
$sin83 = 0.992546;
$sin84 = 0.994522;
$sin85 = 0.996195;
$sin86 = 0.997564;
$sin87 = 0.998630;
$sin88 = 0.999391;
$sin89 = 0.999848;
$sin90 = 1;
$sin91 = 0.999848;
$sin92 = 0.999391;
$sin93 = 0.998630;
$sin94 = 0.997564;
$sin95 = 0.996195;
$sin96 = 0.994522;
$sin97 = 0.992546;
$sin98 = 0.990268;
$sin99 = 0.987688;
$sin100 = 0.984808;
$sin101 = 0.981627;
$sin102 = 0.978148;
$sin103 = 0.974370;
$sin104 = 0.970296;
$sin105 = 0.965926;
$sin106 = 0.961262;
$sin107 = 0.956305;
$sin108 = 0.951057;
$sin109 = 0.945519;
$sin110 = 0.939693;
$sin111 = 0.933580;
$sin112 = 0.927184;
$sin113 = 0.920505;
$sin114 = 0.913545;
$sin115 = 0.906308;
$sin116 = 0.898794;
$sin117 = 0.891007;
$sin118 = 0.882948;
$sin119 = 0.874620;
$sin120 = 0.866025;
$sin121 = 0.857167;
$sin122 = 0.848048;
$sin123 = 0.838671;
$sin124 = 0.829038;
$sin125 = 0.819152;
$sin126 = 0.809017;
$sin127 = 0.798636;
$sin128 = 0.788011;
$sin129 = 0.777146;
$sin130 = 0.766044;
$sin131 = 0.754710;
$sin132 = 0.743145;
$sin133 = 0.731354;
$sin134 = 0.719340;
$sin135 = 0.707107;
$sin136 = 0.694658;
$sin137 = 0.681998;
$sin138 = 0.669131;
$sin139 = 0.656059;
$sin140 = 0.642788;
$sin141 = 0.629320;
$sin142 = 0.615661;
$sin143 = 0.601815;
$sin144 = 0.587785;
$sin145 = 0.573576;
$sin146 = 0.559193;
$sin147 = 0.544639;
$sin148 = 0.529919;
$sin149 = 0.515038;
$sin150 = 0.5;
$sin151 = 0.484810;
$sin152 = 0.469472;
$sin153 = 0.453990;
$sin154 = 0.438371;
$sin155 = 0.422618;
$sin156 = 0.406737;
$sin157 = 0.390731;
$sin158 = 0.374607;
$sin159 = 0.358368;
$sin160 = 0.342020;
$sin161 = 0.325568;
$sin162 = 0.309017;
$sin163 = 0.292372;
$sin164 = 0.275637;
$sin165 = 0.258819;
$sin166 = 0.241922;
$sin167 = 0.224951;
$sin168 = 0.207912;
$sin169 = 0.190809;
$sin170 = 0.173648;
$sin171 = 0.156434;
$sin172 = 0.139173;
$sin173 = 0.121869;
$sin174 = 0.104528;
$sin175 = 0.087156;
$sin176 = 0.069756;
$sin177 = 0.052335;
$sin178 = 0.034899;
$sin179 = 0.017452;
$sin180 = 0;
$sin181 = -0.017452;
$sin182 = -0.034899;
$sin183 = -0.052335;
$sin184 = -0.069756;
$sin185 = -0.087156;
$sin186 = -0.104528;
$sin187 = -0.121869;
$sin188 = -0.139173;
$sin189 = -0.156434;
$sin190 = -0.173648;
$sin191 = -0.190809;
$sin192 = -0.207912;
$sin193 = -0.224951;
$sin194 = -0.241922;
$sin195 = -0.258819;
$sin196 = -0.275637;
$sin197 = -0.292372;
$sin198 = -0.309017;
$sin199 = -0.325568;
$sin200 = -0.342020;
$sin201 = -0.358368;
$sin202 = -0.374607;
$sin203 = -0.390731;
$sin204 = -0.406737;
$sin205 = -0.422618;
$sin206 = -0.438371;
$sin207 = -0.453990;
$sin208 = -0.469472;
$sin209 = -0.484810;
$sin210 = -0.5;
$sin211 = -0.515038;
$sin212 = -0.529919;
$sin213 = -0.544639;
$sin214 = -0.559193;
$sin215 = -0.573576;
$sin216 = -0.587785;
$sin217 = -0.601815;
$sin218 = -0.615661;
$sin219 = -0.629320;
$sin220 = -0.642788;
$sin221 = -0.656059;
$sin222 = -0.669131;
$sin223 = -0.681998;
$sin224 = -0.694658;
$sin225 = -0.707107;
$sin226 = -0.719340;
$sin227 = -0.731354;
$sin228 = -0.743145;
$sin229 = -0.754710;
$sin230 = -0.766044;
$sin231 = -0.777146;
$sin232 = -0.788011;
$sin233 = -0.798636;
$sin234 = -0.809017;
$sin235 = -0.819152;
$sin236 = -0.829038;
$sin237 = -0.838671;
$sin238 = -0.848048;
$sin239 = -0.857167;
$sin240 = -0.866025;
$sin241 = -0.874620;
$sin242 = -0.882948;
$sin243 = -0.891007;
$sin244 = -0.898794;
$sin245 = -0.906308;
$sin246 = -0.913545;
$sin247 = -0.920505;
$sin248 = -0.927184;
$sin249 = -0.933580;
$sin250 = -0.939693;
$sin251 = -0.945519;
$sin252 = -0.951057;
$sin253 = -0.956305;
$sin254 = -0.961262;
$sin255 = -0.965926;
$sin256 = -0.970296;
$sin257 = -0.974370;
$sin258 = -0.978148;
$sin259 = -0.981627;
$sin260 = -0.984808;
$sin261 = -0.987688;
$sin262 = -0.990268;
$sin263 = -0.992546;
$sin264 = -0.994522;
$sin265 = -0.996195;
$sin266 = -0.997564;
$sin267 = -0.998630;
$sin268 = -0.999391;
$sin269 = -0.999848;
$sin270 = -1;
$sin271 = -0.999848;
$sin272 = -0.999391;
$sin273 = -0.998630;
$sin274 = -0.997564;
$sin275 = -0.996195;
$sin276 = -0.994522;
$sin277 = -0.992546;
$sin278 = -0.990268;
$sin279 = -0.987688;
$sin280 = -0.984808;
$sin281 = -0.981627;
$sin282 = -0.978148;
$sin283 = -0.974370;
$sin284 = -0.970296;
$sin285 = -0.965926;
$sin286 = -0.961262;
$sin287 = -0.956305;
$sin288 = -0.951057;
$sin289 = -0.945519;
$sin290 = -0.939693;
$sin291 = -0.933580;
$sin292 = -0.927184;
$sin293 = -0.920505;
$sin294 = -0.913545;
$sin295 = -0.906308;
$sin296 = -0.898794;
$sin297 = -0.891007;
$sin298 = -0.882948;
$sin299 = -0.874620;
$sin300 = -0.866025;
$sin301 = -0.857167;
$sin302 = -0.848048;
$sin303 = -0.838671;
$sin304 = -0.829038;
$sin305 = -0.819152;
$sin306 = -0.809017;
$sin307 = -0.798636;
$sin308 = -0.788011;
$sin309 = -0.777146;
$sin310 = -0.766044;
$sin311 = -0.754710;
$sin312 = -0.743145;
$sin313 = -0.731354;
$sin314 = -0.719340;
$sin315 = -0.707107;
$sin316 = -0.694658;
$sin317 = -0.681998;
$sin318 = -0.669131;
$sin319 = -0.656059;
$sin320 = -0.642788;
$sin321 = -0.629320;
$sin322 = -0.615661;
$sin323 = -0.601815;
$sin324 = -0.587785;
$sin325 = -0.573576;
$sin326 = -0.559193;
$sin327 = -0.544639;
$sin328 = -0.529919;
$sin329 = -0.515038;
$sin330 = -0.5;
$sin331 = -0.484810;
$sin332 = -0.469472;
$sin333 = -0.453990;
$sin334 = -0.438371;
$sin335 = -0.422618;
$sin336 = -0.406737;
$sin337 = -0.390731;
$sin338 = -0.374607;
$sin339 = -0.358368;
$sin340 = -0.342020;
$sin341 = -0.325568;
$sin342 = -0.309017;
$sin343 = -0.292372;
$sin344 = -0.275637;
$sin345 = -0.258819;
$sin346 = -0.241922;
$sin347 = -0.224951;
$sin348 = -0.207912;
$sin349 = -0.190809;
$sin350 = -0.173648;
$sin351 = -0.156434;
$sin352 = -0.139173;
$sin353 = -0.121869;
$sin354 = -0.104528;
$sin355 = -0.087156;
$sin356 = -0.069756;
$sin357 = -0.052335;
$sin358 = -0.034899;
$sin359 = -0.017452;
$sin360 = 0;

$cos0 = 1;
$cos1 = 0.999848;
$cos2 = 0.999391;
$cos3 = 0.998630;
$cos4 = 0.997564;
$cos5 = 0.996195;
$cos6 = 0.994522;
$cos7 = 0.992546;
$cos8 = 0.990268;
$cos9 = 0.987688;
$cos10 = 0.984808;
$cos11 = 0.981627;
$cos12 = 0.978148;
$cos13 = 0.974370;
$cos14 = 0.970296;
$cos15 = 0.965926;
$cos16 = 0.961262;
$cos17 = 0.956305;
$cos18 = 0.951057;
$cos19 = 0.945519;
$cos20 = 0.939693;
$cos21 = 0.933580;
$cos22 = 0.927184;
$cos23 = 0.920505;
$cos24 = 0.913545;
$cos25 = 0.906308;
$cos26 = 0.898794;
$cos27 = 0.891007;
$cos28 = 0.882948;
$cos29 = 0.874620;
$cos30 = 0.866025;
$cos31 = 0.857167;
$cos32 = 0.848048;
$cos33 = 0.838671;
$cos34 = 0.829038;
$cos35 = 0.819152;
$cos36 = 0.809017;
$cos37 = 0.798636;
$cos38 = 0.788011;
$cos39 = 0.777146;
$cos40 = 0.766044;
$cos41 = 0.754710;
$cos42 = 0.743145;
$cos43 = 0.731354;
$cos44 = 0.719340;
$cos45 = 0.707107;
$cos46 = 0.694658;
$cos47 = 0.681998;
$cos48 = 0.669131;
$cos49 = 0.656059;
$cos50 = 0.642788;
$cos51 = 0.629320;
$cos52 = 0.615661;
$cos53 = 0.601815;
$cos54 = 0.587785;
$cos55 = 0.573576;
$cos56 = 0.559193;
$cos57 = 0.544639;
$cos58 = 0.529919;
$cos59 = 0.515038;
$cos60 = 0.5;
$cos61 = 0.484810;
$cos62 = 0.469472;
$cos63 = 0.453990;
$cos64 = 0.438371;
$cos65 = 0.422618;
$cos66 = 0.406737;
$cos67 = 0.390731;
$cos68 = 0.374607;
$cos69 = 0.358368;
$cos70 = 0.342020;
$cos71 = 0.325568;
$cos72 = 0.309017;
$cos73 = 0.292372;
$cos74 = 0.275637;
$cos75 = 0.258819;
$cos76 = 0.241922;
$cos77 = 0.224951;
$cos78 = 0.207912;
$cos79 = 0.190809;
$cos80 = 0.173648;
$cos81 = 0.156434;
$cos82 = 0.139173;
$cos83 = 0.121869;
$cos84 = 0.104528;
$cos85 = 0.087156;
$cos86 = 0.069756;
$cos87 = 0.052336;
$cos88 = 0.034899;
$cos89 = 0.017452;
$cos90 = 0;
$cos91 = -0.017452;
$cos92 = -0.034899;
$cos93 = -0.052336;
$cos94 = -0.069756;
$cos95 = -0.087156;
$cos96 = -0.104528;
$cos97 = -0.121869;
$cos98 = -0.139173;
$cos99 = -0.156434;
$cos100 = -0.173648;
$cos101 = -0.190809;
$cos102 = -0.207912;
$cos103 = -0.224951;
$cos104 = -0.241922;
$cos105 = -0.258819;
$cos106 = -0.275637;
$cos107 = -0.292372;
$cos108 = -0.309017;
$cos109 = -0.325568;
$cos110 = -0.342020;
$cos111 = -0.358368;
$cos112 = -0.374607;
$cos113 = -0.390731;
$cos114 = -0.406737;
$cos115 = -0.422618;
$cos116 = -0.438371;
$cos117 = -0.453990;
$cos118 = -0.469472;
$cos119 = -0.484810;
$cos120 = -0.5;
$cos121 = -0.515038;
$cos122 = -0.529919;
$cos123 = -0.544639;
$cos124 = -0.559193;
$cos125 = -0.573576;
$cos126 = -0.587785;
$cos127 = -0.601815;
$cos128 = -0.615661;
$cos129 = -0.629320;
$cos130 = -0.642788;
$cos131 = -0.656059;
$cos132 = -0.669131;
$cos133 = -0.681998;
$cos134 = -0.694658;
$cos135 = -0.707107;
$cos136 = -0.719340;
$cos137 = -0.731354;
$cos138 = -0.743145;
$cos139 = -0.754710;
$cos140 = -0.766044;
$cos141 = -0.777146;
$cos142 = -0.788011;
$cos143 = -0.798636;
$cos144 = -0.809017;
$cos145 = -0.819152;
$cos146 = -0.829038;
$cos147 = -0.838671;
$cos148 = -0.848048;
$cos149 = -0.857167;
$cos150 = -0.866025;
$cos151 = -0.874620;
$cos152 = -0.882948;
$cos153 = -0.891007;
$cos154 = -0.898794;
$cos155 = -0.906308;
$cos156 = -0.913545;
$cos157 = -0.920505;
$cos158 = -0.927184;
$cos159 = -0.933580;
$cos160 = -0.939693;
$cos161 = -0.945519;
$cos162 = -0.951057;
$cos163 = -0.956305;
$cos164 = -0.961262;
$cos165 = -0.965926;
$cos166 = -0.970296;
$cos167 = -0.974370;
$cos168 = -0.978148;
$cos169 = -0.981627;
$cos170 = -0.984808;
$cos171 = -0.987688;
$cos172 = -0.990268;
$cos173 = -0.992546;
$cos174 = -0.994522;
$cos175 = -0.996195;
$cos176 = -0.997564;
$cos177 = -0.998630;
$cos178 = -0.999391;
$cos179 = -0.999848;
$cos180 = -1;
$cos181 = -0.999848;
$cos182 = -0.999391;
$cos183 = -0.998630;
$cos184 = -0.997564;
$cos185 = -0.996195;
$cos186 = -0.994522;
$cos187 = -0.992546;
$cos188 = -0.990268;
$cos189 = -0.987688;
$cos190 = -0.984808;
$cos191 = -0.981627;
$cos192 = -0.978148;
$cos193 = -0.974370;
$cos194 = -0.970296;
$cos195 = -0.965926;
$cos196 = -0.961262;
$cos197 = -0.956305;
$cos198 = -0.951057;
$cos199 = -0.945519;
$cos200 = -0.939693;
$cos201 = -0.933580;
$cos202 = -0.927184;
$cos203 = -0.920505;
$cos204 = -0.913545;
$cos205 = -0.906308;
$cos206 = -0.898794;
$cos207 = -0.891007;
$cos208 = -0.882948;
$cos209 = -0.874620;
$cos210 = -0.866025;
$cos211 = -0.857167;
$cos212 = -0.848048;
$cos213 = -0.838671;
$cos214 = -0.829038;
$cos215 = -0.819152;
$cos216 = -0.809017;
$cos217 = -0.798636;
$cos218 = -0.788011;
$cos219 = -0.777146;
$cos220 = -0.766044;
$cos221 = -0.754710;
$cos222 = -0.743145;
$cos223 = -0.731354;
$cos224 = -0.719340;
$cos225 = -0.707107;
$cos226 = -0.694658;
$cos227 = -0.681998;
$cos228 = -0.669131;
$cos229 = -0.656059;
$cos230 = -0.642788;
$cos231 = -0.629320;
$cos232 = -0.615661;
$cos233 = -0.601815;
$cos234 = -0.587785;
$cos235 = -0.573576;
$cos236 = -0.559193;
$cos237 = -0.544639;
$cos238 = -0.529919;
$cos239 = -0.515038;
$cos240 = -0.5;
$cos241 = -0.484810;
$cos242 = -0.469472;
$cos243 = -0.453990;
$cos244 = -0.438371;
$cos245 = -0.422618;
$cos246 = -0.406737;
$cos247 = -0.390731;
$cos248 = -0.374607;
$cos249 = -0.358368;
$cos250 = -0.342020;
$cos251 = -0.325568;
$cos252 = -0.309017;
$cos253 = -0.292372;
$cos254 = -0.275637;
$cos255 = -0.258819;
$cos256 = -0.241922;
$cos257 = -0.224951;
$cos258 = -0.207912;
$cos259 = -0.190809;
$cos260 = -0.173648;
$cos261 = -0.156434;
$cos262 = -0.139173;
$cos263 = -0.121869;
$cos264 = -0.104528;
$cos265 = -0.087156;
$cos266 = -0.069756;
$cos267 = -0.052336;
$cos268 = -0.034899;
$cos269 = -0.017452;
$cos270 = 0;
$cos271 = 0.017452;
$cos272 = 0.034899;
$cos273 = 0.052336;
$cos274 = 0.069756;
$cos275 = 0.087156;
$cos276 = 0.104528;
$cos277 = 0.121869;
$cos278 = 0.139173;
$cos279 = 0.156434;
$cos280 = 0.173648;
$cos281 = 0.190809;
$cos282 = 0.207912;
$cos283 = 0.224951;
$cos284 = 0.241922;
$cos285 = 0.258819;
$cos286 = 0.275637;
$cos287 = 0.292372;
$cos288 = 0.309017;
$cos289 = 0.325568;
$cos290 = 0.342020;
$cos291 = 0.358368;
$cos292 = 0.374607;
$cos293 = 0.390731;
$cos294 = 0.406737;
$cos295 = 0.422618;
$cos296 = 0.438371;
$cos297 = 0.453990;
$cos298 = 0.469472;
$cos299 = 0.484810;
$cos300 = 0.5;
$cos301 = 0.515038;
$cos302 = 0.529919;
$cos303 = 0.544639;
$cos304 = 0.559193;
$cos305 = 0.573576;
$cos306 = 0.587785;
$cos307 = 0.601815;
$cos308 = 0.615661;
$cos309 = 0.629320;
$cos310 = 0.642788;
$cos311 = 0.656059;
$cos312 = 0.669131;
$cos313 = 0.681998;
$cos314 = 0.694658;
$cos315 = 0.707107;
$cos316 = 0.719340;
$cos317 = 0.731354;
$cos318 = 0.743145;
$cos319 = 0.754710;
$cos320 = 0.766044;
$cos321 = 0.777146;
$cos322 = 0.788011;
$cos323 = 0.798636;
$cos324 = 0.809017;
$cos325 = 0.819152;
$cos326 = 0.829038;
$cos327 = 0.838671;
$cos328 = 0.848048;
$cos329 = 0.857167;
$cos330 = 0.866025;
$cos331 = 0.874620;
$cos332 = 0.882948;
$cos333 = 0.891007;
$cos334 = 0.898794;
$cos335 = 0.906308;
$cos336 = 0.913545;
$cos337 = 0.920505;
$cos338 = 0.927184;
$cos339 = 0.933580;
$cos340 = 0.939693;
$cos341 = 0.945519;
$cos342 = 0.951057;
$cos343 = 0.956305;
$cos344 = 0.961262;
$cos345 = 0.965926;
$cos346 = 0.970296;
$cos347 = 0.974370;
$cos348 = 0.978148;
$cos349 = 0.981627;
$cos350 = 0.984808;
$cos351 = 0.987688;
$cos352 = 0.990268;
$cos353 = 0.992546;
$cos354 = 0.994522;
$cos355 = 0.996195;
$cos356 = 0.997564;
$cos357 = 0.998630;
$cos358 = 0.999391;
$cos359 = 0.999848;
$cos360 = 1;

function getAngle(%x1, %y1, %x2, %y2)
{
   //Angle is defined from point A (x1, y1) to point B (x2, y2)
   //Point A (x1, y1) is the base point (center of the protractor)
   //Be sure to enter the coordinates for the base point first (x1, y1)

   %deltaX = %x2 - %x1;
   %deltaY = %y2 - %y1;
   %angle = getVector(%deltaX, %deltaY);
   return %angle;
}

function getVector(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);   
   if((%tan >= -0.008728)&&(%tan < 0.008728))
   {
      if(%deltaX > 0)
      {
         %angle = 0;
      }
      else if(%deltaX < 0)
      {
         %angle = 180;
      }
      return %angle;
   }
   else if((%tan >= 0.008728)&&(%tan < 0.026188))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 1;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 181;
      }
      return %angle;
   }
   else if((%tan >= 0.026188)&&(%tan < 0.043664))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 2;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 182;
      }
      return %angle;
   }
   else if((%tan >= 0.043664)&&(%tan < 0.061167))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 3;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 183;
      }
      return %angle;
   }
   else if((%tan >= 0.061167)&&(%tan < 0.078708))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 4;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 184;
      }
      return %angle;
   }
   else if((%tan >= 0.078708)&&(%tan < 0.096296))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 5;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 185;
      }
      return %angle;
   }
   else if((%tan >= 0.096296)&&(%tan < 0.113944))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 6;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 186;
      }
      return %angle;
   }
   else if((%tan >= 0.113944)&&(%tan < 0.131663))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 7;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 187;
      }
      return %angle;
   }
   else if((%tan >= 0.131663)&&(%tan < 0.149463))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 8;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 188;
      }
      return %angle;
   }
   else if((%tan >= 0.149463)&&(%tan < 0.167356))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 9;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 189;
      }
      return %angle;
   }
   else if((%tan >= 0.167356)&&(%tan < 0.185354))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 10;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 190;
      }
      return %angle;
   }
   else if((%tan >= 0.185354)&&(%tan < 0.203468))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 11;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 191;
      }
      return %angle;
   }
   else if((%tan >= 0.203468)&&(%tan < 0.221712))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 12;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 192;
      }
      return %angle;
   }
   else if((%tan >= 0.221712)&&(%tan < 0.240098))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 13;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 193;
      }
      return %angle;
   }
   else if((%tan >= 0.240098)&&(%tan < 0.258639))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 14;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 194;
      }
      return %angle;
   }
   else if((%tan >= 0.258639)&&(%tan < 0.277347))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 15;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 195;
      }
      return %angle;
   }
   else if((%tan >= 0.277347)&&(%tan < 0.296238))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 16;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 196;
      }
      return %angle;
   }
   else if((%tan >= 0.296238)&&(%tan < 0.315325))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 17;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 197;
      }
      return %angle;
   }
   else if((%tan >= 0.315325)&&(%tan < 0.334624))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 18;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 198;
      }
      return %angle;
   }
   else if((%tan >= 0.334624)&&(%tan < 0.354149))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 19;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 199;
      }
      return %angle;
   }
   else if((%tan >= 0.354149)&&(%tan < 0.373917))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 20;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 200;
      }
      return %angle;
   }
   else
   {
      getVector2(%deltaX, %deltaY);
   }
}

function getVector2(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan >= 0.373917)&&(%tan < 0.393945))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 21;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 201;
      }
      return %angle;
   }
   else if((%tan >= 0.393945)&&(%tan < 0.414251))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 22;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 202;
      }
      return %angle;
   }
   else if((%tan >= 0.414251)&&(%tan < 0.434852))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 23;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 203;
      }
      return %angle;
   }
   else if((%tan >= 0.434852)&&(%tan < 0.455768))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 24;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 204;
      }
      return %angle;
   }
   else if((%tan >= 0.455768)&&(%tan < 0.477020))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 25;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 205;
      }
      return %angle;
   }
   else if((%tan >= 0.477020)&&(%tan < 0.498629))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 26;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 206;
      }
      return %angle;
   }
   else if((%tan >= 0.498629)&&(%tan < 0.520617))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 27;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 207;
      }
      return %angle;
   }
   else if((%tan >= 0.520617)&&(%tan < 0.543009))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 28;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 208;
      }
      return %angle;
   }
   else if((%tan >= 0.543009)&&(%tan < 0.565830))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 29;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 209;
      }
      return %angle;
   }
   else if((%tan >= 0.565830)&&(%tan < 0.589105))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 30;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 210;
      }
      return %angle;
   }
   else if((%tan >= 0.589105)&&(%tan < 0.612865))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 31;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 211;
      }
      return %angle;
   }
   else if((%tan >= 0.612865)&&(%tan < 0.637138))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 32;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 212;
      }
      return %angle;
   }
   else if((%tan >= 0.637138)&&(%tan < 0.661958))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 33;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 213;
      }
      return %angle;
   }
   else if((%tan >= 0.661958)&&(%tan < 0.687358))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 34;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 214;
      }
      return %angle;
   }
   else if((%tan >= 0.687358)&&(%tan < 0.713375))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 35;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 215;
      }
      return %angle;
   }
   else if((%tan >= 0.713375)&&(%tan < 0.740048))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 36;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 216;
      }
      return %angle;
   }
   else if((%tan >= 0.740048)&&(%tan < 0.767420))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 37;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 217;
      }
      return %angle;
   }
   else if((%tan >= 0.767420)&&(%tan < 0.795535))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 38;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 218;
      }
      return %angle;
   }
   else if((%tan >= 0.795535)&&(%tan < 0.824442))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 39;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 219;
      }
      return %angle;
   }
   else if((%tan >= 0.824442)&&(%tan < 0.854193))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 40;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 220;
      }
      return %angle;
   }
   else
   {
      getVector3(%deltaX, %deltaY);
   }
}

function getVector3(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan >= 0.854193)&&(%tan < 0.884845))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 41;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 221;
      }
      return %angle;
   }
   else if((%tan >= 0.884845)&&(%tan < 0.916460))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 42;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 222;
      }
      return %angle;
   }
   else if((%tan >= 0.916460)&&(%tan < 0.949102))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 43;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 223;
      }
      return %angle;
   }
   else if((%tan >= 0.949102)&&(%tan < 0.982844))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 44;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 224;
      }
      return %angle;
   }
   else if((%tan >= 0.982844)&&(%tan < 1.017765))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 45;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 225;
      }
      return %angle;
   }
   else if((%tan >= 1.017765)&&(%tan < 1.053950))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 46;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 226;
      }
      return %angle;
   }
   else if((%tan >= 1.053950)&&(%tan < 1.091491))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {

         %angle = 47;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 227;
      }
      return %angle;
   }
   else if((%tan >= 1.091491)&&(%tan < 1.130490))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 48;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 228;
      }
      return %angle;
   }
   else if((%tan >= 1.130490)&&(%tan < 1.171061))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 49;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 229;
      }
      return %angle;
   }
   else if((%tan >= 1.171061)&&(%tan < 1.213325))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 50;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 230;
      }
      return %angle;
   }
   else if((%tan >= 1.213325)&&(%tan < 1.257419))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 51;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 231;
      }
      return %angle;
   }
   else if((%tan >= 1.257419)&&(%tan < 1.303493))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 52;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 232;
      }
      return %angle;
   }
   else if((%tan >= 1.303493)&&(%tan < 1.351713))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 53;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 233;
      }
      return %angle;
   }
   else if((%tan >= 1.351713)&&(%tan < 1.402265))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 54;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 234;
      }
      return %angle;
   }
   else if((%tan >= 1.402265)&&(%tan < 1.455354))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 55;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 235;
      }
      return %angle;
   }
   else if((%tan >= 1.455354)&&(%tan < 1.511213))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 56;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 236;
      }
      return %angle;
   }
   else if((%tan >= 1.511213)&&(%tan < 1.570100))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 57;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 237;
      }
      return %angle;
   }
   else if((%tan >= 1.570100)&&(%tan < 1.632307))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 58;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 238;
      }
      return %angle;
   }
   else if((%tan >= 1.632307)&&(%tan < 1.698165))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 59;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 239;
      }
      return %angle;
   }
   else if((%tan >= 1.698165)&&(%tan < 1.768049))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 60;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 240;
      }
      return %angle;
   }
   else
   {
      getVector4(%deltaX, %deltaY);
   }
}

function getVector4(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan >= 1.768049)&&(%tan < 1.842387))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 61;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 241;
      }
      return %angle;
   }
   else if((%tan >= 1.842387)&&(%tan < 1.921668))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 62;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 242;
      }
      return %angle;
   }
   else if((%tan >= 1.921668)&&(%tan < 2.006457))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 63;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 243;
      }
      return %angle;
   }
   else if((%tan >= 2.006457)&&(%tan < 2.097405))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 64;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 244;
      }
      return %angle;
   }
   else if((%tan >= 2.097405)&&(%tan < 2.195272))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 65;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 245;
      }
      return %angle;
   }
   else if((%tan >= 2.195272)&&(%tan < 2.300945))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 66;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 246;
      }
      return %angle;
   }
   else if((%tan >= 2.300945)&&(%tan < 2.415470))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 67;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 247;
      }
      return %angle;
   }
   else if((%tan >= 2.415470)&&(%tan < 2.540088))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 68;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 248;
      }
      return %angle;
   }
   else if((%tan >= 2.540088)&&(%tan < 2.676283))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 69;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 249;
      }
      return %angle;
   }
   else if((%tan >= 2.676283)&&(%tan < 2.825844))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 70;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 250;
      }
      return %angle;
   }
   else if((%tan >= 2.825844)&&(%tan < 2.990947))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 71;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 251;
      }
      return %angle;
   }
   else if((%tan >= 2.990947)&&(%tan < 3.174268))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 72;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 252;
      }
      return %angle;
   }
   else if((%tan >= 3.174268)&&(%tan < 3.379134))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 73;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 253;
      }
      return %angle;
   }
   else if((%tan >= 3.379134)&&(%tan < 3.609733))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 74;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 254;
      }
      return %angle;
   }
   else if((%tan >= 3.609733)&&(%tan < 3.871416))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 75;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 255;
      }
      return %angle;
   }
   else if((%tan >= 3.871416)&&(%tan < 4.171128))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 76;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 256;
      }
      return %angle;
   }
   else if((%tan >= 4.171128)&&(%tan < 4.518053))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 77;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 257;
      }
      return %angle;
   }
   else if((%tan >= 4.518053)&&(%tan < 4.924592))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 78;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 258;
      }
      return %angle;
   }
   else if((%tan >= 4.924592)&&(%tan < 5.407918))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 79;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 259;
      }
      return %angle;
   }
   else if((%tan >= 5.407918)&&(%tan < 5.992517))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 80;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 260;
      }
      return %angle;
   }
   else
   {
      getVector5(%deltaX, %deltaY);
   }
}

function getVector5(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan >= 5.992517)&&(%tan < 6.714561))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 81;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 261;
      }
      return %angle;
   }
   else if((%tan >= 6.714561)&&(%tan < 7.629858))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 82;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 262;
      }
      return %angle;
   }
   else if((%tan >= 7.629858)&&(%tan < 8.829355))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 83;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 263;
      }
      return %angle;
   }
   else if((%tan >= 8.829355)&&(%tan < 10.472208))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 84;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 264;
      }
      return %angle;
   }
   else if((%tan >= 10.472208)&&(%tan < 12.865359))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 85;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 265;
      }
      return %angle;
   }
   else if((%tan >= 12.865359)&&(%tan < 16.690901))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 86;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 266;
      }
      return %angle;
   }
   else if((%tan >= 16.690901)&&(%tan < 23.858695))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 87;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 267;
      }
      return %angle;
   }
   else if((%tan >= 23.858695)&&(%tan < 42.963107))
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 88;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 268;
      }
      return %angle;
   }
   else if(%tan >= 42.963107)
   {
      if((%deltaX > 0)&&(%deltaY > 0))
      {
         %angle = 89;
      }
      else if((%deltaX < 0)&&(%deltaY < 0))
      {
         %angle = 269;
      }
      return %angle;
   }
   else if(%deltaX == 0)
   {
      if(%deltaY > 0)
      {
         %angle = 90;
      }
      else if(%deltaY < 0)
      {
         %angle = 270;
      }
      return %angle;
   }
   else if(%tan < -42.963107)
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 91;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 271;
      }
      return %angle;
   }
   else if((%tan < -23.858695)&&(%tan >= -42.963107))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 92;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 272;
      }
      return %angle;
   }
   else if((%tan < -16.690901)&&(%tan >= -23.858695))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 93;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 273;
      }
      return %angle;
   }
   else if((%tan < -12.865359)&&(%tan >= -16.690901))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 94;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 274;
      }
      return %angle;
   }
   else if((%tan < -10.472208)&&(%tan >= -12.865359))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 95;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 275;
      }
      return %angle;
   }
   else if((%tan < -8.829355)&&(%tan >= -10.472208))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 96;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 276;
      }
      return %angle;
   }
   else if((%tan < -7.629858)&&(%tan >= -8.829355))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 97;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 277;
      }
      return %angle;
   }
   else if((%tan < -6.714561)&&(%tan >= -7.629858))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 98;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 278;
      }
      return %angle;
   }
   else if((%tan < -5.992517)&&(%tan >= -6.714561))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 99;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 279;
      }
      return %angle;
   }
   else if((%tan < -5.407918)&&(%tan >= -5.992517))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 100;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 280;
      }
      return %angle;
   }
   else
   {
      getVector6(%deltaX, %deltaY);
   }
}

function getVector6(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan < -4.924592)&&(%tan >= -5.407918))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 101;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 281;
      }
      return %angle;
   }
   else if((%tan < -4.518053)&&(%tan >= -4.924592))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 102;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 282;
      }
      return %angle;
   }
   else if((%tan < -4.171128)&&(%tan >= -4.518053))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 103;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 283;
      }
      return %angle;
   }
   else if((%tan < -3.871416)&&(%tan >= -4.171128))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 104;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 284;
      }
      return %angle;
   }
   else if((%tan < -3.609733)&&(%tan >= -3.871416))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 105;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 285;
      }
      return %angle;
   }
   else if((%tan < -3.379134)&&(%tan >= -3.609733))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 106;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 286;
      }
      return %angle;
   }
   else if((%tan < -3.174268)&&(%tan >= -3.379134))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 107;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 287;
      }
      return %angle;
   }
   else if((%tan < -2.990947)&&(%tan >= -3.174268))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 108;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 288;
      }
      return %angle;
   }
   else if((%tan < -2.825844)&&(%tan >= -2.990947))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 109;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 289;
      }
      return %angle;
   }
   else if((%tan < -2.676283)&&(%tan >= -2.825844))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 110;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 290;
      }
      return %angle;
   }
   else if((%tan < -2.540088)&&(%tan >= -2.676283))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 111;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 291;
      }
      return %angle;
   }
   else if((%tan < -2.415470)&&(%tan >= -2.540088))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 112;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 292;
      }
      return %angle;
   }
   else if((%tan < -2.300945)&&(%tan >= -2.415470))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 113;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 293;
      }
      return %angle;
   }
   else if((%tan < -2.195272)&&(%tan >= -2.300945))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 114;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 294;
      }
      return %angle;
   }
   else if((%tan < -2.097405)&&(%tan >= -2.195272))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 115;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 295;
      }
      return %angle;
   }
   else if((%tan < -2.006457)&&(%tan >= -2.097405))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 116;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 296;
      }
      return %angle;
   }
   else if((%tan < -1.921668)&&(%tan >= -2.006457))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 117;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 297;
      }
      return %angle;
   }
   else if((%tan < -1.842387)&&(%tan >= -1.921668))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 118;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 298;
      }
      return %angle;
   }
   else if((%tan < -1.768049)&&(%tan >= -1.842387))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 119;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 299;
      }
      return %angle;
   }
   else if((%tan < -1.698165)&&(%tan >= -1.768049))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 120;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 300;
      }
      return %angle;
   }
   else
   {
      getVector7(%deltaX, %deltaY);
   }
}

function getVector7(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan < -1.632307)&&(%tan >= -1.698165))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 121;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 301;
      }
      return %angle;
   }
   else if((%tan < -1.570100)&&(%tan >= -1.632307))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 122;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 302;
      }
      return %angle;
   }
   else if((%tan < -1.511213)&&(%tan >= -1.570100))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 123;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 303;
      }
      return %angle;
   }
   else if((%tan < -1.455354)&&(%tan >= -1.511213))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 124;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 304;
      }
      return %angle;
   }
   else if((%tan < -1.402265)&&(%tan >= -1.455354))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 125;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 305;
      }
      return %angle;
   }
   else if((%tan < -1.351713)&&(%tan >= -1.402265))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 126;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 306;
      }
      return %angle;
   }
   else if((%tan < -1.303493)&&(%tan >= -1.351713))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 127;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 307;
      }
      return %angle;
   }
   else if((%tan < -1.257419)&&(%tan >= -1.303493))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 128;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 308;
      }
      return %angle;
   }
   else if((%tan < -1.213325)&&(%tan >= -1.257419))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 129;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 309;
      }
      return %angle;
   }
   else if((%tan < -1.171061)&&(%tan >= -1.213325))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 130;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 310;
      }
      return %angle;
   }
   else if((%tan < -1.130490)&&(%tan >= -1.171061))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 131;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 311;
      }
      return %angle;
   }
   else if((%tan < -1.091491)&&(%tan >= -1.130490))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 132;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 312;
      }
      return %angle;
   }
   else if((%tan < -1.053950)&&(%tan >= -1.091491))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 133;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 313;
      }
      return %angle;
   }
   else if((%tan < -1.017765)&&(%tan >= -1.053950))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 134;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 314;
      }
      return %angle;
   }
   else if((%tan < -0.982844)&&(%tan >= -1.017765))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 135;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 315;
      }
      return %angle;
   }
   else if((%tan < -0.949102)&&(%tan >= -0.982844))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 136;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 316;
      }
      return %angle;
   }
   else if((%tan < -0.916460)&&(%tan >= -0.949102))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 137;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 317;
      }
      return %angle;
   }
   else if((%tan < -0.884845)&&(%tan >= -0.916460))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 138;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 318;
      }
      return %angle;
   }
   else if((%tan < -0.854193)&&(%tan >= -0.884845))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 139;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 319;
      }
      return %angle;
   }
   else if((%tan < -0.824442)&&(%tan >= -0.854193))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 140;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 320;
      }
      return %angle;
   }
   else
   {
      getVector8(%deltaX, %deltaY);
   }
}

function getVector8(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan < -0.795535)&&(%tan >= -0.824442))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 141;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 321;
      }
      return %angle;
   }
   else if((%tan < -0.767420)&&(%tan >= -0.795535))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 142;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 322;
      }
      return %angle;
   }
   else if((%tan < -0.740048)&&(%tan >= -0.767420))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 143;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 323;
      }
      return %angle;
   }
   else if((%tan < -0.713375)&&(%tan >= -0.740048))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 144;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 324;
      }
      return %angle;
   }
   else if((%tan < -0.687358)&&(%tan >= -0.713375))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 145;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 325;
      }
      return %angle;
   }
   else if((%tan < -0.661958)&&(%tan >= -0.687358))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 146;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 326;
      }
      return %angle;
   }
   else if((%tan < -0.637138)&&(%tan >= -0.661958))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 147;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 327;
      }
      return %angle;
   }
   else if((%tan < -0.612865)&&(%tan >= -0.637138))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 148;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 328;
      }
      return %angle;
   }
   else if((%tan < -0.589105)&&(%tan >= -0.612865))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 149;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 329;
      }
      return %angle;
   }
   else if((%tan < -0.565830)&&(%tan >= -0.589105))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 150;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 330;
      }
      return %angle;
   }
   else if((%tan < -0.543009)&&(%tan >= -0.565830))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 151;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 331;
      }
      return %angle;
   }
   else if((%tan < -0.520617)&&(%tan >= -0.543009))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 152;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 332;
      }
      return %angle;
   }
   else if((%tan < -0.498629)&&(%tan >= -0.520617))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 153;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 333;
      }
      return %angle;
   }
   else if((%tan < -0.477020)&&(%tan >= -0.498629))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 154;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 334;
      }
      return %angle;
   }
   else if((%tan < -0.455768)&&(%tan >= -0.477020))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 155;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 335;
      }
      return %angle;
   }
   else if((%tan < -0.434852)&&(%tan >= -0.455768))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 156;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 336;
      }
      return %angle;
   }
   else if((%tan < -0.414251)&&(%tan >= -0.434852))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 157;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 337;
      }
      return %angle;
   }
   else if((%tan < -0.393945)&&(%tan >= -0.414251))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 158;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 338;
      }
      return %angle;
   }
   else if((%tan < -0.373917)&&(%tan >= -0.393945))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 159;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 339;
      }
      return %angle;
   }
   else if((%tan < -0.354149)&&(%tan >= -0.373917))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 160;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 340;
      }
      return %angle;
   }
   else
   {
      getVector9(%deltaX, %deltaY);
   }
}

function getVector9(%deltaX, %deltaY)
{
   %tan = (%deltaY / %deltaX);
   if((%tan < -0.334624)&&(%tan >= -0.354149))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 161;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 341;
      }
      return %angle;
   }
   else if((%tan < -0.315325)&&(%tan >= -0.334624))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 162;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 342;
      }
      return %angle;
   }
   else if((%tan < -0.296238)&&(%tan >= -0.315325))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 163;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 343;
      }
      return %angle;
   }
   else if((%tan < -0.277347)&&(%tan >= -0.296238))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 164;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 344;
      }
      return %angle;
   }
   else if((%tan < -0.258639)&&(%tan >= -0.277347))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 165;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 345;
      }
      return %angle;
   }
   else if((%tan < -0.240098)&&(%tan >= -0.258639))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 166;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 346;
      }
      return %angle;
   }
   else if((%tan < -0.221712)&&(%tan >= -0.240098))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 167;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 347;
      }
      return %angle;
   }
   else if((%tan < -0.203468)&&(%tan >= -0.221712))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 168;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 348;
      }
      return %angle;
   }
   else if((%tan < -0.185354)&&(%tan >= -0.203468))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 169;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 349;
      }
      return %angle;
   }
   else if((%tan < -0.167356)&&(%tan >= -0.185354))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 170;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 350;
      }
      return %angle;
   }
   else if((%tan < -0.149463)&&(%tan >= -0.167356))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 171;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 351;
      }
      return %angle;
   }
   else if((%tan < -0.131663)&&(%tan >= -0.149463))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 172;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 352;
      }
      return %angle;
   }
   else if((%tan < -0.113944)&&(%tan >= -0.131663))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 173;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 353;
      }
      return %angle;
   }
   else if((%tan < -0.096296)&&(%tan >= -0.113944))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 174;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 354;
      }
      return %angle;
   }
   else if((%tan < -0.078708)&&(%tan >= -0.096296))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 175;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 355;
      }
      return %angle;
   }
   else if((%tan < -0.061167)&&(%tan >= -0.078708))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 176;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 356;
      }
      return %angle;
   }
   else if((%tan < -0.043664)&&(%tan >= -0.061167))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 177;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 357;
      }
      return %angle;
   }
   else if((%tan < -0.026188)&&(%tan >= -0.043664))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 178;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 358;
      }
      return %angle;
   }
   else if((%tan < -0.008728)&&(%tan >= -0.026188))
   {
      if((%deltaX < 0)&&(%deltaY > 0))
      {
         %angle = 179;
      }
      else if((%deltaX > 0)&&(%deltaY < 0))
      {
         %angle = 359;
      }
      return %angle;
   }
}