// FILENAME:	CTF_Double_Blade.cs
//
// AUTHOR:  	Gen. Stormtrooper [M.I.B.]
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetect = true;    //Set to false to turn off stealth detection

//------------------------------------------------------------------------------
$missionName = "CTF_Double_Blade";

// CTF stuff
$maxFlagCount  = 8;           // no of flags required by a team to end the game
$flagValue     = 5;          // points your team gets for capturing
$carrierValue  = 2;          //  "      "    "    "    " killing carrier
$killPoints    = 1;
$deathPoints   = 1;
$flagTime = 180;             // 4 minute timer

exec("multiplayerStdLib.cs");
exec("CTFstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
     mercurySounds();
     initGlobalVars();
     $bluetarget = getObjectId("MissionGroup\\bluem");
     $redtarget = getObjectId("MissionGroup\\redm");
}

function onMissionLoad()
{
   cdAudioCycle("Cyberntx", "Cloudburst", "Terror","Mechsoul"); 
}

function player::onAdd(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game");
   }
   say(%player, 0, "Welcome to CTF Double Blade! You can download CTF_Double_Blade & other missions made by Gen. Stormtrooper [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function vehicle::onAdd(%guy)
{
   setVehicleRadarVisible(%guy, false);
   vehicle.spotted = false;
   deleteObject(%guy.marker);
}

function player::onRemove(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game");
   }
}

function copyObject(%object, %name)
{
   storeObject(%object, "copyObject.tmp");
   if(%name == "")
   {
      %copy = loadObject(getObjectName(%object), "copyObject.tmp");
   }
   else
   {
      %copy = loadObject(%name, "copyObject.tmp");
   }
   return %copy;
}

function track(%vehicleid)
{
   %x = getPosition(%vehicleid, x);
   %y = getPosition(%vehicleid, y);
   %z = getPosition(%vehicleid, z);
   setPosition(%vehicleid.marker, %x, %y, %z);

	if(%vehicle.spotted==true)
	{
   		schedule("track("@%vehicleid@");", 0.1 );
	}
}

function vehicle::onSpot(%spotter, %target)
{
   %player = playermanager::vehicleIdtoPlayerNum(%spotter);
   if(%target!="")
   {
	checknspot(%target);
      say(%player,%player,"<f4>You have painted "@getHudName(%target)@" as a target for your team.");
   }
   else
   {
	$target.spotted = false;
      say(%player,%player,"<f4>Target lost. Your target is no longer painted.");
      deleteObject(%target.marker);
   }
}

function vehicle::onDestroyed(%this, %destroyer)
{
   %this.spotted = false;
   deleteObject(%this.marker);
   
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }
}

function checknspot(%target)
{
   %target.spotted = true;

      if(getTeam(%target)=="Purple Team")
	{
	   %target.marker = copyObject($redtarget, pmarker);
	}

      if(getTeam(%target)=="Blue Team")
	{
	   %target.marker = copyObject($bluetarget, bmarker);
	}

   track(%target);
}